unit About;

interface

{$R About.RES}

uses WinProcs, WinTypes, Objects, OWindows, ODialogs;

const
 idShade=100;
 idBump=101;
 idHotKey=103;

type PPCharArray=^TPCharArray;
     TPCharArray=array [0..65520 div sizeof(PChar)] of PChar;

     PCreditWindow=^TCreditWindow;
     TCreditWindow=object(TWindow)
                    BitMap:HBitMap;
                    BitSize:TBitMap;
                    ScrollUnit:integer;
                    ScrollRate:integer;
                    ScrollPos:integer;
                    FontHeigth:integer;
                    StringList:PPCharArray;
                    StringCount:word;
                    constructor Init(AParent:PWindowsObject;
                                     ABitMapName:PChar;
                                     const AStringList:array of PChar);
                    destructor Done; virtual;
                    function GetClassName: PChar; virtual;
                    procedure GetWindowClass(var WC: TWndClass); virtual;
                    procedure SetupWindow; virtual;
                    procedure WMDestroy(var Msg: TMessage); virtual wm_First+wm_Destroy;
                    procedure Paint(DC: HDC; var PS: TPaintStruct); virtual;
                    procedure ShowCredits; virtual;
                    procedure WMTImer(var Msg: TMessage); virtual wm_First+wm_Timer;
                   end;

     PAboutBox=^TAboutBox;
     TAboutBox=object(TDialog)
                Title:PChar;
                CreditWindow:PCreditWindow;
                constructor Init(AParent:PWindowsObject;
                                 ATitle, ABitMapName:PChar;
                                 const AStringList:array of PChar);
                destructor Done; virtual;
                procedure SetupWindow; virtual;
                function GetResName:PChar; virtual;
                procedure InitCreditWindow(ABitMapName:PChar;
                                           const AStringList:array of PChar); virtual;
                procedure ShowCredits(var Msg:TMessage); virtual id_First+idHotKey;
               end;

 implementation

 uses Strings;

 constructor TCreditWindow.Init(AParent:PWindowsObject;
                                ABitMapName:Pchar;
                                const AStringList:array of PChar);
  var DC:HDC;
      OldFont:HFont;
      TM:TTextMetric;

  begin
   inherited Init(AParent,nil);
   Attr.Style:=ws_Child or ws_Visible;
   BitMap:=LoadBitMap(HInstance, ABitMapName);
   if BitMap=0 then
    begin
     Status:=em_InvalidWindow;
     exit;
    end;
   GetObject(BitMap,sizeof(BitSize),@BitSize);
   ScrollPos:=0;
   DC:=GetDC(0);
   ScrollUnit:=2;
   ScrollRate:=80;
   OldFont:=SelectObject(DC,GetStockObject(ANSI_VAR_FONT));
   GetTextMetrics(DC,TM);
   FontHeigth:=TM.tmHeight+TM.tmExternalLeading+5;
   SelectObject(DC,OldFont);
   ReleaseDC(0,DC);
   StringList:=@AStringList;
   StringCount:=High(AStringList)+1;
  end;

 destructor TCreditWindow.Done;
  begin
   inherited Done;
   DeleteObject(BitMap);
  end;

 function TCreditWindow.GetClassName:PChar;
  begin
   GetClassName:='OWLAboutBitMap';
  end;

 procedure TCreditWindow.GetWindowClass(var WC:TWndClass);
  begin
   inherited GetWindowClass(WC);
   WC.Style:=cs_ByteAlignWindow;
   WC.hbrBackGround:=GetStockObject(Black_Brush);
  end;

 procedure TCreditWindow.SetupWindow;
  begin
   inherited SetupWindow;
   SetWindowPos(HWindow,0,0,0,BitSize.bmWidth,BitSize.bmHeight,
                swp_NoMove or swp_NoZOrder or swp_NoActivate or swp_NoRedraw);
  end;

 procedure TCreditWindow.WMDestroy(var Msg:TMessage);
  begin
   if ScrollPos<>0 then
    begin
     KillTimer(HWindow,1);
     ScrollPos:=0;
    end;
   inherited WMDestroy(Msg);
  end;

 procedure TCreditWindow.Paint(DC:HDC; var PS:TPaintStruct);
  var R:TRect;
      FirstLine, LastLine, Y:integer;

  procedure DrawBitMap(Y:integer);
   var MemDC:HDC;
       OldBits:HBitMap;
   begin
    MemDC:=CreateCompatibleDC(DC);
    OldBits:=SelectObject(MemDC,BitMap);
    BitBlt(DC,0,Y,Attr.W,Attr.H,MemDC,0,0,srcCopy);
    SelectObject(MemDC,OldBits);
    DeleteDC(MemDC);
   end;

  begin
   SaveDC(DC);
   SetViewportOrg(Dc, 0, -ScrollPos);
   OffsetRect(PS.rcPaint,0,ScrollPos);
   with R do
    begin
     Left:=0;
     Top:=0;
     Right:=Attr.W;
     Bottom:=Attr.H;
    end;
   if Bool(InterSectRect(R,PS.rcPaint,R)) then
    begin
     DrawBitMap(0);
     with PS.rcPaint do
      begin
       if (R.Top<Top)and(R.Bottom>Top) then Top:=R.Bottom;
       if (R.Top<Bottom)and(R.Bottom>Bottom) then Bottom:=R.Top;
       if Top>Bottom then Top:=Bottom;
      end;
    end;
   if ScrollPos>0 then
    begin
     FirstLine:=(PS.rcPaint.Top-Attr.H) div FontHeigth;
     if FirstLine<0 then FirstLine:=0;
     if FirstLine<StringCount then
      begin
       SetTextAlign(DC,TA_Center);
       SetBkColor(DC,0);
       SetTextColor(DC,rgb($FF,$FF,$FF));
       LastLine:=(PS.rcPaint.Bottom-Attr.H) div FontHeigth;
       for Y:=FirstLine to LastLine do
        if Y<StringCount then
         TextOut(DC,Attr.W div 2, Y*FontHeigth+Attr.H,StringList^[Y],StrLen(StringList^[Y]));
      end;
     if PS.rcPaint.Bottom>(Attr.H+FontHeigth*StringCount) then
      DrawBitMap(Attr.H+FontHeigth*StringCount);
    end;
   restoreDC(DC,-1);
  end;

 procedure TCreditWindow.ShowCredits;
  begin
   SetTimer(HWindow,1,ScrollRate,nil);
  end;

 procedure TCreditWindow.WMTimer(var Msg:TMessage);
  begin
   inc(ScrollPos,ScrollUnit);
   if ScrollPos>Attr.H+FontHeigth*StringCount then
    begin
     ScrollPos:=0;
     KillTimer(HWindow,1);
     InvalidateRect(HWindow,nil,false);
    end                                        else
     ScrollWindow(HWindow,0,-ScrollUnit,nil,nil);
   UpdateWindow(HWindow);
  end;

 constructor TAboutBox.Init(AParent:PWindowsObject;
                           ATitle, ABitMapName:PChar;
                           const AStringList:array of PChar);
  begin
   inherited Init(AParent,GetResName);
   Title:=StrNew(ATitle);
   InitCreditWindow(ABitMapName, AStringList);
  end;

 destructor TAboutBox.Done;
  begin
   inherited Done;
   if Title<>nil then StrDispose(Title);
  end;

 procedure TAboutBox.SetupWindow;
  var
   RDialog,R,RBitWnd,RShade,RBump,ROk:TRect;
   X8,Y8:integer;
   DC:HDC;
  begin
   inherited SetupWindow;
   SetWindowText(HWindow,Title);
   DC:=GetDC(HWindow);
   X8:=GetDeviceCaps(DC,LogPixelsX) div 8;
   Y8:=GetDeviceCaps(DC,LogPixelsY) div 8;
   ReleaseDC(HWindow, DC);
   GetClientRect(GetDlgItem(HWindow,idShade),RShade);
   GetClientRect(GetDlgItem(HWindow,idBump),RBump);
   GetClientRect(GetDlgItem(HWindow,idOk),ROk);
   GetClientRect(CreditWindow^.HWindow,RBitWnd);
   RShade.Top:=Y8;
   RShade.Left:=X8;
 {  if RShade.Right<RBitWnd.Right+2*X8 then}
    RShade.Right:=RBitWnd.Right+2*X8;
   if RShade.Bottom<RBitWnd.Bottom+2*Y8 then
    RShade.Bottom:=RBitWnd.Bottom+2*Y8;

   with RDialog do
    begin
     GetWindowRect(HWindow,RDialog);
     GetClientRect(HWindow,R);
     Right:=Right-Left-R.Right;
     Bottom:=Bottom-Top-R.Bottom;
     Right:=Right+X8+RShade.Right+X8;
     Bottom:=Bottom+Y8+RShade.Bottom+Y8+RBump.Bottom+
             Y8+ROk.Bottom+Y8;
     if Parent<>nil then
      begin
       GetWindowRect(Parent^.HWindow,R);
       Left:=R.Left+(R.Right-R.Left) div 2 - Right div 2;
       Top:=R.Top+(R.Bottom-R.Top) div 2 - Bottom div 2;
      end;
     SetWindowPos(HWindow,0,Left,Top,Right,Bottom,swp_NOActivate or swp_NoZOrder);
    end;
   with RShade do
    begin
     SetWindowPos(GetDlgItem(HWindow,idShade),0,Left,Top,
                  Right,Bottom,swp_NoActivate or swp_NoZOrder);
     SetWindowPos(CreditWindow^.HWindow,0,Left+X8,Top+Y8,
                  0,0,swp_NoActivate or swp_NoSize or swp_NoZOrder);
    end;
   with RBump do
    begin
     Left:=-1;
     Right:=RDialog.Right+2;
     Top:=RShade.Top+RShade.Bottom+Y8;
     SetWindowPos(GetDlgItem(HWindow,idBump),0,Left,
      Top,Right,Bottom,
      swp_NoActivate or swp_NoSize or swp_NoZOrder);
    end;
   GetClientRect(HWindow,R);
   with ROk do
    begin
     SetWindowPos(GetDlgItem(HWindow,IdOk),0,
      R.Right div 2 - Right div 2,
      RBump.Top+RBump.Bottom+Y8,0,0,
      swp_NoActivate or swp_Nosize or swp_NoZOrder);
    end;
  end;

 function TAboutBox.GetResName:PChar;
  begin
   GetResName:='dlgAbout';
  end;

 procedure TAboutBox.InitCreditWindow(ABitMapName:Pchar;
                                      const AStringList:array of PChar);
  begin
   CreditWindow:=New(PCreditWindow, Init(@Self, ABitMapName, AStringList));
  end;

 procedure TAboutBox.ShowCredits(var Msg:TMessage);
  begin
   CreditWindow^.ShowCredits;
  end;

end.