program EmScript;

{$undef DEBUG}

{ Softwarov emulace postscriptu }
{    Hlavn okno aplikace        }
{    Tom Mayer     1995        }

uses OWindows, WinTypes, WinProcs, Win31, Strings, ODialogs, OStdDlgs,
     Objects, MMSystem, OMemory, OStdWnds,
     Hodnoty, GlobInf, Lexikal, Slovniky, Zasobnik, Konverze, About,
     ObjKomp, Grafika, Chyby, Device, Fonty, ToolBar, MFileC, Bwcc;

{$R EmScript.RES}
{$R ToolLib.RES}

{ ********************************************************* }
{ ---                    Kosntanty                      --- }
{ ********************************************************* }

const cm_About         = 101;
      cm_Help          = 102;
      cm_Open          = 201;
      cm_Zasobnik      = 301;
      cm_BehZasobnik   = 302;
      cm_VirtualMemory = 303;
      cm_GraphPath     = 304;
      cm_ClipPath      = 305;
      cm_Output        = 306;
      cm_Preview       = 307;
      cm_Beh           = 401;
      cm_Debug         = 402;
      cm_ResetSystem   = 403;
      cm_Operace       = 410;
      cm_Print         = 501;

      wm_speedbar=$0400;


      CreditText:array [1..7] of PChar=(
      '',
      '',
      '',
      '',
      '',
      '',
      '');

var PomChar:array [0..255] of char; { retezcovy buffer pro prenos stringu z resource souboru }


{ ********************************************************* }
{ ---                 Definice masek pol               --- }
{ ********************************************************* }


type  PProcBox=^TProcBox;
      TProcBox=array [0..500] of TPolZas; { Polozka longint(PPRocBox^[0].Uk) urcuje jak je pole operandu opravdu velike }

const Win31LockWindowUpdate: function (Wnd: HWnd): Bool = nil;

type TSystemState = record
		     Zasobnik:PZasobnik;
		     BehZasobnik:PBehZasobnik;
		     SlovZas:PSlovZas;
		     VMem:PVirtMemory;
		    end;

{ ********************************************************* }
{ ---                 Defince okna                      --- }
{ ********************************************************* }

type PMessageWindow=^TMessageWindow;
     TMessageWindow=object(TWindow)
		     Kresli:boolean; { povoli vykreseleni okna az po precteni prvni instrukce}
		     Atom:PChar;
		     TypW:word;
		     procedure Paint(DC:HDC;var PS:TPaintStruct); virtual;
		    end;

     procedure TMessageWindow.Paint(DC:HDC; var PS: TPaintStruct);
      var D:array [0..3] of char;
	  S:array [0..255] of char;
	  PaintDC:HDC;
      begin
       if Kresli then
	begin
	 WVSPrintF(D,'%d',TypW);
	 WVSPrintF(S,'%s',Atom);
	 TextOut(DC,20,80,S,strlen(S));
	 TextOut(DC,20,120,D,strlen(D));
	end;
      end;



type PHlavniOkno = ^THlavniOkno;
     THlavniOkno = object(TMDIWindow)
		    Atom:PChar;
		    DragDC:HDC;
		    ToolBar:PToolBar;
		    FOtevren:boolean;
		    OutDevice:POutputDevice;
		    WindowOfStack:PWinZas;
		    WindowOfProcStack:PWinBehZas;
		    WindowOfVirtualMemory:PWinVMem;
		    WindowOfGraphPath:PWinGraphPath;
                        WindowOfClipPath:PWinCLipPath;
		    WindowOfOutput:PWinPaint;
                        WindowOfPreview:PWinPreview;
		    OutputBitmapDC:HDC;
		    OutPutBitmap:HBitmap;
		    Zasobnik:PZasobnik;   { operand stack }
		    PolBehZas:TPolBehZas; { kontrolka pro prubeh definice procedury }
		    BehZasobnik:PBehZasobnik; { executive stack }
		    SlovZas:PSlovZas;       { dictionary stack }
		    GraphStack:PGraphStack; { graphics stack }
		    VMem:PVirtMemory;       { virtual memory }

		    Input:TMemDescr;
		    GraphState:TMemDescr;
		    BreakDebug:boolean;

		    FontTemp:TMemDescr; { Docasny prvek urceny pro testovani fontu }

		    FileName:array [0..255] of char;
		    constructor Init(ATitle:PChar; Menu:HMenu);
		    destructor Done; virtual;
                        procedure ResetSys;
		    procedure SetupWindow; virtual;
		    procedure SaveState(var SystemState:TSystemState);
		    procedure RestoreState(SystemState:TSystemState);
		    procedure DisposeState(SystemState:TSystemState);
		    procedure DefVM(AVMemory:PVirtMemory);
		    procedure RedoClientRect;
		    procedure HorizontalToolbar(var Msg: TMessage);
		      virtual cm_First + cm_HorizontalToolbar;
		    procedure RightVerticalToolbar(var Msg: TMessage);
		      virtual cm_First + cm_RightVerticalToolbar;
		    procedure LeftVerticalToolbar(var Msg: TMessage);
		      virtual cm_First + cm_LeftVerticalToolbar;
		    procedure WMSize(var Msg: TMessage);
		      virtual wm_First + wm_Size;
		    procedure GetWindowClass(var aWndClass: TWndClass); virtual;
		    function GetClassName: PChar; virtual;
		    procedure CMOpen(var Msg:TMessage); virtual CM_FIRST+CM_OPEN;
		    procedure CMAbout(var Msg:TMessage); virtual CM_FIRST+CM_ABOUT;
                        procedure CMHelp(var Msg:TMessage); virtual CM_FIRST+CM_HELP;
		    procedure CMZasobnik(var Msg:TMessage); virtual cm_First+cm_Zasobnik;
		    procedure CMBehZasobnik(var Msg:TMessage); virtual cm_First+cm_BehZasobnik;
		    procedure CMVirtualMemory(var Msg:TMessage); virtual cm_First+cm_VirtualMemory;
		    procedure CMGraphPath(var Msg:TMessage); virtual cm_First+cm_GraphPath;
                        procedure CMClipPath(var Msg:TMessage); virtual cm_First+cm_ClipPath;
                        procedure CMOutput(var Msg:TMessage); virtual CM_FIRST+CM_OUTPUT;
                        procedure CMPreview(var Msg:TMessage); virtual CM_FIRST+CM_PREVIEW;
		    procedure CMBeh(var Msg:TMessage); virtual cm_First+cm_Beh;
		    procedure CMDebug(var Msg:TMessage); virtual cm_First+cm_Debug;
		    procedure CMOperace(var Msg:TMessage); virtual cm_First+cm_Operace;
		    procedure CMVMCopy(var Msg:TMessage); virtual cm_First+676;
                        procedure CMPrint(var Msg:TMessage); virtual cm_First+CM_PRINT;
                        procedure CMResetSystem(var Msg:TMessage); virtual cm_First+CM_RESETSYSTEM;
		    procedure WMWinClosed(var Msg:TMessage); virtual wm_User+wm_WinCLosed;
		    function VykonBlok(Cislo:word):bool;
		    procedure ZpracovaniChyby(Where:PChar;Error:byte);
		    procedure SpeedBar(var Message:TMessage); virtual wm_First+wm_SpeedBar;
                        procedure GetGraphState(var Msg:TMessage); virtual GI_GRAPHSTATE;
                        procedure GetGraphPath(var Msg:TMessage); virtual GI_GRAPHPATH;
                        procedure GetClipPath(var Msg:TMessage); virtual GI_CLIPPATH;
		   end;

     constructor THlavniOkno.Init(ATitle:Pchar; Menu:HMenu);
      var GrSt:PGraphState;
      begin
       FOtevren:=false;
       inherited Init(ATitle,Menu);
       VMem:=new(PVirtMemory,Init);
       Zasobnik:=new(PZasobnik,Init(VMem));
       PolBehZas.Typ:=0;   { v recordu nen zznam }
       BehZasobnik:=new(PBehZasobnik,Init(VMem));
       SlovZas:=new(PSlovZas,Init(VMem));
       GraphStack:=new(PGraphStack,Init(VMem));
       OutDevice:=new(POutPutDevice,Init);
       SlovnikovyZasobnik:=SlovZas;
       strcopy(FileName,'*.PS');
       with Attr do Style:=Style or ws_ClipChildren;
       Grst:=new(PGraphState,Init(VMem));
       VMem^.Alloc(GrSt,GraphState);
       VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.Path);
       VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.ClipPath);

       VMem^.Alloc(new(PMatrix,Init(VMem)),GrSt^.CTM);
       VMem^.Inc(Graphstate);
       VMem^.Inc(GrSt^.Path);
       VMem^.Inc(GrSt^.ClipPath);
       VMem^.Inc(GrSt^.CTM);
       OutDevice^.SetCTMMatrix(PMatrix(VMem^.GetPointer(GrSt^.CTM)));

       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertMove(0,0);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,0);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,792);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(0,792);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertClosePath;

       Input:=NULL;
       WindowOfStack:=nil;
       WindowOfProcStack:=nil;
       WindowOfVirtualMemory:=nil;
       WindowOfGraphPath:=nil;
       WindowOfClipPath:=nil;
       ToolBar:=new(PToolBar,Init(@Self, 'ToolBar_1', tbHorizontal));
{       MessageWindow:=new(PMessageWindow,Init(@Self,'Messages'));}
{       MessageWindow^.Kresli:=false;}
       BreakDebug:=false;

       ChildMenuPos:=4;
      end;

     destructor THlavniOkno.Done;
      begin
       Dispose(Zasobnik,Done);
       Dispose(BehZasobnik,Done);
       Dispose(SlovZas,Done);
       Dispose(GraphStack,DOne);
       Dispose(ToolBar,Done);
       Dispose(VMem,Done);
       inherited Done;
      end;


     procedure THlavniOkno.ResetSys;  { Reset interpret to default state }
      var GrSt:PGraphState;
          F:PEditFile;
          NewVM:PVirtMemory;
          DgDc:HDC;
      begin
       DeleteDc(OutputBitmap);
       DeleteObject(OutputBitmap);
{ Create new virtual memory pool }
       NewVM:=new(PVirtMemory,Init);  { New virtual memory pool }
{ Input file reset }
       if Input<>NULL then
        begin
         F:=PEditFile(PFIle(VMem^.GetPointer(Input))^.Copy(NewVM));
         NewVM^.Alloc(F,Input); { Copy an input file object to the new virtual memory }
         if F^.EdF=cmd_EditFile then
          begin
           with F^ do
            begin
             Konec:=false;
             FirstF8:=true;
             Line:=0;
             IsNewLine:=false;
             FOtevren:=true;
            end;
          end;
         end;
{ Operand stack reset }
       Zasobnik^.AktPoz:=0;
       Zasobnik^.VMem:=NewVM;
       if WindowOfStack<>nil then WindowOfStack^.Seznam(NewVM);
{ Executable stack reset }
       BehZasobnik^.AktPoz:=0;
       BehZasobnik^.VMem:=NewVM;
       if WindowOfProcStack<>nil then WindowOfPRocStack^.Seznam(NewVM);
       PolBehZas.Typ:=0;   { v recordu nen zznam }
{ Close the old virtual memory pool }
       if WindowOfVirtualMemory<>nil then SendMessage(WindowOfVirtualMemory^.HWindow,WM_CLOSE,0,0);
       Dispose(VMem,Done);
       Dispose(SlovZas,Done);
       Dispose(GraphStack,Done);
       Dispose(OutDevice,Done);
       VMem:=NewVM;
       SlovZas:=new(PSlovZas,Init(VMem));
       GraphStack:=new(PGraphStack,Init(VMem));
       OutDevice:=new(POutPutDevice,Init);
       SlovnikovyZasobnik:=SlovZas;
       with Attr do Style:=Style or ws_ClipChildren;
       Grst:=new(PGraphState,Init(VMem));

       VMem^.Alloc(GrSt,GraphState);
       VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.Path);
       VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.ClipPath);
       VMem^.Alloc(new(PMatrix,Init(VMem)),GrSt^.CTM);
       VMem^.Inc(Graphstate);
       VMem^.Inc(GrSt^.Path);
       VMem^.Inc(GrSt^.ClipPath);
       VMem^.Inc(GrSt^.CTM);
       OutDevice^.SetCTMMatrix(PMatrix(VMem^.GetPointer(GrSt^.CTM)));

       { Init clip path to the whole area of the graph page }
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertMove(0,0);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,0);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,792);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(0,792);
       PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertClosePath;
{ From SetupWindow routine }
	 DgDC:=GetDC(HWindow);
	 OutputBitmapDC:=CreateCompatibleDC(DgDC);
	 OutputBitmap:=CreateCompatibleBitmap(DgDC,576,792);
	 if WindowOfOUtput<>nil then WindowOfOutput^.BitmapDC:=OutputBitmapDC;
           if WindowOfPreview<>nil then WindowOfPReview^.BitmapDC:=OutputBitmapDC;
	 VMem^.Alloc(new(PFont,Init(VMem,OutputBitmapDC,'Arial')),FontTemp);
	 GrSt^.Font:=FontTemp;
	 inclife(VMem,ct_Font,GrSt^.Font);
	 SelectObject(OutputBitmapDc,OutputBitmap);
	 BitBlt(OutputBitmapDc,0,0,576,792,DgDc,0,0,WHITENESS);
	 ReleaseDC(HWindow,DgDC);
{ Error handle reset }
        ErrorHandle^.NOError;
      end;

 procedure THlavniOkno.SetupWindow;
   var DgDC:HDC;
	  GrSt:PGraphState;
      begin
       inherited SetupWindow;
	begin
	 if Graphstate=NULL then begin
    		                ErrorHandle^.NewValue('SETUP WINDOW',err_criticalerror);
			      ZpracovaniChyby('SetupWindow',err_criticalerror);
			      exit;
			     end;
	 GrSt:=PGraphState(VMem^.GetPointer(GraphState));
	 WindowOfOutput:=new(PWinPaint,Init(@Self));
	 Application^.MakeWindow(WindowOfOutput);
           WindowOfPReview:=new(PWinPreview,Init(@Self));
	 Application^.MakeWindow(WindowOfPreview);
	 DgDC:=GetDC(HWindow);
	 OutputBitmapDC:=CreateCompatibleDC(DgDC);
	 OutputBitmap:=CreateCompatibleBitmap(DgDC,576,792);
	 WindowOfOutput^.BitmapDC:=OutputBitmapDC;
           WindowOfPreview^.BitmapDC:=OutputBitmapDC;
	 VMem^.Alloc(new(PFont,Init(VMem,OutputBitmapDC,'Arial')),FontTemp);
	 GrSt^.Font:=FontTemp;
	 inclife(VMem,ct_Font,GrSt^.Font);
	 SelectObject(OutputBitmapDc,OutputBitmap);
	 BitBlt(OutputBitmapDc,0,0,576,792,DgDc,0,0,WHITENESS);
	 ReleaseDC(WindowOfOutput^.HWindow,DgDC);
	end;
      end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.SaveState(var SystemState:TSystemState);
 begin
{$ifdef DEBUG}
  MessageBox(HWindow,'THlavniOkno.SaveState - start','DEBUG',mb_Ok);
{$endif}
  SystemState.VMem:=VMem^.Copy;
  SystemState.Zasobnik:=Zasobnik^.Copy(SystemState.VMem);
  SystemState.BehZasobnik:=BehZasobnik^.Copy(SystemState.VMem);
  SystemState.SlovZas:=SlovZas^.Copy(SystemState.VMem);
{$ifdef DEBUG}
  MessageBox(HWindow,'THlavniOkno.SaveState - end','DEBUG',mb_Ok);
{$endif}
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.DisposeState(SystemState:TSystemState);
 begin
{$ifdef DEBUG}
  MessageBox(HWindow,'THlavniOkno.DisposeState - start','DEBUG',mb_Ok);
{$endif}
  dispose(SystemState.VMem,Done);
  dispose(SystemState.Zasobnik,Done);
  dispose(Systemstate.BehZasobnik,Done);
  dispose(SystemState.SlovZas,Done);
{$ifdef DEBUG}
  MessageBox(HWindow,'THlavniOkno.DisposeState - end','DEBUG',mb_Ok);
{$endif}
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.RestoreState(SystemState:TSystemState);
 begin
  dispose(VMem,Done);
  dispose(Zasobnik,Done);
  dispose(BehZasobnik,DOne);
  dispose(SlovZas,Done);
  VMem:=SystemState.VMem;
  Zasobnik:=SystemState.Zasobnik;
  BehZasobnik:=SystemState.BehZasobnik;
  SlovZas:=SystemState.SlovZas;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.DefVM(AVMemory:PVirtMemory);
 begin
  VMem:=AVMemory;
  Zasobnik^.VMem:=AVMemory;
  BehZasobnik^.VMem:=AVMemory;
  SlovZas^.VMem:=AVMemory;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMVMCopy;
 var X:PVirtMemory;
 begin
  X:=VMem^.Copy;
  dispose(VMem,Done);
  DefVM(X);
  if WindowOfVirtualMemory<>nil then WindowOfVirtualMemory^.Seznam(VMem);
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMPrint;
 begin
  OutDevice^.Print(HWindow,OutputBitmapDC)
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMResetSystem(var Msg:TMessage);
 begin
  ResetSys;
  if WindowOfGraphPath<>nil then RedrawWindow(WindowOfGraphPath^.HWindow,nil,0,RDW_Invalidate or RDW_ERASE);
  if WindowOfClipPath<>nil then RedrawWindow(WindowOfClipPath^.HWindow,nil,0,RDW_Invalidate or RDW_ERASE);
  if WindowOfOutput<>nil then RedrawWindow(WindowOfOutput^.HWindow,nil,0,RDW_Invalidate);
  if WindowOfPreview<>nil then RedrawWindow(WindowOfPreview^.HWindow,nil,0,RDW_Invalidate);
  EnableMenuItem(Attr.Menu,CM_Debug,MF_ENABLED);
  EnableMenuItem(Attr.Menu,CM_Beh,MF_ENABLED);
 end;

{ ----------------------------------------------------------- }

{ Allow special windows such as the Toolbar the opportunity to say how
  much room they need to take away from the MDI client area AND draw themselves.}
procedure THlavniOkno.RedoClientRect;
var R: TRect;
  procedure NotifyChildren( P: PWindow ); far;
  begin
    if P^.HWindow <> 0 then
      SendMessage(P^.HWindow, am_CalcParentClientRect, AllowRepaint, Longint(@R));
  end;
begin
  GetClientRect(HWindow, R);
  ForEach(@NotifyChildren);
  SetWindowPos(ClientWnd^.HWindow, 0, R.Left, R.Top,
				      R.Right - R.Left,
				      R.Bottom - R.Top, swp_NoZOrder);
end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.HorizontalToolbar(var Msg: TMessage);
begin
  if Toolbar^.GetOrientation <> tbHorizontal then
  begin
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(HWindow);
    Toolbar^.Show(sw_Hide);
    Toolbar^.SetOrientation(tbHorizontal);
    RedoClientRect;
    Toolbar^.Show(sw_Show);
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(0);
    CheckMenuItem(Attr.Menu, cm_HorizontalToolbar, mf_ByCommand or mf_Checked);
    CheckMenuItem(Attr.Menu, cm_LeftVerticalToolbar, mf_ByCommand or mf_UnChecked);
    CheckMenuItem(Attr.Menu, cm_RightVerticalToolbar, mf_ByCommand or mf_UnChecked);
  end;
end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.RightVerticalToolbar(var Msg: TMessage);
begin
  if Toolbar^.GetOrientation <> tbRightVertical then
  begin
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(HWindow);
    Toolbar^.Show(sw_Hide);
    Toolbar^.SetOrientation(tbRightVertical);
    RedoClientRect;
    Toolbar^.Show(sw_Show);
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(0);
    CheckMenuItem(Attr.Menu, cm_HorizontalToolbar, mf_ByCommand or mf_UnChecked);
    CheckMenuItem(Attr.Menu, cm_LeftVerticalToolbar, mf_ByCommand or mf_UnChecked);
    CheckMenuItem(Attr.Menu, cm_RightVerticalToolbar, mf_ByCommand or mf_Checked);
  end;
end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.LeftVerticalToolbar(var Msg: TMessage);
begin
  if Toolbar^.GetOrientation <> tbLeftVertical then
  begin
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(HWindow);
    Toolbar^.Show(sw_Hide);
    Toolbar^.SetOrientation(tbLeftVertical);
    RedoClientRect;
    Toolbar^.Show(sw_Show);
    if Assigned(Win31LockWindowUpdate) then
      Win31LockWindowUpdate(0);
    CheckMenuItem(Attr.Menu, cm_HorizontalToolbar, mf_ByCommand or mf_UnChecked);
    CheckMenuItem(Attr.Menu, cm_LeftVerticalToolbar, mf_ByCommand or mf_Checked);
    CheckMenuItem(Attr.Menu, cm_RightVerticalToolbar, mf_ByCommand or mf_UnChecked);
  end;
end;

{ ----------------------------------------------------------- }

{ Allow special windows such as the Toolbar the opportunity to say how much room
 they need outside the MDI client area.  The default Windows processing for
 wm_Size always sets the MDI client area to fill the main window's client area,
 and it forces a repaint.  We don't want that, so we don't call the inherited
 wm_Size or the Windows default message processor. }
procedure THlavniOkno.wmSize(var Msg: TMessage);
var
  R: TRect;
begin
  if (Scroller <> nil) and (Msg.WParam <> sizeIconic) then
    Scroller^.SetPageSize;
  if Msg.wParam = sizeNormal then
  begin
    GetWindowRect(HWindow, R);
    Attr.H := R.bottom - R.top;
    Attr.W := R.right - R.left;
  end;
  RedoClientRect;
end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.SpeedBar(var Message:TMessage);
 begin
  CMOpen(Message);
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.GetWindowClass(var aWndClass: TWndClass);
 begin
  inherited GetWindowClass(aWndClass);
  aWndClass.hIcon:=LoadIcon(hInstance,'Ikona');
  aWndClass.hbrBackground:=COLOR_BACKGROUND + 1;
 end;

{ ----------------------------------------------------------- }

function THlavniOkno.GetClassName: PChar;
 begin
  GetClassName:='HlavniOkno';
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMOpen(var Msg:TMessage);
 var i:integer;
     X:TMemDescr;
     F:PEditFile;
  begin
   StrCopy(FileName,'*.PS');
   if Application^.ExecDialog(New(PFileDialog,
        Init(@Self, PChar(sd_FileOpen), FileName))) = id_Ok then
          begin
           if Input<>NULL then
            begin
             F:=PEditFile(VMem^.GetPointer(Input));
             if F^.TextWindow<>nil then SendMessage(F^.TExtWindow^.HWindow,WM_CLOSE,0,0);
            end;
           StrCopy(PomChar,FileName);
           CMResetSystem(Msg);
           StrCopy(FileName,PomChar);
           VMem^.Alloc(new(PEditFile,Init(VMem,FileName,@Self)),X);
           if Input=NULL then begin
                               Input:=X;
                               VMem^.Inc(Input);
                              end;
           PEditFile(VMem^.GetPointer(X))^.MakeTextWindow;
           FOtevren:=true;
          end;
{   MessageWindow^.Kresli:=false;}
   if WindowOfVirtualMemory<>nil then WindowOfVirtualMemory^.Seznam(VMem);
  end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMAbout(var Msg:TMessage);
 begin
  Application^.ExecDialog(New(PAboutBox, Init(@Self, 'About', 'Hlavicka', CreditText)));
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMHelp(var Msg:TMessage);
 begin
  WinHelp(HWindow,'EMSCRIPT.HLP',HELP_CONTENTS,0);
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMZasobnik(var Msg:TMessage);
 begin
  if WindowOfStack=nil then
   begin
    WindowOfStack:=new(PWinZas, Init(@Self,Zasobnik));
    Application^.MakeWindow(WindowOfStack);
    WindowOfStack^.Seznam(VMem);
   end                 else
   begin
    SendMessage(WindowOfStack^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
  end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMBehZasobnik(var Msg:TMessage);
 begin
  if WindowOfProcStack=nil then
   begin
    WindowOfProcStack:=new(PWinBehZas, Init(@Self,BehZasobnik));
{***} Application^.MakeWindow(WindowOfProcStack);
    WindowOfProcStack^.Seznam(VMem);
   end                     else
   begin
    SendMessage(WindowOfProcStack^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMVirtualMemory(var Msg:TMessage);
 begin
  if WindowOfVirtualMemory=nil then
   begin
    WindowOfVirtualMemory:=new(PWinVMem, Init(@Self,VMem));
{***}Application^.MakeWindow(WindowOfVirtualMemory);
    WindowOfVirtualMemory^.Seznam(VMem);
   end                         else
   begin
    SendMessage(WindowOfVirtualMemory^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMGraphPath(var Msg:TMessage);
 var A:PGraphPath;
 begin
  if WindowOfGraphPath=nil then
   begin
    A:=PGraphPath(VMem^.GetPointer(PGraphState(VMem^.GetPointer(Graphstate))^.Path));
    WindowOfGraphPath:=new(PWinGraphPath, Init(@Self,A));
{***} Application^.MakeWindow(WindowOfGraphPath);
   end                      else
   begin
    SendMessage(WindowOfGraphPath^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMClipPath(var Msg:TMessage);
 begin
  if WindowOfClipPath=nil then
   begin
    WindowOfClipPath:=new(PWinClipPath, Init(@Self,PGRaphState(VMem^.GetPointer(Graphstate))));
    Application^.MakeWindow(WindowOfClipPath);
   end                    else
   begin
    SendMessage(WindowOfClipPath^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMOutput(var Msg:TMessage);
 begin
  if WindowOfOutput=nil then
   begin
    WindowOfOutput:=new(PWinPaint, Init(@Self));
    WindowOfOutput^.BitmapDC:=OutputBitmapDC;
    Application^.MakeWindow(WindowOfOutput);
   end                  else
   begin
    SendMessage(WindowOfOutput^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
  CMPreview(Msg);
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMPreview(var Msg:TMessage);
 begin
  if WindowOfPreview=nil then
   begin
    WindowOfPreview:=new(PWinPreview, Init(@Self));
    WindowOfPreview^.BitmapDC:=OutputBitmapDC;
    Application^.MakeWindow(WindowOfPreview);
   end                   else
   begin
    SendMessage(WindowOfPreview^.HWindow,WM_ACTIVATE,WA_ACTIVE,0);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMBeh(var Msg:TMessage);
 var OldCursor:HCursor;
     XMsg:TMsg;
     Dial:PDialog;
     S:TMessage;
 begin
  if Input<>NULL then
   begin
    OldCursor:=SetCursor(LoadCursor(0,IDC_WAIT));
    PEditFile(VMem^.GetPointer(Input))^.DebugSign:=false;
    SendMessage(HWindow,wm_Command,cm_Operace,0);
    Dial:=new(PDialog,Init(@Self,'Dialog_3'));
    Dial^.Create;
    while not(PEditFile(VMem^.GetPointer(Input))^.Konec and not ((PolBehZas.Typ=0)and(BehZasobnik^.AktPoz<>0)))and(FOtevren) do
     begin
      if PeekMessage(XMsg,Dial^.HWindow,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE) then break;
      CMOperace(S);
     end;
    PostMessage(Dial^.HWindow,WM_CLOSE,0,0);
    dispose(Dial,Done);
    DestroyCursor(SetCursor(OldCursor));
    if PEditFile(VMem^.GetPointer(Input))^.Konec then
     begin
      EnableMenuItem(Attr.Menu,CM_Debug,MF_DISABLED or MF_GRAYED);
      EnableMenuItem(Attr.Menu,CM_Beh,MF_DISABLED or MF_GRAYED);
     end;
    if WindowOfStack<>nil then WindowOfStack^.Seznam(VMem);
    if WindowOfProcStack<>nil then WindowOfProcStack^.Seznam(VMem);
    if WindowOfVirtualMemory<>nil then WindowOfVirtualMemory^.Seznam(VMem);
   end;
 end;

{ ----------------------------------------------------------- }

procedure THlavniOkno.CMDebug(var Msg:TMessage);
 var XTyp:byte;
     OldCursor:HCursor;
 begin
  if Input<>NULL then
   begin
    PEditFile(VMem^.GetPointer(Input))^.DebugSign:=true;
    with PEditFile(VMem^.GetPointer(Input))^ do
     begin
      if FirstF8 then
       begin
        NaPrvniPlatny;
        SelectLine(Line-1);
        FirstF8:=false;
       end       else
       begin
        BreakDebug:=false;
        OldCursor:=SetCursor(LoadCursor(0,IDC_WAIT));
        while not(BreakDebug)and not((Konec and not((PolBehZas.Typ=0)and(BehZasobnik^.AktPoz<>0)))) and FOtevren do
         SendMessage(HWindow,wm_Command,cm_Operace,0);
        if WindowOfStack<>nil then WindowOfStack^.Seznam(Self.VMem);
        if WindowOfProcStack<>nil then WindowOfProcStack^.Seznam(Self.VMem);
        if WindowOfVirtualMemory<>nil then WindowOfVirtualMemory^.Seznam(Self.VMem);
        DestroyCursor(SetCursor(OldCursor));
        if not Konec then SelectLine(Line-1)
                     else begin
                           if TextWindow<>nil then TextWindow^.Editor^.SetSelection(0,0);
                           EnableMenuItem(Attr.Menu,CM_Debug,MF_DISABLED or MF_GRAYED);
                           EnableMenuItem(Attr.Menu,CM_Beh,MF_DISABLED or MF_GRAYED);
                          end;
       end;
     end;
   end;
 end;

{ ----------------------------------------------------------- }

     procedure THlavniOkno.CMOperace(var Msg:TMessage);
      var XTyp:byte;
	  XChar:PChar;
	  XBox:TMemDescr;
	  PolZas:TPolZas;
	  PomBehPol:TPolBehZas;
	  Err:bool;
	  P:TPolozka;
	  Tab,Kde:word;
	  Textik: array [0..40] of char;
	  Cislo,i,j:longint;
	  Vysl:boolean;
	  Odlozeny:boolean; { true - odlozeny beh   false - bezprostredni }
	  StateBackup:TSystemState;
            Subst:boolean; { indikuje substituci ze slovniku }

      begin
       XTyp:=ct_Null;
       Subst:=false;
       if FOtevren then
         begin { if FOtevren }
	Odlozeny:=(PolBehZas.Typ=0)and(BehZasobnik^.AktPoz<>0);
	if Odlozeny then
	 begin { if Odlozeny }
{===}     { Odlozeny beh }
{$ifdef SaveState}
	  SaveState(StateBackup); { Provedeni kopie vsech kopmlikovanych objecktu }
{$endif}
	  with BehZasobnik^.POBox[BehZasobnik^.AktPoz] do
	   if Typ=ct_LoopCyklus then
	    begin { if loop jedna se o loop cyklus }
	     PomBehPol.Typ:=ct_Proc;
	     PomBehPol.Uk1.Uk:=Uk1.Uk;                    { Ukazatel na proceduru }
	     PomBehPol.Uk2.HLongint:=
		PProc(VMem^.GetPointer(Uk1.HPProc))^.Size; { Index operace v behovem poli, ktera se bude provadet }
	     BehZasobnik^.Vloz(PomBehPol);
	    end;  { if loop }
	  with BehZasobnik^.POBox[BehZasobnik^.AktPoz] do
	   if (Typ=ct_ForCyklus)or(Typ=ct_RepeatCyklus) then
	    begin { if for }
 {===}      { Jedna se o FOR nebo REPEAT cyklus }
	     if Uk2.Typ=ct_Integer then { rizeni probiha v integer promennych }
	      begin
	       if Uk2.HLongint>0 then Vysl:=Uk1.Hlongint<=BehZasobnik^.POBox[BehZasobnik^.AktPoz-1].Uk2.HLongint
			     else Vysl:=Uk1.HLongint>=BehZasobnik^.POBox[BehZasobnik^.AktPoz-1].Uk2.HLongint;
	      end                  else
                begin
	       if Uk2.HReal>0 then Vysl:=Uk1.HReal<=BehZasobnik^.POBox[BehZasobnik^.AktPoz-1].Uk2.HReal
				 else Vysl:=Uk1.HReal>=BehZasobnik^.POBox[BehZasobnik^.AktPoz-1].Uk2.HReal;
                end;
	     if Vysl then
	      begin
	       { Ridici hodnota neni pres limit }
                 PomBehPol:=BehZasobnik^.POBox[BehZasobnik^.AktPoz-1];
     	       if Typ=ct_ForCyklus then { For cyklus na rozdil od repeat cyklu       }
		begin                   { uklada na zasobnik hodnotu ridici promenne }
{===}                with PolZas do
		  begin
		   if Uk2.Typ=ct_Integer then
                        begin
		     Typ:=ct_Integer;
                         HLongint:=Uk1.HLongint
                        end                  else
		    begin
                         Typ:=ct_Real;
		     HReal:=Uk1.HReal;
                        end;
		  end;
{===}                Zasobnik^.Vloz(PolZas);
                    end;
{===}          if Uk2.Typ=ct_Integer then Uk1.HLongint:=Uk1.HLongint+Uk2.HLongint
			       else Uk1.HReal:=Uk1.HReal+Uk2.HReal;
	     PomBehPol.Uk2.HLongint:=
		    PPRoc(VMem^.GetPointer(PomBehPol.Uk1.HPProc))^.Size;{ Index operace v behovem poli, ktera se bude provadet }
	     BehZasobnik^.Vloz(PomBehPol);
              end   { if for }      else
              begin { else for }
	       { Ridici hodnota je pres limit - ukonceni for cyklu }
	       BehZasobnik^.Vyber(PomBehPol);
	       BehZasobnik^.Vyber(PomBehPol);
	       exit; { predcasne ukonceni zpracovani - dalsi kolo ridiciho cyklu }
	    end;  { else for }
	    end;
          with BehZasobnik^.POBox[BehZasobnik^.AktPoz] do
	   begin
	    if not PProc(VMem^.GetPointer(Uk1.HPProc))^.KonecProcedury(Uk2.HLongint) then begin
							      { Dosazeni operatoru z behoveho pole procedury }
							     PProc(VMem^.GetPointer(Uk1.HPProc))^.VratPrvek(Uk2.HLongint,TPolProc(PolZas));
							     XTyp:=PolZas.Typ;
{							     MessageWindow^.TypW:=XTyp;}
                                                                           P.Typ:=PolZas.Typ;
                                                                           P.Hodnota.Whole:=PolZas.Whole;
							    end
						       else begin
							     { Konec procedury }
							     BehZasobnik^.Vyber(PomBehPol);
							    end;

           end;
	 end   { if Odlozeny }           else
	 begin { else Odlozeny }
            { Bezprostredni beh }
	  if(PFile(VMem^.GetPointer(Input))^.EdF=cmd_EditFile)then
	   if(PEditFile(VMem^.GetPointer(Input))^.IsNewLine)then
	    begin
	     PEditFile(VMem^.GetPointer(Input))^.IsNewLine:=false;
	     BreakDebug:=true;
	     exit;
	    end;
{$ifdef Savestate}
	  SaveState(StateBackup); { Provedeni kopie vsech kopmlikovanych objecktu }
{$endif}
	  PFile(VMem^.GetPointer(Input))^.VstupOP(XTyp, Atom);
{	  MessageWindow^.TypW:=XTyp;}
	  AtomToDat(VMem,XTyp, Atom, PolZas);
	 end;  { else Oldozeny }

	 if (XTyp=ct_Name) then
	  begin { if 1 }
	     i:=0;
	      if PolBehZas.Typ=0 then { primy beh }
	       begin { if 2 }
		P.Op:=PolZas.Uk;
		Vysl:=SlovZas^.Find(P,Tab,Kde);
		if Vysl then
		 begin { if 3 }
                      Subst:=true;
		  Xtyp:=P.Typ;
		  with PolZas do
                   begin { if 4 }
                    Typ:=P.Typ;
                    Whole:=P.Hodnota.Whole;
                   end;  { if 4 }
                 end  { if 3 }   else
		      MessageBox(HWindow, 'Error 1 - Operator not found','Error message',mb_Ok or mb_IconQuestion);
	       end   { if 2 }    else
	       begin { else 2 }
		{ Typ 3 - jmeno se ulozi na zasobnik (pouze pri definici procedury)}
                Err:=Zasobnik^.Vloz(PolZas);
               end;   { else 2 }
            end;  { if 1 }
         if (XTyp=ct_ImpProc) then VykonBlok(P.Hodnota.Slovo1);
         if (XTyp=ct_Proc) then
	  begin { if 1 }
           { Je procedura - ulozit na behovy zasobnik }
           with PomBehPol do
            begin { with PomBehPol }
             Typ:=ct_Proc;
              if Subst then
               begin { procedura se nalezena ve slovniku - vykona se ihned }
                Uk1.HPPRoc:=PolZas.HPProc;
                Uk2.HLongint:=PPRoc(VMem^.GetPointer(Uk1.HPProc))^.Size;
    	      if not BehZasobnik^.Vloz(PomBehPol) then exit;
               end     else
               if not Zasobnik^.Vloz(PolZas) then exit; { procedura ulozena jako operand - vklada se na zasobnik operandu }
             end; { with PomBehPol }
          end;  { if 1 }
         if (XTyp=ct_Integer) or (XTyp=ct_Real)  or (XTyp=ct_Logic) or
	    (XTyp=ct_Dict)    or (XTyp=ct_Array) or (XTyp=ct_String) or
               (XTyp=ct_matrix) or (XTyp=ct_Font) then
          begin { if 1 }
           Err:=Zasobnik^.Vloz(PolZas);
          end;  { if 1 }
         if (XTyp=ct_mark) then
          begin
           PolZas.Typ:=ct_mark;
	   Err:=Zasobnik^.Vloz(PolZas);
	  end;
	 if (XTyp=ct_BracProc) then
          begin
	   Err:=Zasobnik^.Vloz(PolZas);
           Err:=BehZasobnik^.Vloz(PolBehZas);
	   Cislo:=0;
	   BehToDat(ct_DefProc,TMemDescr(Cislo),TMemDescr(Cislo),PolBehZas);
         end;
         if (XTyp=ct_BackBrack) then
          begin { if 8 }
             j:=Zasobnik^.AktPoz;
	     while (Zasobnik^.POBox[j].Typ<>ct_Mark)and(j<>0) do dec(j);
	     if j=0 then
	      begin
	       ErrorHandle^.NewValue('DEF ARRAY',err_stackunderflow);
	       exit;
	      end;
	     VMem^.Alloc(new(PProc,Init(VMem,Zasobnik^.AktPoz-j)),XBox);
	     repeat
	      if not Zasobnik^.Vyber(PolZas) then exit;
	      if PolZas.Typ<>ct_Mark then begin
					   PPRoc(VMem^.GEtPointer(XBox))^.PlusPrvek(TPolProc(PolZas));
					  end;
	     until PolZas.Typ=ct_Mark;
	     PolZas.Typ:=ct_Array;
	     PolZas.Uk:=XBox;
	     if not Zasobnik^.Vloz(PolZas) then exit;
	  end;  { if 8 }
         if (XTyp=ct_BackBrackProc) then
          begin { if 8 }
           if PolBehZas.Typ<>0 then
	    begin
	     VMem^.Alloc(new(PProc,Init(VMem,PolBehZas.Uk1.HLongint)),XBox);
	     repeat
              Err:=Zasobnik^.Vyber(PolZas);
	      if PolZas.Typ<>ct_BracProc then begin
				     PProc(VMem^.GetPointer(XBox))^.PlusPrvek(TPolProc(PolZas));
                                    end;
             until PolZas.Typ=ct_BracProc;
	     PolZas.Typ:=ct_Proc;
	     PolZas.Uk:=XBox;
             if not Zasobnik^.Vloz(PolZas) then exit;
             if not BehZasobnik^.Vyber(PolBehZas) then exit;
	    end           else ErrorHandle^.NewValue('DEF PROC',err_syntaxerror);
	  end;  { if 8 }

         if (XTyp=ct_LitName) then
	  begin
	   Err:=Zasobnik^.Vloz(PolZas);
          end;

         if (XTyp=ct_SubstName) then
	  begin
	   P.Op:=PolZas.Uk;
           Vysl:=SlovZas^.Find(P,Tab,Kde);
           with PolZas do
            begin
	     Typ:=P.Typ;
             Uk:=P.Hodnota.Uk;
	    end;
           Err:=Zasobnik^.Vloz(PolZas);
	  end;

         if (PolBehZas.Typ<>0)and(PolZas.Typ<>ct_BracProc) then inc(PolBehZas.Uk1.HLongint);
{$ifdef SaveState}
	 if ErrorHandle^.Value<>err_NoError then
					       begin
						ZpracovaniChyby(ErrorHandle^.Value);
						RestoreState(StateBackup) { Nastala chyba - zpet predchozi stav }
					       end
		      else DisposeState(StateBackup); { Nenastala chzba, smaze se zaloha }
{$else}
	 if ErrorHandle^.Value<>err_NoError then ZpracovaniChyby(ErrorHandle^.Description,ErrorHandle^.Value);
{$endif}
{$ifdef DEBUG}
 MessageBox(HWindow,'Uvolneni unlock objektu z VM pameti','DEBUG',mb_Ok);
{$endif}
	 VMem^.Free;
	end;
      end;

    function THlavniOkno.VykonBlok(Cislo:word):bool;

     function ObsluhaZas(Cislo:word):bool;
      var PolZas1,PolZas2,PolZas3:TPolZas;
          i,j,k:longint;

      begin { ObsluhaZas }
       case Cislo of
        in_pop:begin { pop }
                Zasobnik^.Vyber(PolZas1);
	       end;
        in_exch:begin { exch }
                 if Zasobnik^.Vyber(PolZas1) then
		  if Zasobnik^.Vyber(PolZas2) then
                   begin
                    Zasobnik^.Vloz(PolZas1);
                    Zasobnik^.Vloz(PolZas2);
                   end;
                end;
        in_dup:begin { dup }
                if Zasobnik^.Vyber(PolZas1) then
                 begin
	        Zasobnik^.Vloz(PolZas1);
                  Zasobnik^.Vloz(PolZas1);
                 end;
               end;
        in_index:begin { index }
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if PolZas1.Typ<>ct_integer then
                   begin
		    ErrorHandle^.NewValue('OP INDEX',err_typecheck);
                    exit
                   end;
                  if PolZas1.HLongint<0 then
		   begin
		    ErrorHandle^.NewValue('OP INDEX',err_rangecheck);
                    exit;
                   end;
                  j:=Zasobnik^.AktPoz-PolZas1.HLongint;
                  if j>0 then
                   begin { if 1 }
                    PolZas2:=Zasobnik^.POBox[j];
                    Zasobnik^.Vloz(PolZas2);
		   end   else ErrorHandle^.NewValue('OP INDEX',err_stackunderflow);
                end;
        in_roll:begin { roll }
		 if not Zasobnik^.Vyber(PolZas1) then exit; { j }
                 if not Zasobnik^.Vyber(PolZas2) then exit; { n }
                 if (PolZas1.Typ=ct_Integer)and(PolZas2.Typ=ct_Integer) then
                  begin { if 1 }
                   if PolZas2.HLongint<0 then
                    begin
		     ErrorHandle^.NewValue('OP ROLL',err_rangecheck);
                     exit;
                    end;
                   i:=Zasobnik^.AktPoz-PolZas2.HLongint+1;
                   if i>0 then
                    if PolZas1.HLongInt>0 then
                     begin { if 2 }
                      for j:=1 to PolZas1.HLongint do
                       begin { for j }
                        Zasobnik^.Vyber(PolZas3);
                        Zasobnik^.Vloz(PolZas3);
                        for k:=Zasobnik^.AktPoz-1 downto i do
                         begin { for k }
                          Zasobnik^.POBox[k+1]:=Zasobnik^.POBox[k];
                         end;  { for k }
                        Zasobnik^.POBox[i]:=PolZas3;
                       end;  { for j }
                      end   { if 2 }       else
                    begin { else 2 }
                     for j:=1 to -PolZas1.HLongint do
                      begin { for j }
                       PolZas3:=Zasobnik^.POBox[i];
                       for k:=i to Zasobnik^.AktPoz-1 do
                        begin { for k }
                         Zasobnik^.POBox[k]:=Zasobnik^.POBox[k+1];
                        end;  { for k }
                       Zasobnik^.POBox[Zasobnik^.AktPoz]:=PolZas3;
                      end;  { for j }
		    end  { else 2 }  else ErrorHandle^.NewValue('OP ROLL',err_stackunderflow);
		  end  { if 1 }   else ErrorHandle^.NewValue('OP ROLL',err_typecheck);
                end;  { roll }
        in_clear:begin { clear }
                  while Zasobnik^.AktPoz>0 do Zasobnik^.Vyber(PolZas1);
                 end;  { clear }
        in_count:begin { count }
                  PolZas1.Typ:=ct_Integer;
                  PolZas1.HLongint:=Zasobnik^.AktPoz;
                  Zasobnik^.Vloz(PolZas1);
                 end;  { count }
        in_mark:begin { mark }
                 PolZas1.Typ:=ct_Mark;
                 Zasobnik^.Vloz(PolZas1);
                end;  { mark }
        in_cleartomark:begin { cleartomark }
                        if Zasobnik^.AktPoz=0 then
                         begin
			  ErrorHandle^.NewValue('OP CLEARTOMARK',err_unmatchedmark);
                          exit;
                         end;
                        Zasobnik^.Vyber(PolZas1);
{***}                   while (Zasobnik^.AktPoz>0)and(PolZas1.Typ<>ct_Mark) do Zasobnik^.Vyber(PolZas1);
			if Zasobnik^.AktPoz=0 then ErrorHandle^.NewValue('OP CLEARTOMARK',err_unmatchedmark);
                       end;  { clearomark }
        in_counttomark:begin { counttomark }
                        i:=Zasobnik^.AktPoz;
                        j:=0;
                        while (i-j>0)and(Zasobnik^.POBox[i-j].Typ<>ct_Mark) do inc(j);
{***}                   if i-j=0 then ErrorHandle^.NewValue('OP COUNTTOMARK',err_unmatchedmark)
                        else begin
                              PolZas1.Typ:=ct_Integer;
                              PolZas1.HLongint:=j;
                              Zasobnik^.Vloz(PolZas1);
                             end;
                       end;  { counttomark }
       end;  { case }
      end;  { ObsluhaZas }


     function ObsluhaSlov(Cislo:word):bool;

      var PolZas1,PolZas2:TPolZas;
          PolDict:TPolozka;
          Tab,Kde:word;
	  Sl:TMemDescr;

      begin { ObsluhaSlov }
       case Cislo of
        in_dict:begin { dict }
                 if not Zasobnik^.Vyber(PolZas1) then exit;
                 if PolZas1.Typ=ct_Integer then
                  begin
                   if PolZas1.HLongint<0 then
                    begin
		     ErrorHandle^.NewValue('OP DICT',err_rangecheck);
                     exit;
                    end;
                   PolZas2.Typ:=ct_Dict;
		   VMem^.Alloc(new(PSlovnik,Init(VMem,'',PolZas1.HLongint)),PolZas2.Uk);
		   Zasobnik^.Vloz(PolZas2);
		  end              else ErrorHandle^.NewValue('OP DICT',err_typecheck);
		 end;  { dict }
	in_length:begin { length }
		   if not Zasobnik^.Vyber(PolZas1) then exit;
		    if PolZas1.Typ=ct_Dict then
		     begin
		      PolZas2.Typ:=ct_Integer;
                      PolZas2.HLongint:=PSlovnik(PolZas1.Uk)^.Pocet;
                      Zasobnik^.Vloz(PolZas2);
		     end                   else ErrorHandle^.NewValue('OP LENGTH',err_typecheck);
                  end;  { length }
        in_maxlength:begin { maxlength }
                      if not Zasobnik^.Vyber(PolZas1) then exit;
                      if PolZas1.Typ=ct_Dict then
                       begin
                        PolZas2.Typ:=ct_Integer;
                        PolZas2.HLongint:=PSlovnik(PolZas1.Uk)^.Kapacita;
                        Zasobnik^.Vloz(PolZas2);
		       end             else ErrorHandle^.NewValue('OP MAXLENGTH',err_typecheck);
                     end;  { maxlength }
        in_begin:begin { begin }
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if PolZas1.Typ=ct_Dict then
                   begin
                    SlovZas^.Vloz(PolZas1.Uk);
		   end                   else ErrorHandle^.NewValue('OP BEGIN',err_typecheck);
                 end;  { begin }
        in_end:begin { end }
                SlovZas^.Vyber;
               end;  { end }
        in_def:begin { def }
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if not Zasobnik^.Vyber(PolZas2) then exit;
                if PolZas2.Typ=ct_LitName then
                 begin { if 1 }
                   with PolDict do
                    begin { with 1 }
                     Op:=PolZas2.Uk;
                     Typ:=PolZas1.Typ;
                     Hodnota.Whole:=PolZas1.Whole;
                     if not SlovZas^.Put(SlovZas^.SlovZasTop,PolDict) then
                      begin { if 2 }
		       ErrorHandle^.NewValue('OP DEF',err_dictfull);
                       exit;
                      end;  { if 2 }
                    end;  { with 1 }
		 end   { if 1 }         else ErrorHandle^.NewValue('OP DEF',err_typecheck);
               end;  { def }
        in_load:begin { load }
                 if not Zasobnik^.Vyber(PolZas1) then exit;
                 if PolZas1.Typ=ct_LitName then
                  begin
                   PolDict.Op:=PolZas1.Uk;
                   if SlovZas^.Find(PolDict,Tab,Kde) then
                    begin
                     PolZas2.Typ:=PolDict.Typ;
                     PolZas2.Whole:=PolDict.Hodnota.Whole;
                     Zasobnik^.Vloz(PolZas2);
		    end                            else ErrorHandle^.NewValue('OP LOAD',err_undefined);
		  end                      else ErrorHandle^.NewValue('OP LOAD',err_typecheck);
                end;  { load }
        in_store:begin { store }
                  if not Zasobnik^.Vyber(PolZas2) then exit;
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if PolZas1.Typ<>ct_LitName then
                   begin
		    ErrorHandle^.NewValue('OP STORE',err_typecheck);
                    exit;
                   end;
                  with PolDict do
                   begin
                    Op:=PolZas1.Uk;
                    Typ:=PolZas2.Typ;
                    Hodnota.Whole:=PolZas2.Whole;
                   end;
                  if not SlovZas^.Find(PolDict,Tab,Kde) then
                   begin
                    if not Slovzas^.Put(SlovZas^.SlovZasTop,PolDict) then
		     begin
		      ErrorHandle^.NewValue('OP STORE',err_dictfull);
                      exit;
                     end;
                   end else
                   begin
                    with PolDict do
                     begin
                      Typ:=PolZas2.Typ;
                      Hodnota.Whole:=PolZas2.Whole;
                     end;
                    Slovzas^.StoreDirect(Tab,Kde,PolDict);
                   end;
		 end;  { store }
        in_known:begin { known }
                  if not Zasobnik^.Vyber(PolZas2) then exit;
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if (PolZas2.Typ<>ct_LitName) or (PolZas1.Typ<>ct_Dict) then
                   begin
		    ErrorHandle^.NewValue('OP KNOWN',err_typecheck);
                    exit;
                   end;
                  PolDict.Op:=PolZas2.Uk;
                  PolZas2.Typ:=ct_Logic;
		  if not PSlovnik(VMem^.GetPointer(PolZas1.HPDict))^.GetPair(PolDict,Kde) then
                   begin
		    PolZas2.HBoolean:=false;
                   end                                        else
                   begin
                    PolZas2.HBoolean:=true;
                   end;
                  Zasobnik^.Vloz(PolZas2);
                 end;  { known }
        in_where:begin { where }
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if PolZas1.Typ<>ct_LitName then
                   begin
		    ErrorHandle^.NewValue('OP WHERE',err_typecheck);
                    exit;
		   end;
		  PolDict.Op:=PolZas1.Uk;
		  PolZas2.Typ:=ct_Logic;
		  if not SlovZas^.Where(PolDict,Sl,Kde) then
                   PolZas2.HBoolean:=false              else
                   begin
                    PolZas1.Typ:=ct_dict;
                    PolZas1.HPDict:=Sl;
                    if not Zasobnik^.Vloz(PolZas1) then exit;
                   end;
                  Zasobnik^.Vloz(PolZas2);
                 end;  { where }
        in_systemdict:begin { systemdict }
                       with PolZas1 do
                        begin
                         Typ:=ct_dict;
                         Uk:=SlovZas^.SlovZas[SlovZas^.SlovZasSystem];
                        end;
                       Zasobnik^.Vloz(PolZas1);
                      end;  { systemdict }
        in_userdict:begin { userdict }
                       with PolZas1 do
                        begin
                         Typ:=ct_dict;
                         Uk:=SlovZas^.SlovZas[SlovZas^.SlovZasUser];
                        end;
                       Zasobnik^.Vloz(PolZas1);
                     end;  { userdict }
        in_currentdict:begin { currentdict }
                        with PolZas1 do
                         begin
                          Typ:=ct_dict;
                          Uk:=SlovZas^.SlovZas[SlovZas^.SlovZasTop];
                         end;
                        Zasobnik^.Vloz(PolZas1);
                       end;  { curentdict }
        in_countdictstack:begin { countdictstack }
                        with PolZas1 do
                         begin
                          Typ:=ct_integer;
                          HLongint:=SlovZas^.SlovZasTop;
                         end;
                        Zasobnik^.Vloz(PolZas1);
                       end;  { countdictstack }
       end; { case }
      end;  { ObsluhaSlov }

     function ObsluhaTyp(Cislo:word):bool;
      var PolZas1,PolZas2,PolZas3:TPolZas;
          ErrCode:integer;
          A:string;
      label Finaly;
      begin { ObsluhaTyp }
       case Cislo of
        in_type:;
        in_cvlit:begin
                  if not Zasobnik^.Vyber(PolZas1) then exit;
                  if PolZas1.Typ in [ct_Dict,ct_File,ct_String,ct_SubString,ct_DefArray,ct_Array,
                                     ct_SubArray,ct_Matrix,ct_Font,ct_Proc] then
                                    VMem^.GetPointer(PolZas1.HPCompObject)^.Literal:=true;
                  if not Zasobnik^.Vloz(PolZas1) then exit;
                 end;
        in_cvx:begin
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if PolZas1.Typ in [ct_Dict,ct_File,ct_String,ct_SubString,ct_DefArray,ct_Array,
                                   ct_SubArray,ct_Matrix,ct_Font,ct_Proc] then
                                   VMem^.GetPointer(PolZas1.HPCompObject)^.Literal:=false;
                if not Zasobnik^.Vloz(PolZas1) then exit;
               end;
        in_xcheck:;
        in_executeonly:;
        in_noaccess:;
        in_readonly:;
        in_rcheck:;
        in_wcheck:;
        in_cvi:begin {cvi}
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_string) then
                 begin
	        ErrorHandle^.NewValue('OP CVI',err_typecheck);
                  exit;
                 end;
                if PolZas1.Typ=ct_integer then Zasobnik^.Vloz(PolZas1);
                if PolZas1.Typ=ct_real then
                 begin
                  if PolZas1.HReal>Maxlongint then
                   begin
  	          ErrorHandle^.NewValue('OP CVI',err_rangecheck);
                    exit;
                   end;
                   with PolZas2 do
                    begin
                     PolZas2.Typ:=ct_integer;
                     PolZas2.HLongint:=trunc(PolZas1.HReal);
                    end;
                 end;
                if PolZas1.Typ=ct_string then
                 begin
                   with PolZas2 do
                    begin
                     PolZas2.Typ:=ct_integer;
                     val(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,PolZas2.HLongint,ErrCode);
                    end;
                  if ErrCode<>0 then
                   begin
  	          ErrorHandle^.NewValue('OP CVI',err_syntaxerror);
                    exit;
                   end;
                 end;
               end;  { cvi }
        in_cvn:begin { cvn }
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if PolZas1.Typ<>ct_string then
                 begin
	        ErrorHandle^.NewValue('OP CVN',err_typecheck);
                  exit;
                 end;
                if VMem^.GetPointer(PolZas1.HPRet)^.Literal=true then
                 begin
                  PolZas1.Typ:=ct_LitName;
                 end                                             else
                 begin
                  PolZas1.Typ:=ct_Name;
                 end;
                Zasobnik^.Vloz(PolZas1);
               end;  { cvn }
        in_cvr:begin { cvr }
                 if not Zasobnik^.Vyber(PolZas1) then exit;
                if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_string) then
                 begin
	        ErrorHandle^.NewValue('OP CVR',err_typecheck);
                  exit;
                 end;
                if PolZas1.Typ=ct_real then Zasobnik^.Vloz(PolZas1);
                if PolZas1.Typ=ct_integer then
                 begin
                   with PolZas2 do
                    begin
                     PolZas2.Typ:=ct_real;
                     PolZas2.HReal:=PolZas1.HLongint;
                    end;
                 end;
                if PolZas1.Typ=ct_string then
                 begin
                   with PolZas2 do
                    begin
                     PolZas2.Typ:=ct_real;
                     val(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,PolZas2.HReal,ErrCode);
                    end;
                  if ErrCode<>0 then
                   begin
  	          ErrorHandle^.NewValue('OP CVR',err_syntaxerror);
                    exit;
                   end;
                 end;
               end;  { cvr }
        in_cvrs:;
        in_cvs:begin { cvs }
                if not Zasobnik^.Vyber(PolZas2) then exit;
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if PolZas2.Typ<>ct_string then
                 begin
	        ErrorHandle^.NewValue('OP CVS',err_typecheck);
                  exit;
                 end;
                if PolZas1.Typ=ct_Real then
                 begin
                  str(PolZas1.HReal,A);
                  StrPCopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,A);
                  goto Finaly;
                 end;
                if PolZas1.Typ=ct_Integer then
                 begin
                  str(PolZas1.HLongint,A);
                  StrPCopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,A);
                  goto Finaly;
                 end;
                if PolZas1.Typ=ct_Logic then
                 begin
                  if PolZas1.HBoolean then
                   begin
                    StrCopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,'true');
                   end                else
                   begin
                    StrCopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,'false');
                   end;
                  goto Finaly;
                 end;
                if PolZas1.Typ in [ct_Name,ct_LitName,ct_String] then
                 begin
                  strcopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box);
                  goto Finaly;
                 end;
                strcopy(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box,'--nonstringval--');
Finaly:         Zasobnik^.Vloz(PolZas2);
               end;  { cvs }
        in_true:begin { true }
                 with PolZas1 do
                  begin
                   Typ:=ct_Logic;
                   HBoolean:=true;
                  end;
                 Zasobnik^.Vloz(PolZas1);
                end;  { true }
        in_false:begin { false }
                  with PolZas1 do
                   begin
                    Typ:=ct_Logic;
                    HBoolean:=false;
                   end;
                  Zasobnik^.Vloz(PolZas1);
		 end;  { false }
       end; { case Cislo }
      end; { ObsluhaTyp }

     function Equal(PolZas1,PolZas2:TPolZas):boolean;
      begin
       Equal:=false;
       if (PolZas1.Typ in [ct_String,ct_Name,ct_LitName])and
          (PolZas2.Typ in [ct_String,ct_Name,ct_LitName]) then
         Equal:=strcomp(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)=0;
       if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_integer) then
        Equal:=PolZas1.HLongint=PolZas2.HLongint;
       if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_integer) then
        Equal:=PolZas1.HReal=PolZas2.HLongint;
       if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_real) then
        Equal:=PolZas1.HLongint=PolZas2.HReal;
       if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_real) then
        Equal:=PolZas1.HReal=PolZas2.HReal;
       if (PolZas1.Typ=ct_array)and(PolZas2.Typ=ct_array) then Equal:=PolZas1.HPProc=PolZas2.HPProc;
       if (PolZas1.Typ=ct_dict)and(PolZas2.Typ=ct_dict) then Equal:=PolZas1.HPDict=PolZas2.HPDict;
      end;


     function ObsluhaLog(Cislo:word):bool;
      var PolZas1,PolZas2,PolZas3:TPolZas;
      label GE_Finaly,GT_Finaly,LE_Finaly,LT_Finaly;
      begin { ObsluhaLog }
       case Cislo of
        in_true:begin { true }
                 with PolZas1 do
                  begin
                   Typ:=ct_Logic;
                   HBoolean:=true;
                  end;
                 Zasobnik^.Vloz(PolZas1);
                end;  { true }
        in_false:begin { false }
                  with PolZas1 do
                   begin
                    Typ:=ct_Logic;
                    HBoolean:=false;
                   end;
                  Zasobnik^.Vloz(PolZas1);
		 end;  { false }
        in_eq:begin { eq }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               PolZas3.HBoolean:=Equal(PolZas1,PolZas2);
               Zasobnik^.Vloz(PolZas3);
              end;  { eq }
        in_ne:begin { ne }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               PolZas3.HBoolean:=not Equal(PolZas1,PolZas2);
               Zasobnik^.Vloz(PolZas3);
              end;  { ne }
        in_ge:begin { ge }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint>=PolZas2.HLongint;
                 goto GE_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal>=PolZas2.HLongint;
                 goto GE_Finaly;
                end;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint>=PolZas2.HReal;
                 goto GE_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal>=PolZas2.HReal;
                 goto GE_Finaly;
                end;
               if (PolZas1.Typ=ct_string)and(PolZas2.Typ=ct_string) then
                begin
                 PolZas3.HBoolean:=not strcomp(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,
                                               PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)<0;
                 goto GE_Finaly;
                end;
               ErrorHandle^.NewValue('OP GE',err_typecheck);
               exit;
GE_Finaly:
               Zasobnik^.Vloz(PolZas3);
              end;  { ge }
        in_gt:begin { gt }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint>PolZas2.HLongint;
                 goto GT_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal>PolZas2.HLongint;
                 goto GT_Finaly;
                end;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint>PolZas2.HReal;
                 goto GT_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal>PolZas2.HReal;
                 goto GT_Finaly;
                end;
               if (PolZas1.Typ=ct_string)and(PolZas2.Typ=ct_string) then
                begin
                 PolZas3.HBoolean:=strcomp(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,
                                           PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)>0;
                 goto GT_Finaly;
                end;
               ErrorHandle^.NewValue('OP GT',err_typecheck);
               exit;
GT_Finaly:
               Zasobnik^.Vloz(PolZas3);
              end;  { gt }
        in_le:begin { le }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint<=PolZas2.HLongint;
                 goto LE_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal<=PolZas2.HLongint;
                 goto LE_Finaly;
                end;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint<=PolZas2.HReal;
                 goto LE_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal<=PolZas2.HReal;
                 goto LE_Finaly;
                end;
               if (PolZas1.Typ=ct_string)and(PolZas2.Typ=ct_string) then
                begin
                 PolZas3.HBoolean:=not strcomp(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,
                                               PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)>0;
                 goto LE_Finaly;
                end;
               ErrorHandle^.NewValue('OP LE',err_typecheck);
               exit;
LE_Finaly:
               Zasobnik^.Vloz(PolZas3);
              end;  { le }
        in_lt:begin { lt }
               if not Zasobnik^.Vyber(PolZas2) then exit;
               if not Zasobnik^.Vyber(PolZas1) then exit;
               PolZas3.Typ:=ct_Logic;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint<PolZas2.HLongint;
                 goto LT_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_integer) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal<PolZas2.HLongint;
                 goto LT_Finaly;
                end;
               if (PolZas1.Typ=ct_integer)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HLongint<PolZas2.HReal;
                 goto LT_Finaly;
                end;
               if (PolZas1.Typ=ct_real)and(PolZas2.Typ=ct_real) then
                begin
                 PolZas3.HBoolean:=PolZas1.HReal<PolZas2.HReal;
                 goto LT_Finaly;
                end;
               if (PolZas1.Typ=ct_string)and(PolZas2.Typ=ct_string) then
                begin
                 PolZas3.HBoolean:=not strcomp(PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box,
                                               PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)<0;
                 goto LT_Finaly;
                end;
               ErrorHandle^.NewValue('OP LT',err_typecheck);
               exit;
LT_Finaly:
               Zasobnik^.Vloz(PolZas3);
              end;  { lt }
        in_and:begin { and }
                if not Zasobnik^.Vyber(PolZas2) then exit;
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if ((PolZas1.Typ<>ct_logic)or(PolZas2.Typ<>ct_logic))and
                   ((PolZas1.Typ<>ct_integer)or(PolZas2.Typ<>ct_integer)) then
                 begin
                  ErrorHandle^.NewValue('OP AND',err_typecheck);
                  exit;
                 end;
                if (PolZas1.Typ=ct_logic) then
                 begin
                  PolZas3.Typ:=ct_logic;
                  PolZas3.HBoolean:=PolZas1.HBoolean and PolZas2.HBoolean;
                 end;
                if (PolZas1.Typ=ct_integer) then
                 begin
                  PolZas3.Typ:=ct_integer;
                  PolZas3.HLongint:=PolZas1.HLongint and PolZas2.HLongint;
                 end;
                Zasobnik^.Vloz(PolZas3);
               end;  { and }
        in_not:begin { not }
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if (PolZas1.Typ<>ct_logic)and(PolZas1.Typ<>ct_integer) then
                 begin
                  ErrorHandle^.NewValue('OP NOT',err_typecheck);
                  exit;
                 end;
                if (PolZas1.Typ=ct_logic) then
                 begin
                  PolZas2.Typ:=ct_logic;
                  PolZas2.HBoolean:=not PolZas1.HBoolean;
                 end;
                if (PolZas1.Typ=ct_integer) then
                 begin
                  PolZas2.Typ:=ct_integer;
                  PolZas2.HLongint:=not PolZas1.HLongint;
                 end;
                Zasobnik^.Vloz(PolZas2);
               end;  { not }
        in_or:begin  { or }
                if not Zasobnik^.Vyber(PolZas2) then exit;
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if ((PolZas1.Typ<>ct_logic)or(PolZas2.Typ<>ct_logic))and
                   ((PolZas1.Typ<>ct_integer)or(PolZas2.Typ<>ct_integer)) then
                 begin
                  ErrorHandle^.NewValue('OP OR',err_typecheck);
                  exit;
                 end;
                if (PolZas1.Typ=ct_logic) then
                 begin
                  PolZas3.Typ:=ct_logic;
                  PolZas3.HBoolean:=PolZas1.HBoolean or PolZas2.HBoolean;
                 end;
                if (PolZas1.Typ=ct_integer) then
                 begin
                  PolZas3.Typ:=ct_integer;
                  PolZas3.HLongint:=PolZas1.HLongint or PolZas2.HLongint;
                 end;
                Zasobnik^.Vloz(PolZas3);
              end;   { or }
        in_xor:begin { xor }
                if not Zasobnik^.Vyber(PolZas2) then exit;
                if not Zasobnik^.Vyber(PolZas1) then exit;
                if ((PolZas1.Typ<>ct_logic)or(PolZas2.Typ<>ct_logic))and
                   ((PolZas1.Typ<>ct_integer)or(PolZas2.Typ<>ct_integer)) then
                 begin
                  ErrorHandle^.NewValue('OP XOR',err_typecheck);
                  exit;
                 end;
                if (PolZas1.Typ=ct_logic) then
                 begin
                  PolZas3.Typ:=ct_logic;
                  PolZas3.HBoolean:=PolZas1.HBoolean xor PolZas2.HBoolean;
                 end;
                if (PolZas1.Typ=ct_integer) then
                 begin
                  PolZas3.Typ:=ct_integer;
                  PolZas3.HLongint:=PolZas1.HLongint xor PolZas2.HLongint;
                 end;
                Zasobnik^.Vloz(PolZas3);
               end;  { xor }
        in_bitshift:;
       end; { case Cislo }
      end; { ObsluhaLog }

     function ObsluhaAritm(Cislo:word):bool;
      var PolZas1, PolZas2, PolZas3: TPolZas;
	  Pom:real;
	  A,B:TReal;
      begin { ObsluhaAritm }
       case Cislo of
	 in_mul:begin { mul }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if not Zasobnik^.Vyber(PolZas2) then exit;
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Integer;
		   PolZas3.HLongint:=PolZas1.HLongint*PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Integer) then
                  begin
                   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal*PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HLongint*PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal*PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else ErrorHandle^.NewValue('OP MUL',err_typecheck);
		end;  { mul }
	 in_add:begin { add }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if not Zasobnik^.Vyber(PolZas2) then exit;
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Integer;
		   PolZas3.HLongint:=PolZas1.HLongint+PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal+PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Real) then
		  begin
                   PolZas3.Typ:=ct_Real;
                   PolZas3.HReal:=PolZas1.HLongint+PolZas2.HReal;
                   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal+PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else ErrorHandle^.NewValue('OP ADD',err_typecheck);
		end;  { add }
	 in_div:begin { div - A/B}
		 if not Zasobnik^.Vyber(PolZas2) then exit; { B }
		 if not Zasobnik^.Vyber(PolZas1) then exit; { A }
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_real;
		   PolZas3.HReal:=PolZas1.HLongint/PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal/PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HLongint/PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal/PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else ErrorHandle^.NewValue('OP DIV',err_typecheck);
		end;  { div }
	 in_idiv:begin { idiv - A div B }
		 if not Zasobnik^.Vyber(PolZas2) then exit; { B }
		 if not Zasobnik^.Vyber(PolZas1) then exit; { A }
		 if (PolZas1.Typ<>ct_Integer) or (PolZas2.Typ<>ct_Integer) then
		  begin
                       ErrorHandle^.NewValue('OP IDIV',err_typecheck);
                       exit;
		  end;
                     if PolZas2.HLongint=0 then
                      begin
                       ErrorHandle^.NewValue('OP IDIV',err_undefinedresult);
                       exit;
                      end;
                     with PolZas3 do
                      begin
                       Typ:=ct_Integer;
                       HLongint:=PolZas1.HLongint div PolZas2.HLongint;
                      end;
                     Zasobnik^.Vloz(PolZas3);
                   end;  { idiv }
	 in_mod:begin { mod }
		 if not Zasobnik^.Vyber(PolZas2) then exit; { B }
		 if not Zasobnik^.Vyber(PolZas1) then exit; { A }
		 if (PolZas1.Typ<>ct_Integer) or (PolZas2.Typ<>ct_Integer) then
		  begin
                       ErrorHandle^.NewValue('OP MOD',err_typecheck);
                       exit;
		  end;
                     if PolZas2.HLongint=0 then
                      begin
                       ErrorHandle^.NewValue('OP MOD',err_undefinedresult);
                       exit;
                      end;
                     with PolZas3 do
                      begin
                       Typ:=ct_Integer;
                       HLongint:=PolZas1.HLongint mod PolZas2.HLongint;
                      end;
                     Zasobnik^.Vloz(PolZas3);
                  end;  { mod }
	 in_sub:begin { sub }
		 if not Zasobnik^.Vyber(PolZas2) then exit;
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Integer;
		   PolZas3.HLongint:=PolZas1.HLongint-PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Integer) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal-PolZas2.HLongint;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Integer) and (PolZas2.Typ=ct_Real) then
		  begin
                   PolZas3.Typ:=ct_Real;
                   PolZas3.HReal:=PolZas1.HLongint-PolZas2.HReal;
                   Zasobnik^.Vloz(PolZas3);
		  end                                   else
		 if (PolZas1.Typ=ct_Real) and (PolZas2.Typ=ct_Real) then
		  begin
		   PolZas3.Typ:=ct_Real;
		   PolZas3.HReal:=PolZas1.HReal-PolZas2.HReal;
		   Zasobnik^.Vloz(PolZas3);
		  end                                   else ErrorHandle^.NewValue('OP SUB',err_typecheck);
                  end;  { sub }
	 in_abs:begin { abs }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP ABS',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then
                      begin
		   Polzas2.Typ:=ct_integer;
		   PolZas2.HLongint:=abs(PolZas1.HLongint);
                      end		       else
                      begin
		   Polzas2.Typ:=ct_real;
                       PolZas2.HReal:=abs(PolZas1.HReal);
                      end;
		 if not Zasobnik^.Vloz(PolZas2) then exit;
                  end;  { abs }
	 in_neg:begin { neg }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP NEG',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then
                      begin
		   Polzas2.Typ:=ct_integer;
		   PolZas2.HLongint:=-PolZas1.HLongint;
                      end		       else
                      begin
		   Polzas2.Typ:=ct_real;
                       PolZas2.HReal:=-PolZas1.HReal;
                      end;
		 if not Zasobnik^.Vloz(PolZas2) then exit;
                  end;  { neg }
	 in_ceiling:begin { ceiling }
		   if not Zasobnik^.Vyber(PolZas1) then exit;
		   if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		    begin
		     ErrorHandle^.NewValue('OP CEILING',err_typecheck);
		     exit;
		    end;
		   if PolZas1.Typ=ct_integer then
                        begin
		     Polzas2.Typ:=ct_integer;
		     PolZas2.HLongint:=round(PolZas1.HLongint+0.49999);
                        end		       else
                        begin
		     Polzas2.Typ:=ct_real;
                         PolZas2.HReal:=round(PolZas1.HReal+0.49999);
                        end;
		   if not Zasobnik^.Vloz(PolZas2) then exit;
                      end;  { ceiling }
	 in_floor:begin { floor }
		   if not Zasobnik^.Vyber(PolZas1) then exit;
		   if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		    begin
		     ErrorHandle^.NewValue('OP FLOOR',err_typecheck);
		     exit;
		    end;
		   if PolZas1.Typ=ct_integer then
                        begin
		     Polzas2.Typ:=ct_integer;
		     PolZas2.HLongint:=round(PolZas1.HLongint-0.49999);
                        end		       else
                        begin
		     Polzas2.Typ:=ct_real;
                         PolZas2.HReal:=int(PolZas1.HReal-0.49999);
                        end;
		   if not Zasobnik^.Vloz(PolZas2) then exit;
                    end;  { floor }
	 in_round:begin { round }
		   if not Zasobnik^.Vyber(PolZas1) then exit;
		   if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		    begin
		     ErrorHandle^.NewValue('OP ROUND',err_typecheck);
		     exit;
		    end;
		   if PolZas1.Typ=ct_integer then
                        begin
		     Polzas2.Typ:=ct_integer;
		     PolZas2.HLongint:=round(PolZas1.HLongint);
                        end		       else
                        begin
		     Polzas2.Typ:=ct_real;
                         PolZas2.HReal:=round(PolZas1.HReal);
                        end;
		   if not Zasobnik^.Vloz(PolZas2) then exit;
                    end;  { round }
	 in_truncate:begin { truncate }
		    if not Zasobnik^.Vyber(PolZas1) then exit;
		    if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		     begin
		      ErrorHandle^.NewValue('OP TRUNCATE',err_typecheck);
		      exit;
		     end;
		    if PolZas1.Typ=ct_integer then
                         begin
		      Polzas2.Typ:=ct_integer;
		      PolZas2.HLongint:=trunc(PolZas1.HLongint);
                         end		       else
                         begin
		      Polzas2.Typ:=ct_real;
                          PolZas2.HReal:=int(PolZas1.HReal);
                         end;
		    if not Zasobnik^.Vloz(PolZas2) then exit;
                       end;  { truncate }
	 in_sqrt:begin { sqrt }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP SQRT',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then Pom:=PolZas1.HLongint
				        else Pom:=PolZas1.HReal;
                     if Pom<0 then
                      begin
                       ErrorHandle^.NewValue('OP SQRT',err_rangecheck);
		   exit;
                      end;
		 Pom:=sqrt(Pom);
		 Polzas2.Typ:=ct_real;
		 PolZas2.HReal:=Pom;
		 if not Zasobnik^.Vloz(PolZas2) then exit;
                   end;  { sqrt }
	 in_atan:begin { atan }
		 if not Zasobnik^.Vyber(PolZas2) then exit; { B }
		 if not Zasobnik^.Vyber(PolZas1) then exit; { A }
		 if (PolZas1.Typ<>ct_Integer)and(PolZas1.Typ<>ct_Real) or
                        (PolZas2.Typ<>ct_Integer)and(PolZas2.Typ<>ct_Real) then
		  begin
                       ErrorHandle^.NewValue('OP ATAN',err_typecheck);
                       exit;
		  end;
                     if PolZas1.Typ=ct_Integer then A:=PolZas1.HLongint
                                               else A:=PolZas1.HReal;
                     if PolZas2.Typ=ct_Integer then B:=PolZas2.HLongint
                                               else B:=PolZas2.HReal;
                     if (A=0)and(B=0) then
                      begin
                       ErrorHandle^.NewValue('OP ATAN',err_undefinedresult);
                       exit;
                      end;
                     if B=0 then
                      if A>0 then
                       begin
                        PolZas3.Typ:=ct_Real;
                        PolZas3.HReal:=90;
                        Zasobnik^.Vloz(PolZas3);
                        exit;
                       end   else
                       begin
                        PolZas3.Typ:=ct_Real;
                        PolZas3.HReal:=270;
                        Zasobnik^.Vloz(PolZas3);
                        exit;
                       end;
                     with PolZas3 do
                      begin
                       PolZas3.Typ:=ct_Real;
                       PolZas3.HReal:=arctan(A/B)/2/pi*360;
                      end;
                     Zasobnik^.Vloz(PolZas3);
                   end;  { atan }
	 in_cos:begin { cos }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP COS',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then Pom:=PolZas1.HLongint
					   else Pom:=PolZas1.HReal;
		 Pom:=cos(Pom*2*pi/360);
		 Polzas2.Typ:=ct_real;
		 PolZas2.HReal:=Pom;
		 if not Zasobnik^.Vloz(PolZas2) then exit;
		end;  { cos }
	 in_sin:begin { sin }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP SIN',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then Pom:=PolZas1.HLongint
					   else Pom:=PolZas1.HReal;
		 Pom:=sin(Pom*2*pi/360);
		 Polzas2.Typ:=ct_real;
		 PolZas2.HReal:=Pom;
		 if not Zasobnik^.Vloz(PolZas2) then exit;
		end;  { sin }
	 in_exp:begin   { exp }
	         if not Zasobnik^.Vyber(PolZas2) then exit; { B }
	         if not Zasobnik^.Vyber(PolZas1) then exit; { A }
	         if ((PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer))or
                      ((PolZas2.Typ<>ct_real)and(PolZas2.Typ<>ct_integer)) then
		begin
		 ErrorHandle^.NewValue('OP EXP',err_typecheck);
		 exit;
		end;
	         if PolZas1.Typ=ct_integer then A:=PolZas1.HLongint
				     else A:=PolZas1.HReal;
	         if PolZas2.Typ=ct_integer then B:=PolZas2.HLongint
				     else B:=PolZas2.HReal;

                   PolZas3.Typ:=ct_real;
	         PolZas3.HReal:=exp(ln(A)*B);
	         if not Zasobnik^.Vloz(PolZas3) then exit;
                  end;    { exp }
	 in_ln:begin { ln }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP LN',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then Pom:=PolZas1.HLongint
				       else Pom:=PolZas1.HReal;
		 PolZas2.Typ:=ct_real;
		 PolZas2.HReal:=ln(Pom);
		 if not Zasobnik^.Vloz(PolZas2) then exit;
                 end;  { ln }
	 in_log:begin { log }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP LOG',err_typecheck);
		   exit;
		  end;
		 if PolZas1.Typ=ct_integer then Pom:=PolZas1.HLongint
				       else Pom:=PolZas1.HReal;
		 PolZas2.Typ:=ct_real;
		 PolZas2.HReal:=ln(Pom)/ln(10);
		 if not Zasobnik^.Vloz(PolZas2) then exit;
                  end;  { log }
	 in_rand:begin { rand }
                    PolZas1.Typ:=ct_integer;
                    PolZas1.HLongint:=65535*random(65535);
                    Zasobnik^.Vloz(PolZas1);
                   end;  { rand }
	 in_srand:begin { srand }
		 if not Zasobnik^.Vyber(PolZas1) then exit;
		 if (PolZas1.Typ<>ct_real)and(PolZas1.Typ<>ct_integer) then
		  begin
		   ErrorHandle^.NewValue('OP SRAND',err_typecheck);
		   exit;
		  end;
                     randomize;
                    end;  { srand }
	 in_rrand:begin { rrand }
                     PolZas1.Typ:=ct_Integer;
                     PolZas1.HLongint:=0;
                    end;  { rrand }
       end; { case Cislo }
      end;  { ObsluhaAritm }

     function ObsluhaArray(Cislo:word):bool;
      var PolZas1, PolZas2, PolZas3: TPolZas;
	  i:longint;
      begin { ObsluhaArray }
       case Cislo of
	 in_array:begin { array }
		   if not Zasobnik^.Vyber(PolZas1) then exit;
		   if PolZas1.Typ<>ct_integer then
		    begin
		     ErrorHandle^.NewValue('OP ARRAY',err_typecheck);
		     exit;
		    end;
		   PolZas3.Typ:=ct_null;   { objekt bez vyznamu }
                   with PolZas2 do
                    begin
                     Typ:=ct_array;
		     VMem^.Alloc(new(PProc,Init(VMem,PolZas1.HLongint)),HPProc);
		     for i:=1 to PolZas1.HLongint do PProc(VMem^.GetPointer(HPProc))^.PlusPrvek(TPolProc(PolZas3));
		    end;
                   Zasobnik^.Vloz(PolZas2);
                  end;  { array }
         in_aload:begin { aload }
                   if not Zasobnik^.Vyber(PolZas1) then exit;
                   if PolZas1.Typ<>ct_Array then
		    begin
		     ErrorHandle^.NewValue('OP ALOAD',err_Typecheck);
                     exit;
                    end;
		   for i:=1 to PProc(VMem^.GetPointer(PolZas1.HPProc))^.Count do
                    begin
		     PProc(VMem^.GetPointer(PolZas1.HPProc))^.Element(i,TPolProc(PolZas2));
                     if not Zasobnik^.Vloz(PolZas2) then exit;
                    end;
		   Zasobnik^.Vloz(PolZas1);
                  end;  { aload }
         in_astore:begin
                    if not Zasobnik^.Vyber(PolZas1) then exit;
                    if PolZas1.Typ<>ct_Array then
		     begin
		      ErrorHandle^.NewValue('OP ASTORE',err_Typecheck);
		      exit;
                     end;
		    for i:=1 to PProc(VMem^.GetPointer(PolZas1.HPProc))^.Count do
                     begin
                      if not Zasobnik^.Vyber(PolZas2) then exit;
		      PProc(VMem^.GetPointer(PolZas1.HPProc))^.ProcBox^[i]:=TPolProc(PolZas2);
		     end;
                    Zasobnik^.Vloz(PolZas1);
                   end;
       end; { case Cislo }
      end;  { ObsluhaArray }

     function ObsluhaString(Cislo:word):bool;
      var PolZas1, PolZas2, PolZas3: TPolZas;
          Pom:array [0..1] of char;
      begin { ObsluhaString }
       case Cislo of
        in_string:begin { string }
                   if not Zasobnik^.Vyber(PolZas1) then exit;
                   if PolZas1.Typ<>ct_integer then
		    begin
		     ErrorHandle^.NewValue('OP STRING',err_typecheck);
		     exit;
                    end;
                   with PolZas2 do
                    begin
                     Typ:=ct_string;
                     Pom[0]:=#0; { prazdny retezec }
		     VMem^.Alloc(new(PRet,Init(VMem,Pom,PolZas1.HLongint)),HPRet);
                    end;
                   Zasobnik^.Vloz(PolZas2);
                  end;  { string }
       end; { case Cislo }
      end;  { ObsluhaString }

     function ObsluhaMsc(Cislo:word):bool;
      var PolZas1, PolZas2, PolZas3: TPolZas;
          Pom:array [0..1] of char;
          XProc:PProc;
          Prvek:TPolProc;
          i:longint;
          P:TPolozka;
          Vysl:boolean;
          Tab,Kde:word;
      begin { ObsluhaMsc }
       case Cislo of
        in_bind:begin { bind }
                 if not Zasobnik^.Vyber(PolZas1) then exit;
                 if PolZas1.Typ<>ct_proc then
	        begin
	         ErrorHandle^.NewValue('OP BIND',err_typecheck);
     	         exit;
                  end;

{ Zamena jmen za operatory - zacatek }
                 XProc:=PProc(VMem^.GetPointer(PolZas1.HPProc));
                 with XProc^ do
                  begin
                   for i:=ProcBox^[0].HLongint downto 1 do
                    begin
                     Prvek:=ProcBox^[i];
                     if Prvek.Typ=ct_Name then
                      begin
  		   P.Op:=Prvek.Uk;
     		   Vysl:=SlovZas^.Find(P,Tab,Kde);
      		   if Vysl and (P.Typ=ct_ImpProc) then
   		    begin
		     with Prvek do
                          begin
                           Typ:=P.Typ;
                           Whole:=P.Hodnota.Whole;
                           ProcBox^[i]:=Prvek;
                          end;
                        end;
                      end;
                    end;
                  end;
{ Zamena jmen za operatory - konec }

                   Zasobnik^.Vloz(PolZas1);
                end; { bind }
        in_null:;
        in_usertime:;
        in_version:;
       end; { case Cislo }
      end;  { ObsluhaMsc }

     function ObsluhaCoordMatrix(Cislo:word):bool;
      var Polzas1,PolZas2,PolZas3:TPolZas;
	  GrSt:PGraphState;
          CTM,Matr:PMatrix;
          X,Y:TReal;
      begin { ObsluhaCoordMatrix }
       if Graphstate=NULL then begin
				ErrorHandle^.NewValue('Coord matrix support / GraphState=NULL',err_criticalerror);
                                ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
				exit;
                               end;
       GrSt:=PGraphState(VMem^.GetPointer(GraphState));
       if GrSt^.CTM=NULL then
        begin
         ErrorHandle^.NewValue('Coord matrix support / CTM=NULL',err_criticalerror);
	 ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
         exit;
        end;
       CTM:=PMatrix(VMem^.GetPointer(GrSt^.CTM));
       case Cislo of
        in_matrix:begin { matrix }
                   with PolZas1 do
                    begin
                     Typ:=ct_matrix;
		 VMem^.Alloc(new(PMatrix,Init(VMem)),HPCompObject);
                    end;
                   if not Zasobnik^.Vloz(PolZas1) then exit;
                  end;  { matrix }
        in_initmatrix:begin { initmatrix }
		   OutDevice^.SetCTMMatrix(CTM);
                      end;  { initmatrix }
        in_identmatrix:begin { identmatrix }
                        if not Zasobnik^.Vyber(PolZas1) then exit; { matrix }
                        if PolZas1.Typ<>ct_matrix then
                         begin
		      ErrorHandle^.NewValue('OP IDENTMATRIX',err_typecheck);
                          exit;
                         end;
                        Matr:=PMatrix(VMem^.GetPointer(PolZas1.HPCompObject));
                        Matr^.NewValue(1,0,0,0,1,0);
                        if not Zasobnik^.Vloz(PolZas1) then exit;
                       end;  { identmatrix }
        in_defaultmatrix:begin { defaultmatrix }
                          if not Zasobnik^.Vyber(PolZas1) then exit; { matrix }
                          if PolZas1.Typ<>ct_matrix then
                           begin
		        ErrorHandle^.NewValue('OP IDENTMATRIX',err_typecheck);
                            exit;
                           end;
                          Matr:=PMatrix(VMem^.GetPointer(PolZas1.HPCompObject));
                          OutDevice^.SetCTMMatrix(Matr);
                          if not Zasobnik^.Vloz(PolZas1) then exit;
                         end;  { defaultmatrix }
        in_currentmatrix:begin { currentmatrix }
                          if not Zasobnik^.Vyber(PolZas1) then exit; { matrix }
                          if PolZas1.Typ<>ct_matrix then
                           begin
		        ErrorHandle^.NewValue('OP CURRENTMATRIX',err_typecheck);
                            exit;
                           end;
                          Matr:=PMatrix(VMem^.GetPointer(PolZas1.HPCompObject));
                          with CTM^ do Matr^.NewValue(XX,XY,XT,YX,YY,YT);
                          if not Zasobnik^.Vloz(PolZas1) then exit;
                         end;  { currentmatrix }
        in_setmatrix:begin { setmatrix }
                      if not Zasobnik^.Vyber(PolZas1) then exit; { matrix }
                      if PolZas1.Typ<>ct_matrix then
                       begin
		    ErrorHandle^.NewValue('OP SETMATRIX',err_typecheck);
                        exit;
                       end;
                      Matr:=PMatrix(VMem^.GetPointer(PolZas1.HPCompObject));
                      with Matr^ do CTM^.NewValue(XX,XY,XT,YX,YY,YT);
                     end;  { setmatrix }
        in_translate:begin { translate }
                      if not Zasobnik^.Vyber(PolZas3) then exit; { Matice nebo t2 }
		      if PolZas3.Typ=ct_Matrix then
                       begin
                        Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPCompObject));
                        if not Zasobnik^.Vyber(PolZas2) then exit; { t2 }
                       end
                                               else
                       begin
                        Matr:=CTM;
                        PolZas2:=PolZas3;
		   end;
                      if not Zasobnik^.Vyber(PolZas1) then exit; { t1 }
                      if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                         (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
                           begin
		        ErrorHandle^.NewValue('OP TRANSLATE',err_typecheck);
                            exit;
		       end;
                      with PolZas1 do
                       if Typ=ct_integer then X:=HLongint
                                         else X:=HReal;
                      with PolZas2 do
                       if Typ=ct_integer then Y:=HLongint
					 else Y:=HReal;
                      Translate(Matr,X,Y);
                     end;  { translate }
        in_scale:begin { scale }
                      if not Zasobnik^.Vyber(PolZas3) then exit; { Matice nebo s2 }
                      if PolZas3.Typ=ct_Matrix then
                       begin
                        Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPCompObject));
                        if not Zasobnik^.Vyber(PolZas2) then exit; { s2 }
		       end
                                               else
                       begin
                        Matr:=CTM;
                        PolZas2:=PolZas3;
		       end;
                      if not Zasobnik^.Vyber(PolZas1) then exit; { s1 }
		      if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
			 (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
			   begin
			    ErrorHandle^.NewValue('OP SCALE',err_typecheck);
			    exit;
			   end;
		      with PolZas1 do
		       if Typ=ct_integer then X:=HLongint
					 else X:=HReal;
		      with PolZas2 do
		       if Typ=ct_integer then Y:=HLongint
					 else Y:=HReal;
		      Scale(Matr,X,Y);
		 end;  { scale }
	in_rotate:begin { rotate }
		   if not Zasobnik^.Vyber(PolZas2) then exit; { Matice nebo uhel }
                   if PolZas2.Typ=ct_Matrix then
                    begin
                     Matr:=PMatrix(VMem^.GetPointer(PolZas2.HPCompObject));
                     if not Zasobnik^.Vyber(PolZas1) then exit; { Angle }
		    end
                                            else
                    begin
                     Matr:=CTM;
                     PolZas1:=PolZas2;
                    end;
		   if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real) THEN
			begin
			 ErrorHandle^.NewValue('OP ROTATE',err_typecheck);
                         exit;
                        end;
                   with PolZas1 do
                    if Typ=ct_integer then X:=HLongint
                                      else X:=HReal;
                   Rotate(Matr,X);
                  end;  { rotate }
        in_concat:begin { concat }
                   if not Zasobnik^.Vyber(PolZas1) then exit; { matrix }
                   if PolZas1.Typ<>ct_matrix then
                    begin
		 ErrorHandle^.NewValue('OP CONCAT',err_typecheck);
                     exit;
                    end;
                   Matr:=PMatrix(VMem^.GetPointer(PolZas1.HPCompObject));
                   CTM^.Concat(Matr);
                   if not Zasobnik^.Vloz(PolZas1) then exit;
                  end;  { concat }
        in_concatmatrix:begin { concatmatrix }
                         if not Zasobnik^.Vyber(PolZas3) then exit; { matrix3 }
                         if not Zasobnik^.Vyber(PolZas2) then exit; { matrix2 }
                         if not Zasobnik^.Vyber(PolZas1) then exit; { matrix1 }
                         if (PolZas1.Typ<>ct_matrix)or(PolZas2.Typ<>ct_matrix)or(PolZas3.Typ<>ct_matrix) then
                          begin
		       ErrorHandle^.NewValue('OP CONCATMATRIX',err_typecheck);
                           exit;
                          end;
                         Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPMatrix));
                         with PMatrix(VMem^.GetPointer(PolZas1.HPMatrix))^ do
                          begin
                           Matr^.XX:=XX;
                           Matr^.XY:=YX;
                           Matr^.XT:=XT;
                           Matr^.YX:=YX;
                           Matr^.YY:=YY;
                           Matr^.YT:=YT;
                           Matr^.Concat(PMatrix(Self.VMem^.GetPointer(PolZas2.HPMatrix)));
                          end;
                        end;  { concatmatrix }
        in_transform:begin { transform }
                      if not Zasobnik^.Vyber(PolZas3) then exit; { matrix3 }
                      if PolZas3.Typ=ct_matrix then
                       begin
                        Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPMatrix));
                        if not Zasobnik^.Vyber(PolZas2) then exit;
                       end                      else
                       begin
                        Matr:=CTM;
                        PolZas2:=PolZas3;
                       end;
                      if not Zasobnik^.Vyber(PolZas1) then exit; { matrix1 }
                      if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
		     (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
		       begin
		        ErrorHandle^.NewValue('OP TRANSFORM',err_typecheck);
		        exit;
		       end;
                      with PolZas1 do
                       if Typ=ct_integer then X:=HLongint
                                         else X:=HReal;
                      with PolZas2 do
                       if Typ=ct_integer then Y:=HLongint
                                         else Y:=HReal;
                      Transcoord(Matr,X,Y,X,Y);
                      with PolZas1 do
                       begin
                        Typ:=ct_real;
                        HReal:=X;
                       end;
                      with PolZas2 do
                       begin
                        Typ:=ct_real;
                        HReal:=Y;
                       end;
                      if not Zasobnik^.Vloz(PolZas1) then exit;
                      if not Zasobnik^.Vloz(PolZas2) then exit;
                     end;  { transform }
        in_dtransform:begin { dtransform }
                       if not Zasobnik^.Vyber(PolZas3) then exit; { matrix3 }
                       if PolZas3.Typ=ct_matrix then
                        begin
                         Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPMatrix));
                         if not Zasobnik^.Vyber(PolZas2) then exit;
                        end                      else
                        begin
                         Matr:=CTM;
                         PolZas2:=PolZas3;
                        end;
                       if not Zasobnik^.Vyber(PolZas1) then exit; { matrix1 }
                       if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
		      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
		        begin
		         ErrorHandle^.NewValue('OP DTRANSFORM',err_typecheck);
		         exit;
		        end;
                       with PolZas1 do
                        if Typ=ct_integer then X:=HLongint
                                          else X:=HReal;
                       with PolZas2 do
                        if Typ=ct_integer then Y:=HLongint
                                          else Y:=HReal;
                       DeltaTransCoord(Matr,X,Y,X,Y);
                       with PolZas1 do
                        begin
                         Typ:=ct_real;
                         HReal:=X;
                        end;
                       with PolZas2 do
                        begin
                         Typ:=ct_real;
                         HReal:=Y;
                        end;
                      if not Zasobnik^.Vloz(PolZas1) then exit;
                      if not Zasobnik^.Vloz(PolZas2) then exit;
                      end;  { dtransform }
        in_itransform:begin { itransform }
                       if not Zasobnik^.Vyber(PolZas3) then exit; { matrix3 }
                       if PolZas3.Typ=ct_matrix then
                        begin
                         Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPMatrix));
                         if not Zasobnik^.Vyber(PolZas2) then exit;
                        end                      else
                        begin
                         Matr:=CTM;
                         PolZas2:=PolZas3;
                        end;
                       if not Zasobnik^.Vyber(PolZas1) then exit; { matrix1 }
                       if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
		      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
		        begin
		         ErrorHandle^.NewValue('OP ITRANSFORM',err_typecheck);
		         exit;
		        end;
                       with PolZas1 do
                        if Typ=ct_integer then X:=HLongint
                                          else X:=HReal;
                       with PolZas2 do
                        if Typ=ct_integer then Y:=HLongint
                                          else Y:=HReal;
                       InvertTransCoord(Matr,X,Y,X,Y);
                       with PolZas1 do
                        begin
                         Typ:=ct_real;
                         HReal:=X;
                        end;
                       with PolZas2 do
                        begin
                         Typ:=ct_real;
                         HReal:=Y;
                        end;
                      if not Zasobnik^.Vloz(PolZas1) then exit;
                      if not Zasobnik^.Vloz(PolZas2) then exit;
                      end;  { itransform }
        in_idtransform:begin { idtransform }
                        if not Zasobnik^.Vyber(PolZas3) then exit; { matrix3 }
                        if PolZas3.Typ=ct_matrix then
                         begin
                          Matr:=PMatrix(VMem^.GetPointer(PolZas3.HPMatrix));
                          if not Zasobnik^.Vyber(PolZas2) then exit;
                         end                      else
                         begin
                          Matr:=CTM;
                          PolZas2:=PolZas3;
                         end;
                        if not Zasobnik^.Vyber(PolZas1) then exit; { matrix1 }
                        if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
		       (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
		         begin
		          ErrorHandle^.NewValue('OP IDTRANSFORM',err_typecheck);
		          exit;
		         end;
                        with PolZas1 do
                         if Typ=ct_integer then X:=HLongint
                                           else X:=HReal;
                        with PolZas2 do
                         if Typ=ct_integer then Y:=HLongint
                                           else Y:=HReal;
                        InvertDeltaTransCoord(Matr,X,Y,X,Y);
                        with PolZas1 do
                         begin
                          Typ:=ct_real;
                          HReal:=X;
                         end;
                        with PolZas2 do
                         begin
                          Typ:=ct_real;
                          HReal:=Y;
                         end;
                        if not Zasobnik^.Vloz(PolZas1) then exit;
                        if not Zasobnik^.Vloz(PolZas2) then exit;
                       end;  { idtransform }
        in_invertmatrix:begin { invertmatrix }
                         if not Zasobnik^.Vyber(PolZas2) then exit;
                         if not Zasobnik^.Vyber(PolZas1) then exit;
                         if (PolZas1.Typ<>ct_matrix)or(PolZas2.Typ<>ct_matrix) then
                          begin
		       ErrorHandle^.NewValue('OP INVERTMATRIX',err_typecheck);
     	                 exit;
                          end;
                         with PMatrix(VMem^.GetPointer(PolZas1.HPMatrix))^ do
                          begin
                           Matr:=PMatrix(Self.VMem^.GetPointer(PolZas2.HPMatrix));
                           Matr^.NewValue(XX,XY,XT,YX,YY,YT);
                          end;
                         if not Zasobnik^.Vloz(PolZas2) then exit;
                        end;  { invertmatrix }
       end;  { case Cislo }
      end;  { ObsluhaCoordMatrix }

     function ObsluhaGraphState(Cislo:word):bool;
      var GrSt:PGraphState;
	  GrPh,ClPh:PgraphPath;
	  CTMT:PMatrix;
	  El:TGraphSaveRecord;
	  PolZas1,PolZas2,PolZas3:TPolZas;
	  R,G,B,H,S,V:TReal;
	  BR,BG,BB:BYTE;
      begin { ObsluhaGraphstate }
       if Graphstate=NULL then begin
				ErrorHandle^.NewValue('Graph State Support / GraphState=NULL',err_criticalerror);
				ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
				exit;
			       end;
       GrSt:=PGraphState(VMem^.GetPointer(GraphState));
       if GrSt^.Path=NULL then begin
				ErrorHandle^.NewValue('Graph State Support / GraphPath=NULL',err_criticalerror);
				ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
				exit;
			       end;
       if GrSt^.CTM=NULL then begin
			       ErrorHandle^.NewValue('Graph State Support / CTM=NULL',err_criticalerror);
			       ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			       exit;
			      end;
       case Cislo of
	in_gsave:begin { gsave }
		  with El do
		   begin
		    XGraphState:=Graphstate;
		    XGraphPath:=GrSt^.Path;
		    XClipPath:=GrSt^.ClipPath;
		    XCTM:=GrSt^.CTM;
		   end;
		  if not Graphstack^.Push(El) then exit; { limit check error }
		 end;  { gsave }
	in_grestore:begin { grestore }
		     if GraphStack^.Pop(El) then
		       with El do
			begin
			 VMem^.Dec(GraphState);
			 VMem^.Dec(GrSt^.Path);
			 if GrSt^.ClipPath<>NULL then VMem^.Dec(GrSt^.ClipPath);
			 VMem^.Dec(GrSt^.CTM);
			 GraphState:=XGraphState;
			 GrSt:=PGraphState(VMem^.GetPointer(GraphState));
			 VMem^.Inc(GraphState);
			 VMem^.Inc(GrSt^.Path);
			 if GrSt^.ClipPath<>NULL then VMem^.Inc(GrSt^.ClipPath);
			 VMem^.Inc(GrSt^.CTM);
			end;
		    end;  { grestore }
	in_grestoreall:begin { grestoreall }
                          if not GraphStack^.IsEmpty then
                           begin
                            repeat
                             GraphStack^.Pop(El);
                            until GraphStack^.IsEmpty;
		        with El do
			 begin
			  VMem^.Dec(GraphState);
			  VMem^.Dec(GrSt^.Path);
			  if GrSt^.ClipPath<>NULL then VMem^.Dec(GrSt^.ClipPath);
			  VMem^.Dec(GrSt^.CTM);
			  GraphState:=XGraphState;
			  GrSt:=PGraphState(VMem^.GetPointer(GraphState));
			  VMem^.Inc(GraphState);
			  VMem^.Inc(GrSt^.Path);
			  if GrSt^.ClipPath<>NULL then VMem^.Inc(GrSt^.ClipPath);
			  VMem^.Inc(GrSt^.CTM);
			 end;
                           end;
                         end;  { grestoreall }
	in_initgraphics:;
	in_setlinewidth:begin { setlinewidth }
                           if not Zasobnik^.Vyber(PolZas1) then exit; {width}
                           if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real) then
                            begin
		         ErrorHandle^.NewValue('OP SETLINEWIDTH',err_typecheck);
     		         exit;
                            end;
                           if PolZas1.Typ=ct_integer then GrSt^.LWidth:=PolZas1.HLongint
                                                     else GrSt^.LWidth:=PolZas1.HReal;
                          end;  { setlinewidth }
	in_currentlinewidth:begin {currentlinewidth}
                               with PolZas1 do
                                begin
                                 Typ:=ct_real;
                                 PolZas1.HReal:=GrSt^.LWidth;
                                end;
                               if not Zasobnik^.Vloz(PolZas1) then exit;
                              end;  {currentlinewidth}
	in_setlinecap:begin { setlinecap }
                          if not Zasobnik^.Vyber(PolZas1) then exit;
                          if PolZas1.Typ<>ct_integer then
                           begin
           	        ErrorHandle^.NewValue('OP SETLINECAP',err_typecheck);
  		        exit;
                           end;
                          if (PolZas1.HLongint<0) or (PolZas1.HLongint>2) then
                           begin
           	        ErrorHandle^.NewValue('OP SETLINECAP',err_rangecheck);
  		        exit;
                           end;
                          GrSt^.LCap:=PolZas1.HLongint;
                        end;  { setlinecap }
	in_currentlinecap:begin { currentlinecap }
                             PolZas1.Typ:=ct_integer;
                             PolZas1.HLongint:=GrSt^.LCap;
                             if Zasobnik^.Vloz(PolZas1) then exit;
                            end;  { currentlinecap }
	in_setlinejoin:begin { setlinejoin }
                          if not Zasobnik^.Vyber(PolZas1) then exit;
                          if PolZas1.Typ<>ct_integer then
                           begin
           	        ErrorHandle^.NewValue('OP SETLINEJOIN',err_typecheck);
  		        exit;
                           end;
                          if (PolZas1.HLongint<0) or (PolZas1.HLongint>2) then
                           begin
           	        ErrorHandle^.NewValue('OP SETLINEJOIN',err_rangecheck);
  		        exit;
                           end;
                          GrSt^.LJoin:=PolZas1.HLongint;
                         end;  { setlinejoin }
	in_currentlinejoin:begin { currentlinejoin }
                              PolZas1.Typ:=ct_integer;
                              PolZas1.HLongint:=GrSt^.LJoin;
                              if Zasobnik^.Vloz(PolZas1) then exit;
                             end;  { currentlinejoin }
	in_setmiterlimit:begin { setmiterlimit }
                            if not Zasobnik^.Vyber(PolZas1) then exit;
                            if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real) then
                             begin
                              ErrorHandle^.NewValue('OP SETMITERLIMIT',err_typecheck);
     		          exit;
                             end;
                            if PolZas1.Typ=ct_integer then GrSt^.MiterLimit:=PolZas1.HLongint
                                                      else GrSt^.MiterLimit:=PolZas1.HReal;
                            with GrSt^ do
                             begin
                              if MiterLimit<1 then MiterLimit:=1;
                             end;
                           end;  { setmiterlimit }
	in_currentmiterlimit:begin { currentmiterlimit }
                                with PolZas1 do
                                 begin
                                  Typ:=ct_real;
                                  PolZas1.HReal:=GrSt^.MiterLimit;
                                 end;
                                if not Zasobnik^.Vloz(PolZas1) then exit;
                               end;  { currentmiterlimit }
	in_setdash:;
	in_currentdash:;
	in_setflat:begin { setlineflat }
                      if not Zasobnik^.Vyber(PolZas1) then exit;
                      if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real) then
                       begin
                        ErrorHandle^.NewValue('OP SETFLAT',err_typecheck);
     		    exit;
                       end;
                      if PolZas1.Typ=ct_integer then GrSt^.Flatness:=PolZas1.HLongint
                                                else GrSt^.Flatness:=PolZas1.HReal;
                      with GrSt^ do
                       begin
                        if Flatness<0.2 then Flatness:=0.2;
                        if FLatness>100 then Flatness:=100;
                       end;
                     end;  { setlineflat }
	in_currentflat:begin { currentflat }
                          with PolZas1 do
                           begin
                            Typ:=ct_real;
                            PolZas1.HReal:=GrSt^.Flatness;
                           end;
                          if not Zasobnik^.Vloz(PolZas1) then exit;
                         end;  { currentflat }
	in_setgray:begin { setgray }
		    if not Zasobnik^.Vyber(PolZas1) then exit; { gray scale }
		    if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real) then
		     begin
		      ErrorHandle^.NewValue('OP SETGRAY',err_typecheck);
		      exit;
		     end;
		    with PolZas1 do
		     if Typ=ct_integer then R:=HLongint
				       else R:=HReal;
		    if R<0 then R:=0; if R>1 then R:=1;
		    BR:=round(R*255);
		    GrSt^.Color:=RGB(BR,BR,BR);
		   end;  { setgray }
	in_currentgray:begin { current gray }
                          PolZas1.Typ:=ct_real;
                          PolZas2.HReal:=GetRValue(GrSt^.Color)/255;
                          if not Zasobnik^.Vloz(PolZas1) then exit;
                         end;  { current gray }
	in_sethsbcolor:begin { sethsbcolor }
			if not Zasobnik^.Vyber(PolZas3) then exit; { field V }
			if not Zasobnik^.Vyber(PolZas2) then exit; { field S }
			if not Zasobnik^.Vyber(PolZas1) then exit; { field H }
			if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
			   (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real)or
			   (PolZas3.Typ<>ct_integer)and(PolZas3.Typ<>ct_real) then
			     begin
			      ErrorHandle^.NewValue('OP SETHSBCOLOR',err_typecheck);
			      exit;
			     end;
			with PolZas1 do
			 if Typ=ct_integer then H:=HLongint
				         else H:=HReal;
			with PolZas2 do
			 if Typ=ct_integer then S:=HLongint
				         else S:=HReal;
			with PolZas3 do
			 if Typ=ct_integer then V:=HLongint
				         else V:=HReal;
			if H<0 then H:=0; if H>1 then H:=1;
			if S<0 then S:=0; if S>1 then S:=1;
			if V<0 then V:=0; if V>1 then V:=1;
                              H:=H*360;
                              HSVtoRGB(H,S,V,R,G,B);
			BR:=round(R*255);
			BG:=round(G*255);
			BB:=round(B*255);
			GrSt^.Color:=RGB(BR,BG,BB);
                         end;  { sethsbcolor }
	in_currenthsbcolor:begin { currenthsbcolor }
                              with GrSt^ do RGBtoHSV(GetRValue(Color),GetGValue(Color),GetBValue(Color),H,S,V);
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=H;
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=S;
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=V;
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                             end;  { currenthsbcolor }
	in_setrgbcolor:begin { setrgbcolor }
			if not Zasobnik^.Vyber(PolZas3) then exit; { field B }
			if not Zasobnik^.Vyber(PolZas2) then exit; { field G }
			if not Zasobnik^.Vyber(PolZas1) then exit; { field R }
			if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
			   (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real)or
			   (PolZas3.Typ<>ct_integer)and(PolZas3.Typ<>ct_real) then
			     begin
			      ErrorHandle^.NewValue('OP SETRGBCOLOR',err_typecheck);
			      exit;
			     end;
			with PolZas1 do
			 if Typ=ct_integer then R:=HLongint
					   else R:=HReal;
			with PolZas2 do
			 if Typ=ct_integer then G:=HLongint
					   else G:=HReal;
			with PolZas3 do
			 if Typ=ct_integer then B:=HLongint
					   else B:=HReal;
			if R<0 then R:=0; if R>1 then R:=1;
			if G<0 then G:=0; if G>1 then G:=1;
			if B<0 then B:=0; if B>1 then B:=1;
			BR:=round(R*255);
			BG:=round(G*255);
			BB:=round(B*255);
			GrSt^.Color:=RGB(BR,BG,BB);
		       end;  { setrgbcolor }
	in_currentrgbcolor:begin { currentrgbcolor }
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=GetRValue(GrSt^.Color);
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=GetGValue(GrSt^.Color);
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                              with PolZas1 do
                               begin
                                Typ:=ct_real;
                                HReal:=GetBValue(GrSt^.Color);
                               end;
                              if not Zasobnik^.Vloz(PolZas1) then exit;
                             end;  { currentrgbcolor }
	in_setscreen:;
	in_currentscreen:;
	in_settransfer:;
	in_currenttransfer:;
       end;  { case Cislo }
      end;  { ObsluhaGraphstate }

     function ObsluhaGraphPath(Cislo:word):bool;
      var Polzas1,PolZas2,PolZas3,PolZas4,PolZas5,Polzas6:TPolZas;
	  X,Y,R,Ang1,Ang2,X1,Y1,X2,Y2,X3,Y3,CX,CY:TReal;
	  GrSt:PGraphState;
	  Gr:PGraphPath;
      begin { ObsluhaGraphPath }
       if Graphstate=NULL then begin
				ErrorHandle^.NewValue('Graph path support / GraphState=NULL',err_criticalerror);
				ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
				exit;
			       end;
       GrSt:=PGraphState(VMem^.GetPointer(GraphState));
       if GrSt^.Path=NULL then
	begin
	 ErrorHandle^.NewValue('Graph path support / Path=NULL',err_criticalerror);
         ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
         exit;
        end;
       Gr:=PGraphPath(VMem^.GetPointer(GrSt^.Path));
       case Cislo of
        in_newpath:begin { newpath }
                     begin
                      VMem^.Dec(GrSt^.Path); { Snizeni poctu sdileni dosavadni graficke cesty }
		  VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.Path); { Vytvoreni nove prazdne graficke cesty }
                      VMem^.Inc(GrSt^.Path); { Zvyseni poctu sdileni nove graficke cesty }
                     end;
                   end;  { newpath }
        in_currentpoint:begin { currentpoint }
                         { aktualni bod se vraci v uzivatelske soustave souradnic }
                         { graficka cesta jej vsak uchovava v soustave souradnic }
                         { zarizeni, je treba provest inverzni konverzi }
                         if not Gr^.DefCurrPoint then
                          begin
                           ErrorHandle^.NewValue('OP CURRENTPOINT',err_NoCurrentPoint);
			   exit;
			  end;
                         with Gr^ do InvertTransCoord(PMatrix(PVirtMemory(VMem)^.GetPointer(GrSt^.CTM)),
                                                      CurrentPoint.X,CurrentPoint.Y,X,Y);
                         with PolZas1 do
                          begin
                           Typ:=ct_real;    { Ulozeni hodnoty X na zasobnik }
			   HReal:=X;
                           if not Zasobnik^.Vloz(PolZas1) then exit;
                           Typ:=ct_real;    { Ulozeni hodnoty Y na zasobnik }
                           HReal:=Y;
			   if not Zasobnik^.Vloz(PolZas1) then exit;
                          end;
                        end;  { currentpoint }
        in_moveto:begin { moveto }
                   if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice }
                   if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice }
                   if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
                        begin
                         ErrorHandle^.NewValue('OP MOVETO',err_typecheck);
                         exit;
			end;
		   with PolZas1 do
                    if Typ=ct_integer then X:=HLongint
                                      else X:=HReal;
                   with PolZas2 do
                    if Typ=ct_integer then Y:=HLongint
                                      else Y:=HReal;
		   Gr^.InsertMove(X,Y);
                  end;  { moveto }
        in_rmoveto:begin { rmoveto }
                    if not Gr^.DefCurrPoint then
		     begin
                      ErrorHandle^.NewValue('OP RMOVETO',err_NoCurrentPoint);
                      exit;
                     end;
                    if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice }
                    if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice }
		    if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
		       (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
			 begin
			  ErrorHandle^.NewValue('OP RMOVETO',err_typecheck);
			  exit;
			 end;
		    with PolZas1 do
                     if Typ=ct_integer then X:=HLongint
                                       else X:=HReal;
                    with PolZas2 do
                     if Typ=ct_integer then Y:=HLongint
                                       else Y:=HReal;
		    with Gr^ do InvertTransCoord(PMatrix(PVirtMemory(VMem)^.GetPointer(GrSt^.CTM)),
                                                  CurrentPoint.X,CurrentPoint.Y,X1,Y1);
                    Gr^.InsertMove(X1+X,Y1+Y);
                   end;  { rmoveto }
	in_lineto:begin { lineto }
                   if not Gr^.DefCurrPoint then
                    begin
                     ErrorHandle^.NewValue('OP LINETO',err_NoCurrentPoint);
                     exit;
                    end;
                   if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice }
                   if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice }
                   if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
                        begin
		     ErrorHandle^.NewValue('OP LINETO',err_typecheck);
			 exit;
                        end;
                   with PolZas1 do
                    if Typ=ct_integer then X:=HLongint
                                      else X:=HReal;
                   with PolZas2 do
                    if Typ=ct_integer then Y:=HLongint
                                      else Y:=HReal;
                   Gr^.InsertLine(X,Y);
                  end;  { lineto }
	in_rlineto:begin { rlineto }
                    if not Gr^.DefCurrPoint then
                     begin
                      ErrorHandle^.NewValue('OP RLINETO',err_NoCurrentPoint);
                      exit;
                     end;
                    if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice }
                    if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice }
                    if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                       (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real) then
                         begin
                          ErrorHandle^.NewValue('OP RLINETO',err_typecheck);
			  exit;
                         end;
                    with PolZas1 do
                     if Typ=ct_integer then X:=HLongint
                                       else X:=HReal;
                    with PolZas2 do
                     if Typ=ct_integer then Y:=HLongint
                                       else Y:=HReal;
                    with Gr^ do InvertTransCoord(PMatrix(PVirtMemory(VMem)^.GetPointer(GrSt^.CTM)),
                                                  CurrentPoint.X,CurrentPoint.Y,X1,Y1);
		    Gr^.Insertline(X1+X,Y1+Y);
                   end;  { rlineto }
        in_arc:begin { arc }
                   if not Zasobnik^.Vyber(PolZas5) then exit; { koncovy uhel Ang2 }
                   if not Zasobnik^.Vyber(PolZas4) then exit; { startovni uhel Ang1 }
                   if not Zasobnik^.Vyber(PolZas3) then exit; { polomer R }
                   if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice stredu }
                   if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice stredu }
                   if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real)or
                      (PolZas3.Typ<>ct_integer)and(PolZas3.Typ<>ct_real)or
                      (PolZas4.Typ<>ct_integer)and(PolZas4.Typ<>ct_real)or
		      (PolZas5.Typ<>ct_integer)and(PolZas5.Typ<>ct_real) then
                        begin
		     ErrorHandle^.NewValue('OP ARC',err_typecheck);
                         exit;
                        end;
                   with PolZas1 do
                    if Typ=ct_integer then X:=HLongint
                                      else X:=HReal;
                   with PolZas2 do
                    if Typ=ct_integer then Y:=HLongint
				      else Y:=HReal;
                   with PolZas3 do
                    if Typ=ct_integer then R:=HLongint
                                      else R:=HReal;
                   with PolZas4 do
                    if Typ=ct_integer then Ang1:=HLongint
                                      else Ang1:=HReal;
                   with PolZas5 do
                    if Typ=ct_integer then Ang2:=HLongint
                                      else Ang2:=HReal;
                   Gr^.InsertArc(false,X,Y,R,Ang1,Ang2);
               end;  { arc }
	in_arcn:begin { arcn }
                   if not Zasobnik^.Vyber(PolZas5) then exit; { koncovy uhel Ang2 }
                   if not Zasobnik^.Vyber(PolZas4) then exit; { startovni uhel Ang1 }
                   if not Zasobnik^.Vyber(PolZas3) then exit; { polomer R }
                   if not Zasobnik^.Vyber(PolZas2) then exit; { Y-ova souradnice stredu }
                   if not Zasobnik^.Vyber(PolZas1) then exit; { X-ova souradnice stredu }
                   if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                      (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real)or
                      (PolZas3.Typ<>ct_integer)and(PolZas3.Typ<>ct_real)or
                      (PolZas4.Typ<>ct_integer)and(PolZas4.Typ<>ct_real)or
		      (PolZas5.Typ<>ct_integer)and(PolZas5.Typ<>ct_real) then
                        begin
		     ErrorHandle^.NewValue('OP ARCN',err_typecheck);
                         exit;
                        end;
                   with PolZas1 do
                    if Typ=ct_integer then X:=HLongint
                                      else X:=HReal;
                   with PolZas2 do
                    if Typ=ct_integer then Y:=HLongint
                                      else Y:=HReal;
                   with PolZas3 do
		    if Typ=ct_integer then R:=HLongint
                                      else R:=HReal;
                   with PolZas4 do
                    if Typ=ct_integer then Ang1:=HLongint
                                      else Ang1:=HReal;
                   with PolZas5 do
                    if Typ=ct_integer then Ang2:=HLongint
                                      else Ang2:=HReal;
                   Gr^.InsertArc(true,X,Y,R,Ang1,Ang2);
                end;  { arcn }
	in_arcto:;
        in_curveto:begin {curveto}
                    if not Gr^.DefCurrPoint then
                     begin
                      ErrorHandle^.NewValue('OP CURVETO',err_NoCurrentPoint);
                      exit;
                     end;
                    if not Zasobnik^.Vyber(PolZas6) then exit; { Y3 }
                    if not Zasobnik^.Vyber(PolZas5) then exit; { X3 }
                    if not Zasobnik^.Vyber(PolZas4) then exit; { Y2 }
                    if not Zasobnik^.Vyber(PolZas3) then exit; { X2 }
                    if not Zasobnik^.Vyber(PolZas2) then exit; { Y1 }
		    if not Zasobnik^.Vyber(PolZas1) then exit; { X1 }
                    if (PolZas1.Typ<>ct_integer)and(PolZas1.Typ<>ct_real)or
                       (PolZas2.Typ<>ct_integer)and(PolZas2.Typ<>ct_real)or
                       (PolZas3.Typ<>ct_integer)and(PolZas3.Typ<>ct_real)or
                       (PolZas4.Typ<>ct_integer)and(PolZas4.Typ<>ct_real)or
                       (PolZas5.Typ<>ct_integer)and(PolZas5.Typ<>ct_real)or
                       (PolZas6.Typ<>ct_integer)and(PolZas6.Typ<>ct_real) then
                         begin
		      ErrorHandle^.NewValue('OP CURVETO',err_typecheck);
                          exit;
		     end;
                    with PolZas1 do
                     if Typ=ct_integer then X1:=HLongint
                                       else X1:=HReal;
                    with PolZas2 do
                     if Typ=ct_integer then Y1:=HLongint
                                       else Y1:=HReal;
                    with PolZas3 do
                     if Typ=ct_integer then X2:=HLongint
                                       else X2:=HReal;
                    with PolZas4 do
                     if Typ=ct_integer then Y2:=HLongint
				       else Y2:=HReal;
                    with PolZas5 do
                     if Typ=ct_integer then X3:=HLongint
                                       else X3:=HReal;
                    with PolZas6 do
                     if Typ=ct_integer then Y3:=HLongint
                                       else Y3:=HReal;
                    Gr^.InsertCurve(X1,Y1,X2,Y2,X3,Y3);
                   end;  {curveto}
	in_closepath:begin { closepath }
                        if Gr^.DefCurrPoint then Gr^.InsertClosePath;
                       end;  { closepath }
        in_flattenpath:;
        in_reversepath:;
        in_strokepath:;
        in_charpath:begin { char path }
                     if not Gr^.DefCurrPoint then
                      begin
                       ErrorHandle^.NewValue('OP CURVETO',err_NoCurrentPoint);
                       exit;
                      end;
	           if not Zasobnik^.Vyber(PolZas2) then exit;
	           if PolZas2.Typ<>ct_logic then begin
				            ErrorHandle^.NewValue('OP CHARPATH',err_typecheck);
					  exit;
				           end;
	           if not Zasobnik^.Vyber(PolZas1) then exit;
	           if PolZas1.Typ<>ct_string then begin
					   ErrorHandle^.NewValue('OP CHARPATH',err_typecheck);
					   exit;
				            end;
                     InvertTransCoord(PMatrix(VMem^.GetPointer(GrSt^.CTM)),
                              Gr^.CurrentPoint.X,Gr^.CurrentPoint.Y,CX,CY);
                     PGraphPath(VMem^.GetPointer(GrSt^.Path))^.InsertMove(CX,CY);
    	           PFont(VMem^.GetPointer(GrSt^.Font))^.
	          	   GlyphText(PRet(Vmem^.GetPointer(PolZas1.HPRet))^.Box,GrSt^.Path);
                     PGraphPath(VMem^.GetPointer(GrSt^.Path))^.InsertMove(CX+PFont(VMem^.GetPointer(GrSt^.Font))^.XOffset,CY);
                    end;  { char path }
        in_clippath:begin { clippath }
                     if GrSt^.Path<>NULL then VMem^.Dec(GrSt^.Path); { Uvolneni stavajici graficke cesty }
                     GrSt^.Path:=GrSt^.ClipPath;
                     VMem^.Inc(GrSt^.ClipPath);
                    end;  { clippath }
        in_pathbbox:;
        in_pathforall:;
        in_initclip:begin { initclip }
                     if GrSt^.ClipPath<>NULL then VMem^.Dec(GrSt^.ClipPath); { Uvolneni stare cesty orezu }
                     VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.ClipPath);
                     VMem^.Inc(GrSt^.ClipPath);
                     PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertMove(0,0);
                     PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,0);
                     PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(576,792);
                     PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertLine(0,792);
                     PGraphPath(VMem^.GetPointer(PGraphstate(VMem^.GetPointer(Graphstate))^.ClipPath))^.InsertClosePath;
                    end;  { initclip }
        in_clip,in_eoclip:begin { clip }
                           if GrSt^.ClipPath<>NULL then VMem^.Dec(GrSt^.ClipPath); { Uvolneni stare cesty orezu }
                           GrSt^.ClipPath:=GrSt^.Path;
                           VMem^.Inc(GrSt^.ClipPath); { Zvyseni poctu sdileni nove cesty orezu }
                          end;  { clip }
       end;  { case Cislo }
       ObsluhaGraphPath:=(ErrorHandle^.Value=err_noerror);
       if WindowOfGraphPath<>nil then
         begin
          InvalidateRect(WindowOfGraphPath^.HWindow,nil,true);
          PostMessage(WindowOfGraphPath^.HWindow,WM_PAINT,0,0);
         end;
       if WindowOfClipPath<>nil then
         begin
          InvalidateRect(WindowOfClipPath^.HWindow,nil,true);
          PostMessage(WindowOfClipPath^.HWindow,WM_PAINT,0,0);
         end;
      end;  { ObsluhaGraphPath }

     function ObsluhaPainting(Cislo:word):bool;
      var DC:HDC;
	  GrSt:PGraphState;
	  S:TPaintStruct;
      begin { ObsluhaPainting }
       if Graphstate=NULL then begin
			  ErrorHandle^.NewValue('Painting support / GraphState=NULL',err_criticalerror);
			  ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			  exit;
			 end;
       GrSt:=PGraphState(VMem^.GetPointer(GraphState));
       if GrSt^.Path=NULL then begin
			  ErrorHandle^.NewValue('Painting support / Path=NULL',err_criticalerror);
			  ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			  exit;
			 end;
       if GrSt^.CTM=NULL then begin
			 ErrorHandle^.NewValue('Painting support / CTM=NULL',err_criticalerror);
			 ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			 exit;
			end;
       case Cislo of
	in_erasepage:begin { erasepage }
                        BitBlt(OutputBitmapDC,0,0,567,792,0,0,0,WHITENESS);
                       end;  { erasepage }
	in_fill:begin { fill }
		 PGraphPath(VMem^.GetPointer(GrSt^.Path))^.FillPath(OutputBitmapDC);
		end;  { fill }
	in_eofill:begin { eofill }
		   PGraphPath(VMem^.GetPointer(GrSt^.Path))^.FillPath(OutputBitmapDC);
		  end;  { eofill }
	in_stroke:begin { stroke }
		   PGraphPath(VMem^.GetPointer(GrSt^.Path))^.DrawPath(OutputBitmapDC);
		  end;  { stroke }
	in_image:;
	in_imagemask:;
       end;  { case Cislo }
      if WindowOfOutPut<>nil then
        begin
         InvalidateRect(WindowOfOutput^.HWindow,nil,true);
         PostMessage(WindowOfOutput^.HWindow,WM_PAINT,0,0);
        end;
      if WindowOfPreview<>nil then
        begin
         InvalidateRect(WindowOfPreview^.HWindow,nil,true);
         PostMessage(WindowOfPreview^.HWindow,WM_PAINT,0,0);
        end;
      end;  { ObsluhaPainting }

     function ObsluhaFontu(Cislo:word):bool;
     var PolZas1,PolZas2:TPolZas;
         XHeight:integer;
         GrSt:PGraphState;
         GrPath:PGraphPath;
         El:TGraphSaveRecord;
         CX,CY:real;
     begin { ObsluhaFontu }
       if Graphstate=NULL then begin
			  ErrorHandle^.NewValue('Font support / GraphState=NULL',err_criticalerror);
			  ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			  exit;
			 end;
       GrSt:=PGraphState(VMem^.GetPointer(GraphState));
       if GrSt^.Path=NULL then begin
			  ErrorHandle^.NewValue('Font support / Path=NULL',err_criticalerror);
			  ZpracovaniChyby(ErrorHandle^.Description,err_criticalerror);
			  exit;
   		           end;
      GrPath:=PGraphPath(VMem^.GetPointer(GrSt^.Path));
      case Cislo of
       in_definefont:;
       in_findfont:begin { findfont }
		    if not Zasobnik^.Vyber(PolZas1) then exit;
		    if PolZas1.Typ<>ct_LitName then begin
						     ErrorHandle^.NewValue('OP FINDFONT',err_typecheck);
						     exit;
						    end;
		    PolZas2.Typ:=ct_Font;
		    VMem^.Alloc(new(PFont,Init(VMem,OutputBitmapDc,
			    PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box)),PolZas2.HPFont);
		    Zasobnik^.Vloz(PolZas2);
		   end;  { findfont }
       in_scalefont:begin { scalefont }
		     if not Zasobnik^.Vyber(PolZas2) then exit; { scale }
		     if not Zasobnik^.Vyber(PolZas1) then exit; { font }
		     if (PolZas1.Typ<>ct_Font)or((PolZas2.Typ<>ct_Real)and(PolZas2.Typ<>ct_integer)) then
		      begin
		       ErrorHandle^.NewValue('OP SCALEFONT',err_typecheck);
		       exit;
		      end;
		     if PolZas2.Typ=ct_real then XHeight:=round(PolZas2.HReal)
					    else XHeight:=PolZas2.HLongint;
		     PFont(VMem^.GetPointer(PolZas1.HPFont))^.ScaleFont(XHeight);
		     Zasobnik^.Vloz(PolZas1);
		    end;  { scalefont }
       in_makefont:;
       in_setfont:begin { setfont }
		    if not Zasobnik^.Vyber(PolZas1) then exit;
		    if PolZas1.Typ<>ct_Font then begin
						  ErrorHandle^.NewValue('OP SETFONT',err_typecheck);
						  exit;
						 end;
		   DecLife(VMem,ct_Font,GrSt^.Font);
		   GrSt^.Font:=PolZas1.HPFont;
		   IncLife(VMem,ct_Font,GrSt^.Font);
		  end;  { setfont }
       in_currentfont:begin { currentfont }
		       with PolZas1 do
			begin
			 Typ:=ct_Font;
			 HPFont:=GrSt^.Font;
			end;
		       Zasobnik^.Vloz(PolZas1);
		      end;  { currentfont }
       in_show:begin { show }
	         if not Zasobnik^.Vyber(PolZas1) then exit;
	         if PolZas1.Typ<>ct_string then begin
					 ErrorHandle^.NewValue('OP SHOW',err_typecheck);
					  exit;
				          end;
                   with El do
                     begin
		  XGraphState:=Graphstate;
		  XGraphPath:=GrSt^.Path;
		  XClipPath:=GrSt^.ClipPath;
		  XCTM:=GrSt^.CTM;
                     end;
                   InvertTransCoord(PMatrix(VMem^.GetPointer(GrSt^.CTM)),
                            GrPath^.CurrentPoint.X,GrPath^.CurrentPoint.Y,CX,CY);
                   VMem^.Alloc(new(PGraphPath,Init(VMem,GraphState)),GrSt^.Path); { Vytvoreni nove prazdne graficke cesty }
                   PGraphPath(VMem^.GetPointer(GrSt^.Path))^.InsertMove(CX,CY);
                   VMem^.Inc(GrSt^.Path); { Zvyseni poctu sdileni nove graficke cesty }
    	         PFont(VMem^.GetPointer(GrSt^.Font))^.
	          	 GlyphText(PRet(Vmem^.GetPointer(PolZas1.HPRet))^.Box,GrSt^.Path);
	         PGraphPath(VMem^.GetPointer(GrSt^.Path))^.DrawPath(OutputBitmapDC);
	         PGraphPath(VMem^.GetPointer(GrSt^.Path))^.FillPath(OutputBitmapDC);
                   VMem^.Dec(GrSt^.Path); { Snizeni poctu sdileni nove graficke cesty }
                    with El do
                     begin
		  Graphstate:=XGraphState;
		  GrSt^.Path:=XGraphPath;
		  GrSt^.ClipPath:=XClipPath;
		  GrSt^.CTM:=XCTM;
                     end;
                   PGraphPath(VMem^.GetPointer(GrSt^.Path))^.InsertMove(CX+PFont(VMem^.GetPointer(GrSt^.Font))^.XOffset,CY);
                   if WindowOfOutput<>nil then
                    begin
                     InvalidateRect(WindowOfOutput^.HWindow,nil,true);
                     PostMessage(WindowOfOutput^.HWindow,WM_PAINT,0,0);
                    end;
                   if WindowOfPreview<>nil then
                    begin
                     InvalidateRect(WindowOfPreview^.HWindow,nil,true);
                     PostMessage(WindowOfPreview^.HWindow,WM_PAINT,0,0);
                    end;
	       end;  { show }
       in_ashow:;
       in_widthshow:;
       in_awidthshow:;
       in_kshow:;
       in_stringwidth:;
       in_FontDirectory:;
       in_StandardEncoding:;
      end; { case of Cislo }
     end;  { ObsluhaFontu }

     function ObsluhaFor(Cislo:word):bool;
     { Pozor - jedna se pouze o inicializaci proceduralniho zasobniku   }
     { O vlastni prubeh for cyklu se stara primo ridici blok zpracovani }
      var PolZas1, PolZas2, PolZas3, PolZas4:TPolZas;
          PolBehZas1, PolBehZas2:TPolBehZas;
      begin { ObsluhaFor }
       if not Zasobnik^.Vyber(PolZas4) then exit; { Procedura }
       if not Zasobnik^.Vyber(PolZas3) then exit; { Limit }
       if not Zasobnik^.Vyber(PolZas2) then exit; { Inkrement }
       if not Zasobnik^.Vyber(PolZas1) then exit; { Inicializacni hodnota }
       if not((PolZas4.Typ=ct_Proc)and
              ((PolZas3.Typ=ct_Integer) or (PolZas3.Typ=ct_Real))and
              ((PolZas2.Typ=ct_Integer) or (PolZas2.Typ=ct_Real))and
              ((PolZas1.Typ=ct_Integer) or (PolZas1.Typ=ct_Real))) then
        begin { if 1 }
	 ErrorHandle^.NewValue('OP FOR',err_typecheck);
         exit
        end;  { if 1 }
       if (PolZas1.Typ=ct_Integer)and(PolZas2.Typ=ct_Integer)and(PolZas3.Typ=ct_Integer) then
        begin   { bude se ridit v integer promennych }
	 with PolBehZas1 do
	  begin { with PolBehZas1 }
           Typ:=ct_Proc;
           Uk1.Uk:=PolZas4.HPProc;
           Uk2.Typ:=PolZas3.Typ;
           Uk2.HLongint:=PolZas3.HLongint;
          end;  { with PolBehZas1 }
         with PolBehZas2 do
          begin { with PolBehZas2 }
           Typ:=ct_ForCyklus;
           Uk1.Typ:=PolZas1.Typ;
           Uk1.HLongint:=PolZas1.HLongint;
           Uk2.Typ:=PolZas2.Typ;
           Uk2.HLongint:=PolZas2.HLongint;
          end;  { with PolBehZas2 }
         end                           else
        begin   { bude se ridit v realnych promennych }
         with PolBehZas1 do
          begin { with PolBehZas1 }
           Typ:=ct_Proc;
           Uk1.Uk:=PolZas4.HPProc;
           Uk2.Typ:=ct_Real;
	   if PolZas3.Typ=ct_Integer then
	    Uk2.HReal:=PolZas3.HLongint
                                     else
            Uk2.HReal:=PolZas3.HReal;
          end;  { with PolBehZas1 }
         with PolBehZas2 do
          begin { with PolBehZas2 }
           Typ:=ct_ForCyklus;
           Uk1.Typ:=ct_Real;
           if PolZas1.Typ=ct_Integer then
            Uk1.HReal:=PolZas1.HLongint
                                     else
            Uk1.HReal:=PolZas1.HReal;
           Uk2.Typ:=ct_Real;
           if PolZas2.Typ=ct_Integer then
            Uk2.HReal:=PolZas2.HLongint
                                     else
            Uk2.HReal:=PolZas2.HReal;
          end;  { with PolBehZas2 }
         end;
        BehZasobnik^.Vloz(PolBehZas1);
        BehZasobnik^.Vloz(PolBehZas2);
       end;  { ObsluhaFor }

     function ObsluhaRepeat(Cislo:word):bool;
     { Pozor - jedna se pouze o inicializaci proceduralniho zasobniku   }
     { O vlastni prubeh repeat cyklu se stara primo ridici blok zpracovani }
      var PolZas1, PolZas2:TPolZas;
          PolBehZas1, PolBehZas2:TPolBehZas;
      begin { ObsluhaRepeat }
       if not Zasobnik^.Vyber(PolZas2) then exit; { Procedura }
       if not Zasobnik^.Vyber(PolZas1) then exit; { Pocet opakovani }
{***}  if (PolZas2.Typ<>ct_Proc)or(PolZas1.Typ<>ct_Integer) then
        begin { if 1 }
	 ErrorHandle^.NewValue('OP REPEAT',err_typecheck);
         exit;
        end;  { if 1 }
       with PolBehZas1 do
        begin { with PolBehZas1 }
         Typ:=ct_Proc;
         Uk1.Uk:=PolZas2.HPProc;       { Procedura }
         Uk2.Typ:=ct_integer;
         Uk2.HLongint:=1;           { Limit     }
        end;  { with PolBehZas1 }
       with PolBehZas2 do
	begin { with PolBehZas2 }
         Typ:=ct_RepeatCyklus;
         Uk1.Typ:=ct_integer;
         Uk1.HLongint:=PolZas1.HLongint; { Ridici hodnota }
         Uk2.Typ:=ct_integer;
         Uk2.HLongint:=-1;               { Increment }
        end;  { with PolBehZas2 }
       BehZasobnik^.Vloz(PolBehZas1);
       BehZasobnik^.Vloz(PolBehZas2);
      end;  { ObsluhaRepeat }

     function ObsluhaLoop(Cislo:word):bool;
      var PolZas1:TPolZas;
          PolBehZas1:TPolBehZas;
      begin { ObsluhaLoop }
       if not Zasobnik^.Vyber(PolZas1) then exit;
       if PolZas1.Typ<>ct_Proc then
        begin
         ObsluhaLoop:=false;
	 ErrorHandle^.NewValue('OP LOOP',err_typecheck);
         exit;
	end;
       with PolZas1,PolBehZas1 do
        begin
         Typ:=ct_LoopCyklus;
	 Uk1.Uk:=HPProc;
        end;
       BehZasobnik^.Vloz(PolBehZas1);
       ObsluhaLoop:=true;
      end;  { ObsluhaLoop }

     procedure ObsluhaExit(Cislo:word);
      var PomBehPol:TPolBehZas;
      begin { ObsluhaExit }
       if not BehZasobnik^.Vyber(PomBehPol) then exit;
       if not BehZasobnik^.Vyber(PomBehPol) then exit;
       with PomBehPol do
        begin
         if (Typ=ct_ForCyklus) or (Typ=ct_RepeatCyklus) then
          begin
           BehZasobnik^.Vyber(PomBehPol);                  { 2. cast for cyklu }
           exit;
          end;
	 if Typ=ct_LoopCyklus then
	  begin
           exit;
          end;
	 ErrorHandle^.NewValue('OP EXIT',err_invalidexit);
        end;
      end;  { ObsluhaExit }

     procedure ObsluhaIf(Cislo:word);
      var PolZas1,PolZas2:TPolZas;
          PolBehZas1:TPolBehZas;
      begin { ObsluhaIf }
       if not Zasobnik^.Vyber(PolZas2) then exit;
       if not Zasobnik^.Vyber(PolZas1) then exit;
       if (PolZas1.Typ<>ct_Logic)or(PolZas2.Typ<>ct_Proc) then
        begin
	 ErrorHandle^.NewValue('OP IF',err_typecheck);
         exit
        end;
       if not PolZas1.HBoolean then exit;
       with PolBehZas1 do
        begin
	 Typ:=ct_Proc;
	 Uk1.Uk:=PolZas2.Uk; { Ukazatel na pole procedury }
	 Uk2.HLongint:=PProc(VMem^.GetPointer(Uk1.HPProc))^.Size;   { Index operace v behovem poli, ktera se bude provadet }
        end;
       BehZasobnik^.Vloz(PolBehZas1);
      end;  { ObsluhaIf }

     procedure ObsluhaIfelse(Cislo:word);
      var PolZas1,PolZas2,PolZas3:TPolZas;
          PolBehZas1:TPolBehZas;
      begin { ObsluhaIfElse }
       if not Zasobnik^.Vyber(PolZas3) then exit;
       if not Zasobnik^.Vyber(PolZas2) then exit;
       if not Zasobnik^.Vyber(PolZas1) then exit;
       if (PolZas1.Typ<>ct_Logic)or(PolZas2.Typ<>ct_Proc)or(PolZas3.Typ<>ct_Proc) then
        begin
	 ErrorHandle^.NewValue('OP IFELSE',err_typecheck);
         exit
        end;
       if not PolZas1.HBoolean then PolZas2:=PolZas3;
       with PolBehZas1 do
        begin
	 Typ:=ct_Proc;
	 Uk1.Uk:=PolZas2.Uk; { Ukazatel na pole procedury }
	 Uk2.HLongint:=PPRoc(VMem^.GetPointer(Uk1.HPProc))^.Size;   { Index operace v behovem poli, ktera se bude provadet }
        end;
       BehZasobnik^.Vloz(PolBehZas1);
      end;  { ObsluhaIfElse }

     procedure ObsluhaGet(Cislo:word);
      var PolZas1,PolZas2,PolZas3:TPolZas;
          Index:word;
          PolDict:TPolozka;
      begin { ObsluhaGet }
       if not Zasobnik^.Vyber(PolZas2) then exit;
       if not Zasobnik^.Vyber(PolZas1) then exit;
       case PolZas1.Typ of
        ct_dict:begin { get for dictionary }
                 if PolZas2.Typ<>ct_LitName then
                  begin
		   ErrorHandle^.NewValue('OP GET',err_typecheck);
                   exit;
                  end;
                 PolDict.Op:=PolZas2.HPRet;
		 PSlovnik(VMem^.GetPointer(PolZas1.HPDict))^.GetPair(PolDict,Index);
		 PolZas3.Typ:=PolDict.Typ;
                 PolZas3.Whole:=PolDict.Hodnota.Whole;
                 Zasobnik^.Vloz(PolZas3);
                end;  { get for dictionary }
       end; { case }
      end;  { ObsluhaGet }

     procedure ObsluhaPut(Cislo:word);
      var PolZas1,PolZas2,PolZas3:TPolZas;
          Index:word;
          PolDict:TPolozka;
      begin { ObsluhaPut }
       if not Zasobnik^.Vyber(PolZas3) then exit;    { value }
       if not Zasobnik^.Vyber(PolZas2) then exit;    { lit. name}
       if not Zasobnik^.Vyber(PolZas1) then exit;    { dict }
       case PolZas1.Typ of
        ct_dict:begin { put for dictionary }
                 if PolZas2.Typ<>ct_LitName then
                  begin
	         ErrorHandle^.NewValue('OP PUT',err_typecheck);
                   exit;
	        end;
	       PolDict.Op:=PolZas2.HPRet;
                 PolDict.Typ:=PolZas3.Typ;
                 PolDict.Hodnota.Whole:=PolZas3.Whole;
	       PSlovnik(VMem^.GetPointer(PolZas1.HPDict))^.PutPair(PolDict);
                end;  { put for dictionary }
       end; { case }
      end;  { ObsluhaPut }


     procedure ObsluhaCopy(Cislo:word);
      var PolZas1,PolZas2,PolZas3:TPolZas;
          PolDict:TPolozka;
          i,j,k:longint;
      begin { ObsluhaCopy }
                 Zasobnik^.Vyber(PolZas1);
                 case PolZas1.Typ of
                  ct_integer:begin { copy for operand stack }
                              k:=0;
                              for i:=PolZas1.HLongint-1 downto 0 do
                               begin { for 1 }
                                j:=Zasobnik^.AktPoz-i-k;;
				if j>0 then begin { if 1 }
					     PolZas2:=Zasobnik^.POBox[j];
                                             Zasobnik^.Vloz(PolZas2);
                                             inc(k);
                                            end   { if 1 }
                               end;  { for 1 }
                             end;  { copy for operand stack }
                  ct_string,ct_substring:begin  { copy string to another string }
                                          if not Zasobnik^.Vyber(PolZas2) then exit;
                                          if (PolZas2.Typ<>ct_string)and(PolZas2.Typ<>ct_SubString) then
                                           begin
					    ErrorHandle^.NewValue('OP COPY / copiing of strings',err_typecheck);
					    exit;
					   end;
					  if PRet(VMem^.GetPointer(PolZas2.HPRet))^.Count>PRet(VMem^.GetPointer(PolZas1.HPRet))^.Count then
                                           begin
					    ErrorHandle^.NewValue('OP COPY / copiing of strings',err_rangecheck);
                                            exit;
                                           end;
					  move(PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box^,PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box^,
					       PRet(VMem^.GetPointer(PolZas2.HPRet))^.Count);
					  PRet(VMem^.GetPointer(PolZas1.HPRet))^.Box[1]:=
					       PRet(VMem^.GetPointer(PolZas2.HPRet))^.Box[1];
					  with PolZas3 do
                                           begin
					    Typ:=ct_SubString;
					    VMem^.Alloc(new(PSubRet,Init(VMem,PolZas1.HPRet, 0, PRet(VMem^.GetPointer(PolZas2.HPRet))^.Count)),HPRet);
					   end;
					  Zasobnik^.Vloz(PolZas3);
			    end;   { copy string to another string }
		 end; { case }
      end;  { ObsluhaCopy }

     begin
      case Cislo of
       ing_OpStackBeg..ing_OpStackEnd:ObsluhaZas(Cislo);
       ing_OpAritmBeg..ing_OpAritmEnd:ObsluhaAritm(Cislo);
       ing_OpDictBeg..ing_OpDictEnd:ObsluhaSlov(Cislo);
       ing_OpTypBeg..ing_OpTypEnd:ObsluhaTyp(Cislo);
       ing_OpArrayBeg..ing_OpArrayEnd:ObsluhaArray(Cislo);
       ing_OpStringBeg..ing_OpStringEnd:ObsluhaString(Cislo);
       ing_OpLogBeg..ing_OpLogEnd:ObsluhaLog(Cislo);
       ing_OpMiscBeg..ing_OpMiscEnd:ObsluhaMsc(Cislo);
       ing_CoordMatrixBeg..ing_CoordMatrixEnd:ObsluhaCoordMatrix(Cislo);
       ing_GraphStateBeg..ing_GraphStateEnd:ObsluhaGraphstate(Cislo);
       ing_GraphPathBeg..ing_GraphPathEnd:ObsluhaGraphPath(Cislo);
       ing_PaintingBeg..ing_PaintingEnd:ObsluhaPainting(Cislo);
       ing_FontBeg..ing_FontEnd:ObsluhaFontu(Cislo);
       in_for:ObsluhaFor(Cislo);
       in_repeat:ObsluhaRepeat(Cislo);
       in_loop:ObsluhaLoop(Cislo);
       in_exit:ObsluhaExit(Cislo);
       in_if:ObsluhaIf(Cislo);
       in_ifelse:ObsluhaIfelse(Cislo);
       in_get:ObsluhaGet(Cislo);
       in_put:ObsluhaPut(Cislo);
       in_copy:ObsluhaCopy(Cislo);
      end;
      VykonBlok:=true;
     end;

procedure THlavniOkno.WMWinClosed(var Msg:TMessage);
 var X:TMemDescr;
 begin
  case Msg.wParam of
   1:WindowOfStack:=nil;
   2:WindowOfProcStack:=nil;
   3:begin
      X:=VMem^.GetMemDescr(PCompObject(Msg.lParam));
      VMem^.Dec(X);
      if X=Input then
       begin
        VMem^.Dec(Input);
        Input:=NULL;
       end;
     end;
   4:begin
      if Input<>NULL then VMem^.Dec(Input);
      Input:=Msg.lParam;
      VMem^.Inc(Input);
     end;
   5:WindowOfVirtualMemory:=nil;
   6:WindowOfGraphPath:=nil;
   7:WindowOfClipPath:=nil;
   8:WindowOfOutput:=nil;
   9:WindowOfPreview:=nil;
  end;
  VMem^.Free;
  if WindowOfVirtualMemory<>nil then WindowOfVirtualMemory^.Seznam(VMem);
 end;

procedure THlavniOkno.ZpracovaniChyby(Where:PChar;Error:byte);
 var D:array [0..100] of char;
     ErrD:word;
 begin
  SndPlaySound('chimes.wav',1);
  LoadString(HInstance,Error,D,sizeof(D));
  if strcomp(D,'')>0 then
                             begin
                              if Where<>nil then
                               begin
                                strcat(D,' in ');
                                strcat(D,Where);
                               end;
                              MessageBox(HWindow, D,'Error message',mb_Ok or mb_IconStop);
                             end
		 else
		  begin
		   ErrD:=Error;
		   WVSPrintF(D,'Error %d',ErrD);
                       if Where<>nil then
                        begin
                         strcat(D,'in ');
                         strcat(D,Where);
                        end;
		   MessageBox(HWindow,D,'Error message',mb_Ok or mb_IconStop);
		  end;
  { Tady bude osetreni systemu v krizove situaci }
{  dispose(Input,Done);}
{  Input:=nil;}
  FOtevren:=false;
  PEditFile(VMem^.GetPointer(Input))^.Konec:=true;
  ErrorHandle^.NoError;
 end;

procedure THlavniOkno.GetGraphState(var Msg:TMessage);
 begin
  if GraphState<>NULL then pointer(Msg.Result):=VMem^.GetPointer(GraphState)
                      else pointer(Msg.Result):=nil;
 end;


procedure THlavniOkno.GetGraphPath(var Msg:TMessage);
 var GrSt:PGraphState;
 begin
  if GraphState<>NULL then GrSt:=PGraphState(VMem^.GetPointer(GraphState));
  if GrSt^.Path<>NULL then pointer(Msg.Result):=VMem^.GetPointer(GrSt^.Path)
                      else pointer(Msg.Result):=nil;
 end;

procedure THlavniOkno.GetClipPath(var Msg:TMessage);
 var GrSt:PGraphState;
 begin
  if GraphState<>NULL then GrSt:=PGraphState(VMem^.GetPointer(GraphState));
  if GrSt^.ClipPath<>NULL then pointer(Msg.Result):=VMem^.GetPointer(GrSt^.ClipPath)
                          else pointer(Msg.Result):=nil;
 end;


{********************************************************** }
{ ---               Defince aplikace                    --- }
{ ********************************************************* }

type PProgram = ^TProgram;
     TProgram = object(TApplication)
		 procedure InitInstance; virtual;
		 procedure InitMainWindow; virtual;
{                 procedure Error(ErrorCode:integer); virtual;}
		end;

     procedure TProgram.InitInstance;
      begin
       inherited InitInstance;
       HAccTable:=LoadAccelerators(hInstance,'ACCELERATORS_1');
      end;

     procedure TProgram.InitMainWindow;
      begin
       MainWindow:=new(PHlavniOkno,Init('Software emulation of POSTSCRIPT',LoadMenu(HInstance,'Hlavni_Menu')));
      end;

{ ********************************************************* }
{ ---               Hlavn  program                     --- }
{ ********************************************************* }

var XProgram:TProgram;

begin
 @Win31LockWindowUpdate :=
  GetProcAddress(GetModuleHandle('User'), PChar(294));
 XProgram.Init('Tak to spust!');
 if ErrorHandle^.Value<>err_noerror then MessageBox(0,'During the start application an error has occured. Stop the program!',
 'Critical error',MB_OK or MB_ICONSTOP or MB_TASKMODAL);
 XProgram.Run;
 XProgram.Done;
end.





