{ Nevyeen problmy:  }
{                       }

unit Fonty;

{ Softwarov emulace postcriptu }
{           Modul font         }
{      Tom Mayer (C) 1994     }

interface

uses Strings,WinTypes,WinProcs,OWindows,Win31,Hodnoty,Konverze,ObjKomp,Grafika;

type PFontInfo=^TLogFont;

type PFont=^TFont;
     TFont=object(TCompObject)
	    Name:array [0..255] of char;
	    Font:TLogFont;
	    OutDC:HDC;
	    OldTrueType:HFont;
	    TrueTypeFont:HFont;
              XOffset:integer;
	    constructor Init(AVMem:PVirtMemory;OutputDC:HDC;AName:PChar);
	    destructor Done; virtual;
	    procedure FindFont(OutputDC:HDC;AName:PChar);
	    procedure ScaleFont(AHeight:integer);
	    procedure ConnectFont(OutputDC:HDC);
	    procedure Activate;
	    procedure Deactivate;
	    procedure GlyphText(AText:Pchar;AGraphPath:TMemDescr); { Tady se bude prevadet rovnou do graficke cesty }
	   end;

implementation

constructor TFont.Init(AVMem:PVirtMemory;OutPutDC:HDC;AName:PChar);
 begin
  inherited Init(AVMem);
  COTyp:=sco_Font;
  strcopy(Name,AName);
  FillChar(Font,sizeof(Font),0);
  FindFont(OutputDc,Name);
  OutDC:=OutputDC;
 end;

destructor TFont.Done;
 begin
  DeleteObject(TrueTypeFont);
 end;

function EnumFontsCallBack(var LogFont:TLogFont;var ATextMetric:TTextMetric;
			    FontType:word;FI:PFontInfo):integer; export;
 begin
  FI^:=LogFont;
  EnumFontsCallBack:=0;
 end;

procedure TFont.FindFont(OutputDC:HDC;AName:PChar);
 var EnumFunc:TFarProc;
     OldHeight:integer;
 begin
  OldHeight:=Font.lfHeight;
  FillChar(Font,sizeof(Font),0);
  Font.lfHeight:=1;
  EnumFunc:=MakeProcInstance(@EnumFontsCallBack,hInstance);
  EnumFonts(OutputDC,AName,EnumFunc,@Font);
  FreeProcInstance(EnumFunc);
  Font.lfHeight:=OldHeight;
 end;

procedure TFont.ScaleFont(AHeight:integer);
 begin
  Font.lfHeight:=AHeight;
 end;

procedure TFont.ConnectFont(OutputDC:HDC);
 begin
  OutDC:=OutputDC;
  FindFont(OutDC,Name);
  Font.lfWidth:=0;
  TrueTypeFont:=CreateFontIndirect(Font);
 end;

procedure TFont.Activate;
 begin
  OldTrueType:=SelectObject(OutDC,TrueTypeFont);
 end;


procedure TFont.Deactivate;
 begin
  SelectObject(OutDC,OldTrueType);
 end;



procedure TFont.GlyphText(AText:PChar;AGraphPath:TMemDescr);
 var Metr:TGlyphMetrics;
     Buff,Buff1:PChar;
     MemMark:longint;
     Matice:TMat2;
     Header:TPolygonHeader;
     Curve:TTTPolyCurve;
     Err:longint;
     OutlinedChar:word;
     Body:array [0..100] of TPointFX;
     i,j:integer;
     Gr:PGraphPath;
     GrSt:PGraphstate;
     PX,PY:TReal;
     XCTM:PMatrix;
 begin
  if AText[0]=#0 then exit;
  Gr:=PGraphPath(PVirtMemory(VMem)^.GetPointer(AGraphPath));
  GrSt:=PGraphState(PVirtMemory(VMem)^.GetPointer(Gr^.Graphstate));
  XCTM:=PMatrix(PVirtMemory(VMem)^.GetPointer(GrSt^.CTM));
  with Matice do
   begin
    eM11.Fract:=0;
    eM11.Value:=1;
    eM12.Fract:=0;
    eM12.Value:=0;
    eM21.Fract:=0;
    eM21.Value:=0;
    eM22.Fract:=0;
    eM22.Value:=1;
   end;
  ConnectFont(OutDC);
  Activate;
  GetMem(Buff,32265);
  j:=0;
  XOffset:=0;
  while j<strlen(AText) do
   begin { while j<strlen(AText) }
    FillChar(Buff^,32265,#0);
    OutlinedChar:=ord(AText[j]);
    Moveto(OutDC,0,0);
    Err:=GetGlyphOutline(OutDC,OutlinedChar,GGO_NATIVE,Metr,32265,Buff,Matice);
    if Err<0 then MessageBox(Application^.MainWindow^.HWindow,'Chyba v GetGlyphOutline','DEBUG',MB_OK or MB_ICONSTOP);
    InvertTransCoord(XCTM,Gr^.CurrentPoint.X,Gr^.CurrentPoint.Y,PX,PY);
    Buff1:=Buff;
     while Buff1[0]<>#0 do
      begin { while 1 : dokud neni konec dat }
       MemMark:=longint(Buff1);
       Header:=PPolygonHeader(Buff1)^;
       inc(longint(Buff1),sizeof(TPolygonHeader));
       Gr^.InsertMove(PX+FixedToReal(Header.pfxStart.X),PY+FixedToReal(Header.pfxStart.Y));
       while longint(Buff1)-MemMark<Header.cb do
	begin { while 2 : dokud neni nova hlavicka krivky }
	 Curve:=PTTPolyCurve(Buff1)^;
	 inc(longint(Buff1),4); { velikost TTTPolyCurve-TPointFX }
	 for i:=0 to Curve.cpfx-1 do
	  begin
	   Body[i]:=PPointFX(Buff1)^;
	   inc(longint(Buff1),sizeof(TPointFX));
	  end;
	 if true{Curve.wType=TT_PRIM_LINE} then
	  begin
	   for i:=0 to Curve.cpfx-1 do
	    begin
	     Gr^.InsertLine(PX+FixedToReal(Body[i].X),PY+FixedToReal(Body[i].Y));
	    end
	  end  		             else { TT_PRIM_QSPLINE }
	  begin
	   case Curve.cpfx of
	    2:Gr^.InsertCurve(PX+FixedToReal(Body[0].X),PY+FixedToReal(Body[0].Y),
			   PX+FixedToReal(Body[0].X),PY+FixedToReal(Body[0].Y),
			   PX+FixedToReal(Body[1].X),PY+FixedToReal(Body[1].Y));
	    3:Gr^.InsertCurve(PX+FixedToReal(Body[0].X),PY+FixedToReal(Body[0].Y),
			   PX+FixedToReal(Body[1].X),PY+FixedToReal(Body[1].Y),
			   PX+FixedToReal(Body[2].X),PY+FixedToReal(Body[2].Y));
	    4:Gr^.InsertCurve(PX+(FixedToReal(Body[0].X)+FixedToReal(Body[1].X))/2,
			   PY+(FixedToReal(Body[0].Y)+FixedToReal(Body[1].Y))/2,
			   PY+(FixedToReal(Body[1].X)+FixedToReal(Body[2].X))/2,
			   PY+(FixedToReal(Body[1].Y)+FixedToReal(Body[2].Y))/2,
			   PX+FixedToReal(Body[3].X),PY+FixedToReal(Body[3].Y));
	    5:Gr^.InsertCurve(PX+FixedToReal(Body[0].X),PY+FixedToReal(Body[0].Y),
			   PX+FixedToReal(Body[2].X),PY+FixedToReal(Body[2].Y),
			   PX+FixedToReal(Body[4].X),PY+FixedToReal(Body[4].Y));
	  end; { case Curve.cpfx }
	 end;
       end;  { while 2 : dokud neni nova hlavicka krivky }
      Gr^.InsertClosePath;
     end;  { while 1 : dokud neni konec dat }
    Gr^.InsertMove(PX+Metr.gmCellIncX,PY);
    inc(XOffset,Metr.gmCellIncX);
    inc(j);
   end;  { while j<=strlen(AText) }
  FreeMem(Buff,32265);
  Deactivate;
 end;

end.