{ Nevyeen problmy: Transformace z user do device space }
{                      Pouvn CTM                       }

unit Grafika;

{ Softwarov emulace postcriptu }
{     Modul grafickho stavu    }
{      Tom Mayer (C) 1994     }


interface


uses Objects, ObjKomp, Slovniky, Hodnoty, WinTypes, WinProcs, OWindows, GlobInf, Chyby;

const XUnit=10;
      YUnit=10;
      XPageRange = 72*8 div 10;  { Weihgt of A4 in Xunits }
      YPageRange = 72*11 div 10; { Height of A4 in Yunits }
      SizeMemBlock = 2048; { up to 64k }
      UpperLimit =   1984;
      Gr_Move          = 1;
      Gr_Line          = 2;
      Gr_Curve         = 3;
      Gr_ClosePath     = 4;
      Gr_NextBlock     = 98;
      Gr_EndOfSequence = 99;


type PMapMemBlock=^TMapMemBlock;
     TMapMemBlock=array [1..SizeMemBlock] of byte;

type TGrPoint=record
	       X,Y:TReal;
	      end;

type PGrLine=^TGrLine;
     TGrLine=record
	      Code:byte;
	      P1:TGrPoint;  { ending point }
             end;

     PGrCurve=^TGrCurve;
     TGrCurve=record
               Code:byte;
               P1:TGrPoint;
               P2:TGrPoint;
               P3:TGrPoint;
              end;

     PGrClosePath=^TGrClosePath;
     TGrClosePath=record
                   Code:byte;
                   FirstSegment:pointer;
                  end;

     PGrNextBlock=^TGrNextBlock;
     TGrNextBlock=record
                 Code:byte;
                 NextBlock:pointer;
                end;

     PGrEndOFSequence=^TGrEndOfSequence;
     TGrEndOfSequence=record
                       Code:byte;
                      end;

type  PGraphState=^TGraphState;
      TGraphState=object(TCompObject)
		   CTM:TMemDescr;  { pointer to transformation matrix }
		   Color:TColorRef;   { current painting color }
		   PosX,PosY:TReal;    { current position of graphic cursor }
		   Path:TMemDescr;      { pointer to graph path }
		   ClipPath:TMemDescr;  { pointer to clipping graph path }
		   ClipRgn:HRgn;
		   Font:TMemDescr;
		   LWidth:TReal;  { width of line }
		   LCap:integer;    { capse of end of line }
		   LJoin:integer;   { type join of two lines }
		   HelfTScreen:pointer;  {  }
		   Transfer:PProc;   { transfer user halftone to device procedure }
		   Flatness:real;
		   MiterLimit:real;
		   DashPattern:pointer;
		   Device:pointer;   { current output device }
	         constructor Init(VMemory:PVirtMemory);
	         destructor Done; virtual;
	         function Copy(AVMemory:PObject):PCompObject; virtual;
	         procedure DefClipPath;
	        end;


type PGraphPath=^TGraphPath;
     TGraphPath=object(TCompObject)
		 GraphState:TMemDescr;
		 MemBlock:pointer;
		 CurrMemBlock:pointer;
		 CurrIndex:word;
		 StartPoint:TGrPoint;  { start of subpath }
		 DefCurrPoint:boolean;  { a first operator MOVETO switch to TRUE }
                     CurrentPoint:TGrPoint; { Current painting point }
                     ViewCurrPath:boolean;
		 constructor Init(VMemory:PvirtMemory;XGraphState:TMemDescr);
		 constructor InitCopy(VMemory:PVirtMemory);
		 destructor Done; virtual;
		 function Copy(AVMemory:PObject):PCompObject; virtual;
		 procedure NewMemBlock(PointerToBlock:PGrNextBlock);
		 procedure CopyAllBlocks(NewP:PGraphPath);
		 procedure ReleaseAllBlocks;
		 procedure InsertNextBlock;
		 procedure InsertMove(PX1,PY1:TReal);
                     procedure InsertLine(PX1,PY1:TReal);
                     procedure InsertClosePath;
                     procedure InsertCurve(PX1,PY1,PX2,PY2,PX3,PY3:TReal);
		 procedure InsertArc(ClockWise:boolean;XC,YC,Radius:TReal;Angle1:TReal;Angle2:TReal);
                     procedure AddArc(First:boolean;Radius,X0,Y0,X3,Y3,XT,YT:TReal);
		 procedure DrawPath(DragDc:HDC);
		 procedure FillPath(DragDC:HDC);
		end;

type PWinGraphPath=^TWinGraphPath;
     TWinGraphPath=object(TWindow)
		    GrPath:PGraphPath;
		    constructor Init(AParent:PWindowsObject;AGrPath:PGraphPath);
		    destructor Done; virtual;
		    procedure Paint(PaintDC:HDC; var PaintStruct:TPaintStruct); virtual;
		   end;

type PWinClipPath=^TWinClipPath;
     TWinClipPath=object(TWindow)
		    GrState:PGraphState;
                        ClPath:PGraphPath;
		    constructor Init(AParent:PWindowsObject; AGraphState:PGraphState);
		    destructor Done; virtual;
		    procedure Paint(PaintDC:HDC; var PaintStruct:TPaintStruct); virtual;
		   end;

type  PWinPreview=^TWinPreview;
      TWinPreview=object(TWindow)
                   OutBitmap:HBitmap;
                   BitmapDC:HDC;
                   Reduction:real;
	         constructor Init(AParent:PWindowsObject);
                   destructor Done; virtual;
                   procedure SetupWindow; virtual;
	         procedure Paint(DC:HDC; var PaintStruct:TPaintStruct); virtual;
                  end;

type PWinPaint=^TWinPaint;
     TWinPaint=object(TWindow)
		BitmapDC:HDC;
		constructor Init(AParent:PWindowsObject);
		destructor Done; virtual;
		procedure Paint(DC:HDC; var PaintStruct:TPaintStruct); virtual;
	       end;


type TGraphSaveRecord=record
		       XGraphState:TMemDescr;
		       XGraphPath:TMemDescr;
		       XClipPath:TMemDescr;
		       XCTM:TMemDescr;
		      end;

const MaxGSaveLevel=31;

type PGraphStack=^TGraphStack;
     TGraphStack=object(TObject)
		  VirtMemory:PVirtMemory;
		  POBOX:array [0..30] of TGraphSaveRecord;
		  Top,Bottom,Curr:integer;
		  constructor Init(AVMemory:PVirtMemory);
		  function Copy(AVMemory:PVirtMemory):PGraphstack; virtual;
		  function Push(Element:TGraphsaveRecord):bool;
		  function Pop(var Element:TGraphsaveRecord):bool;
                      function IsEmpty:bool;
		 end;

procedure Rotate(CTM:PMatrix; Angle:TReal);
procedure Translate(CTM:PMatrix; X,Y:TReal);
procedure Scale(CTM:PMatrix; SX,SY:TReal);
procedure TransCoord(CTM:PMatrix; XUser,YUser:TReal;var XDevice,YDevice:TReal);
procedure InvertTransCoord(CTM:PMatrix; XDevice,YDevice:TReal;var XUser,YUser:TReal);
procedure DeltaTransCoord(CTM:PMatrix; XUser,YUser:TReal;var XDevice,YDevice:TReal);
procedure InvertDeltaTransCoord(CTM:PMatrix; XDevice,YDevice:TReal;var XUser,YUser:TReal);
procedure HSVtoRGB(H,S,V:real; var R,G,B:real);
procedure RGBtoHSV(R,G,B:real; var H,S,V:real);


implementation

procedure TransCoord(CTM:PMatrix; XUser,YUser:TReal;var XDevice,YDevice:TReal);
{ Pouziti transformacni matice CTM na bod [XU,YU]. Vysledkem je bod [XD,YD]. }
 begin
  with CTM^ do
   begin
    XDevice:=XX*XUser+XY*YUser+XT;
    YDevice:=YX*XUser+YY*YUser+YT;
   end;
 end;

procedure InvertTransCoord(CTM:PMatrix; XDevice,YDevice:TReal;var XUser,YUser:TReal);
{ Pouziti inverzni transformacni matice CTM na bod [XD,YD]. Vysledkem je bod [XU,YU]. }
 begin
  with CTM^ do
   begin
    YUser:=((XDevice-XT)*YX+(-YDevice+YT)*XX)/(XY*YX-XX*YY);
    XUser:=(XDevice-XY*YUser-XT)/XX;
   end;
 end;

procedure DeltaTransCoord(CTM:PMatrix; XUser,YUser:TReal;var XDevice,YDevice:TReal);
{ Pouziti transformacni matice CTM na bod [XU,YU]. Vysledkem je bod [XD,YD]. }
 begin
  with CTM^ do
   begin
    XDevice:=XX*XUser+XY*YUser;
    YDevice:=YX*XUser+YY*YUser;
   end;
 end;

procedure InvertDeltaTransCoord(CTM:PMatrix; XDevice,YDevice:TReal;var XUser,YUser:TReal);
{ Pouziti inverzni transformacni matice CTM na bod [XD,YD]. Vysledkem je bod [XU,YU]. }
 begin
  with CTM^ do
   begin
    YUser:=(XDevice*YX-YDevice*XX)/(XY*YX-XX*YY);
    XUser:=(XDevice-XY*YUser)/XX;
   end;
 end;


procedure Rotate(CTM:PMatrix; Angle:TReal);
 var AngleRad:TReal;
     CosA,SinA:TReal;
     PXX,PXY,PYX,PYY:TReal;
 begin
  AngleRad:=Angle*Pi/180;
  CosA:=cos(AngleRad);
  SinA:=sin(AngleRad);
  with CTM^ do
   begin
    PXX:=XX*COSA+XY*SINA;
    PXY:=-XX*SINA+XY*COSA;
    PYX:=YX*COSA+YY*SINA;
    PYY:=-YX*SINA+YY*COSA;
    XX:=PXX;
    XY:=PXY;
    YX:=PYX;
    YY:=PYY;
   end;
 end;

procedure Translate(CTM:PMatrix; X,Y:TReal);
 begin
  with CTM^do
   begin
    XT:=XX*X+XY*Y+XT;
    YT:=YX*X+YY*Y+YT;
   end;
 end;

procedure Scale(CTM:PMatrix; SX,SY:TReal);
 begin
  with CTM^do
   begin
    XX:=XX*SX;
    XY:=XY*SY;
    YY:=YY*SY;
    YX:=YX*SX;
   end;
 end;

function Max(R,G,B:real):real;

var Pom:real;

begin { Max }
 if R>G then Pom:=R
        else Pom:=G;
 if Pom<B then Pom:=B;
 Max:=Pom;
end;  { Max }


function Min(R,G,B:real):real;

var Pom:real;

begin { Min }
 if R<G then Pom:=R
        else Pom:=G;
 if Pom>B then Pom:=B;
 Min:=Pom;
end;  { Min }

procedure RGBtoHSV(R,G,B:real;var H,S,V:real);
{ Prevod RGB to HSV }

var k,r1,g1,b1:real;

begin { RGBtoHSV }
 V:=max(R,G,B);
 k:=min(R,G,B);
 if V<>0 then S:=(V-k)/V
         else S:=0;
 if S<>0 then begin { if 1 }
               r1:=(V-R)/(V-k);
               g1:=(V-G)/(V-k);
               b1:=(V-B)/(V-k);
               if V=R then if k=G then H:=5+b1
                                    else H:=1-g1
                      else
               if V=G then if k=B then H:=1+r1
                                    else H:=3-b1
                      else if k=R then H:=3+g1
                                   else H:=5-r1;
               H:=H*60;
              end   { if 1 }
             else h:=0;
end;  { RGBtoHSV }


procedure HSVtoRGB(H,S,V:real; var R,G,B:real);
{ Prevod HSV to RGB }

var p1,p2,p3,f:real;
    i:integer;

begin { HSVtoRGB }
 if H=360 then H:=0;
 H:=H/60;
 i:=trunc(H);
 f:=h-i;
 p1:=V*(1-S);
 p2:=V*(1-(S*f));
 p3:=V*(1-(S*(1-f)));
 case i of
  0:begin
     R:=V;G:=p3;B:=p1;
    end;
  1:begin
     R:=p2;G:=V;B:=p1;
    end;
  2:begin
     R:=p1;G:=V;B:=p3;
    end;
  3:begin
     R:=p1;G:=p2;B:=V;
    end;
  4:begin
     R:=p3;G:=p1;B:=V;
    end;
  5:begin
     R:=V;G:=p1;B:=p2;
    end;
 end; { case i }
{ R:=R*63;
 G:=G*63;
 B:=B*63;}
end;  { HSVtoRGB }

constructor TGraphPath.Init(Vmemory:PVirtMemory;XGraphState:TMemDescr);
 begin
  inherited Init(VMemory);
  COTyp:=sco_GraphPath;
  DefCurrPoint:=FALSE; { not defined starting point }
  NewMemBlock(nil);  { alocate first graphic path memory block }
  CurrIndex:=1;
  CurrMemblock:=MemBlock;
  PMapMemBlock(CurrMemBlock)^[1]:=Gr_EndOfSequence;
  GraphState:=XGraphState;

  ViewCurrPath:=false;
 end;

constructor TGraphPath.InitCopy(VMemory:PVirtMemory);
 begin
  inherited Init(VMemory);
  COTyp:=sco_GraphPath;
  CurrIndex:=1;

  ViewCurrPath:=false;
 end;

destructor TGraphPath.Done;
 begin
  ReleaseAllBlocks;
  inherited Done;
 end;

function TGraphPath.Copy(AVMemory:PObject):PCompObject;
  var B:PGraphPath;
  begin
   B:=new(PGraphPath,InitCopy(PVirtMemory(AVMemory)));
   CopyAllBlocks(B);
{   B^.MemBlock:=nil;}
   B^.DefCurrPoint:=DefCurrPoint; { not defined starting point }
   B^.CurrMemblock:=B^.MemBlock;
   B^.GraphState:=GraphState;
   Copy:=B;
  end;



procedure TGraphPath.NewMemBlock(PointerToBlock:PGrNextBlock);
 begin
  if PointerToBlock=nil then GetMem(MemBlock,SizeMemBlock)
			else GetMem(PointerToBlock^.NextBlock,SizeMemBlock);
 end;

procedure TGraphPath.ReleaseAllBlocks;
 var i:integer;
     B:byte;
 begin
  if MemBlock=nil then exit;
  i:=1;
  repeat
   B:=PMapMemBlock(MemBlock)^[i];
   case B of
    Gr_Move:inc(i,sizeof(TGrLine));
    Gr_Line:inc(i,sizeof(TGrLine));
    Gr_ClosePath:inc(i,sizeof(TGrLine));
    Gr_Curve:inc(i,sizeof(TGrCurve));
    Gr_NextBlock:begin
		  CurrMemBlock:=MemBlock;
		  pointer(MemBlock):=pointer((PMapMemBlock(MemBlock))^[i+1]);
		  freemem(CurrMemBlock,SizeMemBlock);
		 end;
    Gr_EndOfSequence:begin
		      freemem(MemBlock,SizeMemBlock);
		      MemBlock:=nil;
		     end;
   end;
  until (B=Gr_NextBlock)or(B=Gr_EndOfSequence);
  if B=Gr_NextBlock then ReleaseAllBlocks;
 end;

procedure TGraphPath.CopyAllBlocks(NewP:PGraphPath);
 var i:integer;
     B:byte;
     AMemBlock:pointer;
     AFrom,ATo:PGrNextBlock;
 begin
  AMemBlock:=MemBlock;
  if AMemBlock=nil then exit;
  NewP^.NewMemBlock(nil); { The first graphpath memory block }
  if NewP^.MemBlock=nil then exit;
  move(AMemBlock^,NewP^.MemBlock^,SizeMemBlock);
  NewP^.CurrMemBlock:=NewP^.MemBlock;
  i:=1;
  repeat
   B:=PMapMemBlock(AMemBlock)^[i];
   case B of
    Gr_Move:inc(i,sizeof(TGrLine));
    Gr_Line:inc(i,sizeof(TGrLine));
    Gr_ClosePath:inc(i,sizeof(TGrLine));
    Gr_Curve:inc(i,sizeof(TGrCurve));
    Gr_NextBlock:begin
		  NewP^.NewMemBlock(PGrNextBlock(@PMapMemBlock(NewP^.CurrMemBlock)^[i]));
		  AFrom:=PGrNextBlock(@PMapMemBlock(AMemBlock)^[i]);
		  ATo:=PGrNextBlock(@PMapMemBlock(NewP^.CurrMemBlock)^[i]);
{		  pointer(NewP^.CurrMemBlock):=pointer((PMapMemBlock(NewP^.CurrMemBlock))^[i+1]);
		  pointer(AMemBlock):=pointer((PMapMemBlock(AMemBlock))^[i+1]);}
		  AMemBlock:=AFrom^.NextBlock;
		  NewP^.CurrMemBlock:=ATo^.NextBlock;
		  move(AFrom^.Nextblock^,ATo^.NextBlock^,SizememBlock);
		  i:=1; { Reset offset inside graphpath memory block }
		 end;
    Gr_EndOfSequence:;
   end;
  until (B=Gr_EndOfSequence);
 end;

procedure TGraphPath.InsertNextBlock;
 var NextBlck:TGrNextBlock;
 begin
    NextBlck.Code:=Gr_NextBlock;
    NewMemBlock(@NextBlck);
    move(NextBlck,PMapMemBlock(CurrMemBlock)^[CurrIndex],sizeof(TGrNextBlock));
    CurrIndex:=1;
    CurrMemBlock:=NextBlck.NextBlock;
    PMapMemBlock(CurrMemBlock)^[CurrIndex]:=Gr_EndOfSequence;
 end;

procedure TGraphPath.InsertCurve(PX1,PY1,PX2,PY2,PX3,PY3:TReal);
 var Curve:TGrCurve;
     ACTM:PMatrix;
 begin
  if CurrIndex>UpperLimit then InsertNextBlock;
  with Curve do
   begin
    Code:=Gr_Curve;
    ACTM:=PMatrix(PVirtMemory(VMem)^.GetPointer(PGraphState(PVirtMemory(VMem)^.GetPointer(GraphState))^.CTM));
    TransCoord(ACTM,PX1,PY1,P1.X,P1.Y);
    TransCoord(ACTM,PX2,PY2,P2.X,P2.Y);
    TransCoord(ACTM,PX3,PY3,P3.X,P3.Y);
    with CurrentPoint do
     begin
      X:=P3.X;
      Y:=P3.Y;
     end;
   end;
  move(Curve,PMapMemBlock(CurrMemBlock)^[CurrIndex],sizeof(TGrCurve));
  inc(CurrIndex,sizeof(TGrCurve));
  PMapMemBlock(CurrMemBlock)^[CurrIndex]:=Gr_EndOfSequence;
 end;

procedure TGraphPath.InsertLine(PX1,PY1:TReal);
 var Line:TGrLine;
     ACTM:PMatrix;
 begin
  if CurrIndex>UpperLimit then InsertNextBlock;
  with Line do
   begin
    Code:=Gr_Line;
    ACTM:=PMatrix(PVirtMemory(VMem)^.GetPointer(PGraphState(PVirtMemory(VMem)^.GetPointer(GraphState))^.CTM));
    TransCoord(ACTM,PX1,PY1,P1.X,P1.Y);
    with CurrentPoint do
     begin
      X:=P1.X;
      Y:=P1.Y;
     end;
   end;
  move(Line,PMapMemBlock(CurrMemBlock)^[CurrIndex],sizeof(TGrLine));
  inc(CurrIndex,sizeof(TGrLine));
  PMapMemBlock(CurrMemBlock)^[CurrIndex]:=Gr_EndOfSequence;
 end;


procedure TGraphPath.InsertMove(PX1,PY1:TReal);
 var Line:TGrLine;
     ACTM:PMatrix;
 begin
  ACTM:=PMatrix(PVirtMemory(VMem)^.GetPointer(PGraphState(PVirtMemory(VMem)^.GetPointer(GraphState))^.CTM));
  if CurrIndex>UpperLimit then InsertNextBlock;
  DefCurrPoint:=TRUE;
  with StartPoint do
   begin
    TransCoord(ACTM,PX1,PY1,X,Y);
   end;
  with Line do
   begin
    Code:=Gr_Move;
    TransCoord(ACTM,PX1,PY1,P1.X,P1.Y);
    with CurrentPoint do
     begin
      X:=P1.X;
      Y:=P1.Y;
     end;
   end;
  move(Line,PMapMemBlock(CurrMemBlock)^[CurrIndex],sizeof(TGrLine));
  inc(CurrIndex,sizeof(TGrLine));
  PMapMemBlock(CurrMemBlock)^[CurrIndex]:=Gr_EndOfSequence;
 end;

procedure TGraphPath.InsertClosePath;
 var Line:TGrLine;
 begin
  if CurrIndex>UpperLimit then InsertNextBlock;
  with Line,StartPoint do
   begin
    Code:=Gr_ClosePath;
    P1.X:=X; { Start point was already modified }
    P1.Y:=Y;
    CurrentPoint.X:=X;
    CurrentPoint.Y:=Y;
   end;
  move(Line,PMapMemBlock(CurrMemBlock)^[CurrIndex],sizeof(TGrLine));
  inc(CurrIndex,sizeof(TGrLine));
  PMapMemBlock(CurrMemBlock)^[CurrIndex]:=Gr_EndOfSequence;
 end;

procedure TGraphPath.InsertArc(ClockWise:boolean;XC,YC,Radius:TReal;Angle1:TReal;Angle2:TReal);
 var Angle1Rad,Angle2Rad:TReal;
     X0,Y0,Sin0,Cos0:TReal;
     X3R,Y3R:TReal;
     Work1:TReal;
     First:boolean;
     Diff:TReal;
     TRad:TReal;
 begin { InsertArc }
  First:=true;
  if (Radius<0) then
   begin { if 1 }
    Angle1:=Angle1+180;
    Angle2:=Angle2+180;
    Radius:=-Radius;
   end;  { if 1 }
  Angle1Rad:=Angle1/180*pi;
  sin0:=Radius*sin(Angle1Rad);
  cos0:=Radius*cos(Angle1Rad);
  X0:=XC+Cos0;
  Y0:=YC+Sin0;
  if ClockWise then
   begin { if 1 }
    while (Angle1<Angle2) do Angle2:=Angle2-360;
    while (Angle2-Angle1<-90) do
     begin { while 1 }
      Work1:=Sin0;Sin0:=-Cos0;Cos0:=Work1;
      X3R:=XC+Cos0;
      Y3R:=YC+Sin0;
      AddArc(First,Radius,X0,Y0,X3R,Y3R,X0+Cos0,Y0+Sin0);
      X0:=X3R;
      Y0:=Y3R;
      Angle1:=Angle1-90;
      First:=false;
     end;  { while 1 }
   end   { if 1 } else
   begin { else 1 }
    while(Angle2<Angle1)do Angle2:=Angle2+360;
    while(Angle2-Angle1>90)do
     begin { while 1}
      Work1:=Cos0;Cos0:=-Sin0;Sin0:=Work1;
      X3R:=XC+Cos0;
      Y3R:=Yc+Sin0;
      AddArc(First,Radius,X0,Y0,X3R,Y3R,X0+Cos0,Y0+Sin0);
      X0:=X3R;
      Y0:=Y3R;
      Angle1:=Angle1+90;
      First:=false;
     end;  { while 1}
   end;  { else 1 }
  Diff:=Angle2-Angle1;
  Work1:=Diff/360*pi;
  TRad:=sin(Work1)/cos(Work1);
  Angle2Rad:=Angle2/180*pi;
  AddArc(First,Radius,X0,Y0,
	 (XC+Radius*cos(Angle2Rad)),
	 (YC+Radius*sin(Angle2Rad)),
	 (X0-TRad*Sin0),
	 (Y0+TRad*Cos0));
 end;  { InsertArc }

procedure TGraphPath.AddArc(First:boolean;Radius,X0,Y0,X3,Y3,XT,YT:TReal);
 var DX,DY:TReal;
     Fraction:TReal;
     P0,P3,PT,CPT:TReal;
 begin { AddArc }
  DX:=XT-X0;
  DY:=YT-Y0;
  Fraction:=(4/3)/(1+sqrt(1+(dx*dx+dy*dy)/(Radius*Radius)));
  if First then
   if DefCurrPoint then
    begin { if 1 }
     InsertLine(X0,Y0);
    end   { if 1 }            else
    begin { else 1 }
     InsertMove(X0,Y0);
    end;  { else 1 }
  InsertCurve(X0+(XT-X0)*Fraction,Y0+(YT-Y0)*Fraction,
              X3+(XT-X3)*Fraction,Y3+(YT-Y3)*Fraction,
              X3,Y3);
 end;  { AddArc }

procedure DrawCurve(DragDc:HDC;X0,Y0,X1,Y1,X2,Y2,X3,Y3:TReal;Eps:TReal);
  var dx,dy,x01,y01,x12,y12,x23,y23,x012,y012,x123,y123,x0123,y0123:TReal;
      N1,N2:TReal;
      D:TReal;
  begin
   dx:=x3-x0;
   dy:=y3-y0;
   N1:=dy*(x1-x0)-dx*(y1-y0);
   N2:=dy*(x2-x0)-dx*(y2-y0);
   D:=sqrt(dy*dy+dx*dx);
   if (D<>0)and(abs(N1)/D<eps)and(abs(N2)/D<eps)then
    begin
{     MoveTo(DragDC,round(x0),round(y0));}
     LineTo(DragDC,round(x3),round(y3))
    end
                                       else
    begin
     x01:=(x1+x0)/2;
     y01:=(y1+y0)/2;
     x12:=(x2+x1)/2;
     y12:=(y2+y1)/2;
     x23:=(x3+x2)/2;
     y23:=(y3+y2)/2;
     x012:=(x12+x01)/2;
     y012:=(y12+y01)/2;
     x123:=(x12+x23)/2;
     y123:=(y12+y23)/2;
     x0123:=(x012+x123)/2;
     y0123:=(y012+y123)/2;
     DrawCurve(DragDc,x0,y0,x01,y01,x012,y012,x0123,y0123,eps);
     DrawCurve(DragDc,x0123,y0123,x123,y123,x23,y23,x3,y3,eps);
    end;
 end;


procedure TGraphPath.DrawPath(DragDc:HDC);
 var Segment,Offset:word;
     Pt:pointer;
     PX0,PY0,PX1,PY1,PX2,PY2,PX3,PY3:TReal;
     Position:TPoint;
     OldPen,ThePen:HPen;
     OldClip:HRgn;
     AGraphState:PGraphState;
 begin
  AGraphState:=PGraphState(PVirtMemory(VMem)^.GetPointer(GraphState));
  if (AGraphState^.ClipPath<>NULL)and not ViewCurrPath then
   begin { if 1}
    AGraphState^.DefClipPath;
    OldClip:=SelectObject(DragDC,AGraphState^.ClipRgn);
   end;  { if 1 }
  ThePen:=CreatePen(PS_Solid,round(AGraphState^.LWidth),AGraphState^.Color);
  OldPen:=SelectObject(DragDC,ThePen);
  Segment:=Seg(MemBlock^);
  Offset:=Ofs(MemBlock^);
  while byte(Ptr(Segment,Offset)^)<>Gr_EndOfSequence do
   case byte(Ptr(Segment,Offset)^) of
    Gr_Move:begin
	     inc(Offset,1);
	     MoveTo(DragDc,round(TReal(Ptr(Segment,Offset)^)),
			   round(TReal(Ptr(Segment,Offset+sizeof(TReal))^)));
	     inc(Offset,sizeof(TReal) shl 1);
	    end;
    Gr_Line,Gr_ClosePath:begin
             inc(Offset,1);
             LineTo(DragDc,round(TReal(Ptr(Segment,Offset)^)),
                           round(TReal(Ptr(Segment,Offset+sizeof(TReal))^)));
             inc(Offset,sizeof(TReal) shl 1);
	    end;
    Gr_Curve:begin
              longint(Position):=GetCurrentPosition(DragDC);
	      inc(Offset,1);
              PX1:=TReal(Ptr(Segment,Offset)^);
	      inc(Offset,sizeof(TReal));
              PY1:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PX2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PY2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PX3:=TReal(Ptr(Segment,Offset)^);
	      inc(Offset,sizeof(TReal));
              PY3:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      DrawCurve(DragDC,Position.X,Position.Y,PX1,PY1,PX2,PY2,PX3,PY3,AGraphState^.Flatness);
             end;
    Gr_NextBlock:begin
                  inc(Offset,1);
                  Pt:=pointer(Ptr(Segment,Offset)^);
                  Segment:=Seg(Pt^);
                  Offset:=Ofs(Pt^);
                 end;
   end; { while and case 1 }
   if AGraphState^.ClipPath<>NULL then
    begin { if 1 }
     SelectObject(DragDC,OldClip);
     DeleteObject(AGraphState^.ClipRgn);
    end;  { if 1 }
   SelectObject(DragDc,OldPen);
   DeleteObject(ThePen);
  end; { method }

procedure TGraphPath.FillPath(DragDc:HDC);
 label Cleaning;
 type PBuffer=^TBuffer;
      TBuffer=array [0..65531 div sizeof(TPoint)] of TPoint;
      PBufferCount=^TBufferCount;
      TBufferCount=array [0..65531 div sizeof(integer)] of integer;
 var Segment,Offset:word;
     Buffer:PBuffer;BufferPoint:integer;
     BufferCount:PBufferCount;BufferCountPoint:integer;
     PolygonsCount:integer;
     FirstMove:boolean;
     MoveBefore:boolean;
     StPoint:TGrPoint;
     CurrPoint:TGrPoint;
     Pt:pointer;
     PX0,PY0,PX1,PY1,PX2,PY2,PX3,PY3:TReal;
     Position:TPoint;
     OldBrush,TheBrush:HBrush;
     OldClip:HRgn;
     AGraphState:PGraphState;

     procedure FillCurve(X0,Y0,X1,Y1,X2,Y2,X3,Y3:TReal;Eps:TReal);
       var dx,dy,x01,y01,x12,y12,x23,y23,x012,y012,x123,y123,x0123,y0123:TReal;
           N1,N2:TReal;
           D:TReal;
       begin { interior procedure FillCurve }
        dx:=x3-x0;
        dy:=y3-y0;
        N1:=dy*(x1-x0)-dx*(y1-y0);
        N2:=dy*(x2-x0)-dx*(y2-y0);
        D:=sqrt(dy*dy+dx*dx);
        if (D<>0)and(abs(N1)/D<eps)and(abs(N2)/D<eps)then
         begin { if 1 }
             if MoveBefore then
              begin { if 2 }
               Buffer^[BufferPoint].X:=round(StPoint.X);
               Buffer^[BufferPoint].Y:=round(StPoint.Y);
               MoveBefore:=false;
	       inc(BufferPoint);
               inc(PolygonsCount);
               inc(BufferCount^[BufferCountPoint]);
              end;  { if 2 }
             Buffer^[BufferPoint].X:=round(x3);
             Buffer^[BufferPoint].Y:=round(y3);
	     inc(BufferPoint);
	     inc(BufferCount^[BufferCountPoint]);
         end   { if 1 }
					    else
         begin { else 1 }
          x01:=(x1+x0)/2;
          y01:=(y1+y0)/2;
	  x12:=(x2+x1)/2;
          y12:=(y2+y1)/2;
          x23:=(x3+x2)/2;
          y23:=(y3+y2)/2;
          x012:=(x12+x01)/2;
          y012:=(y12+y01)/2;
          x123:=(x12+x23)/2;
          y123:=(y12+y23)/2;
          x0123:=(x012+x123)/2;
          y0123:=(y012+y123)/2;
          FillCurve(x0,y0,x01,y01,x012,y012,x0123,y0123,eps);
          FillCurve(x0123,y0123,x123,y123,x23,y23,x3,y3,eps);
         end;  { else 2 }
      end; { interior procedure FillCurve }

 begin { method FillPath }
  AGraphState:=PGraphState(PVirtMemory(VMem)^.GetPointer(GraphState));
  if AGraphState^.ClipPath<>NULL then
   begin { if 1}
    AGraphState^.DefClipPath;
    OldClip:=SelectObject(DragDC,AGraphState^.ClipRgn);
   end;  { if 1 }
  TheBrush:=CreateSolidBrush(AGraphState^.Color);
  OldBrush:=SelectObject(DragDC,TheBrush);
  new(Buffer);
  BufferPoint:=0;
  new(BufferCount);
  BufferCountPoint:=-1;
{  BufferCount^[BufferCountPoint]:=0;}
  PolygonsCount:=0;
  MoveBefore:=false;
  FirstMove:=true;
  Segment:=Seg(MemBlock^);
  Offset:=Ofs(MemBlock^);
  if byte(Ptr(Segment,Offset)^)=Gr_EndOfSequence then goto Cleaning; { jump over the filling, if the graph path is empty }
  while byte(Ptr(Segment,Offset)^)<>Gr_EndOfSequence do
   case byte(Ptr(Segment,Offset)^) of
    Gr_Move:begin { case Gr_Move }
	     inc(Offset,1);
	     with StPoint do
	      begin { with StPoint }
	       if not(FirstMove) then
		begin
		 Buffer^[BufferPoint].X:=round(X);
		 Buffer^[BufferPoint].Y:=round(Y);
		 inc(BufferPoint);
		 inc(BufferCount^[BufferCountPoint]);
		end;
	       X:=TReal(Ptr(Segment,Offset)^);
                 Y:=TReal(Ptr(Segment,Offset+sizeof(TReal))^);
                 CurrPoint.x:=X;
                 CurrPoint.y:=Y;
                end;  { with StPoint }
             inc(Offset,sizeof(TReal) shl 1);
             if MoveBefore then
              begin
               inc(PolygonsCount);
              end          else MoveBefore:=true;
             inc(BufferCountPoint);
             BufferCount^[BufferCountPoint]:=0;
             FirstMove:=false;
            end;  { case Gr_Move }
    Gr_Line:begin { case Gr_Line }
             if MoveBefore then
              begin { if 1 }
               Buffer^[BufferPoint].X:=round(StPoint.X);
               Buffer^[BufferPoint].Y:=round(StPoint.Y);
	     MoveBefore:=false;
               inc(BufferPoint);
               inc(PolygonsCount);
	     inc(BufferCount^[BufferCountPoint]);
              end;  { if 1 }
             inc(Offset,1);
             with Buffer^[BufferPoint] do
              begin
               X:=round(TReal(Ptr(Segment,Offset)^));
               Y:=round(TReal(Ptr(Segment,Offset+sizeof(TReal))^));
               CurrPoint.X:=X;
               CurrPoint.Y:=Y;
              end;
             inc(BufferPoint);
             inc(BufferCount^[BufferCountPoint]);
             inc(Offset,sizeof(TReal) shl 1);
	  end;               { case Gr_Line }
    Gr_ClosePath:begin { case Gr_ClosePath }
                  if MoveBefore then
                    begin
                     inc(Offset,1);
                     inc(Offset,sizeof(TReal) shl 1 );
		     exit;
                    end;
                  inc(Offset,1);
                  with Buffer^[BufferPoint] do
                   begin
                    X:=round(TReal(Ptr(Segment,Offset)^));
                    Y:=round(TReal(Ptr(Segment,Offset+sizeof(TReal))^));
		    StPoint.X:=X;
                    StPoint.Y:=Y;
                    CurrPoint.X:=X;
                    CurrPoint.Y:=Y;
                   end;
                  inc(BufferPoint);
                  inc(BufferCount^[BufferCountPoint]);
                  inc(Offset,sizeof(TReal) shl 1);
                 end;  { case Gr_ClosePath }
    Gr_Curve:begin { case Gr_Curve }
              inc(Offset,1);
              PX1:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PY1:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PX2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PY2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PX3:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PY3:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      FillCurve(CurrPoint.X,CurrPoint.Y,PX1,PY1,PX2,PY2,PX3,PY3,AGraphState^.Flatness);
              with CurrPoint do
               begin
		X:=PX3;
                Y:=PY3;
               end;
             end;  { case Gr_Curve }
    Gr_NextBlock:begin { case Gr_NextBlock }
                  inc(Offset,1);
                  Pt:=pointer(Ptr(Segment,Offset)^);
                  Segment:=Seg(Pt^);
                  Offset:=Ofs(Pt^);
                 end;  { case Gr_NextBlock }
  end; { case 1 and while }
   Buffer^[BufferPoint].X:=round(StPoint.X);
   Buffer^[BufferPoint].Y:=round(StPoint.Y);
   inc(BufferPoint);
   inc(BufferCount^[BufferCountPoint]);
   if PolygonsCount=1 then
    begin { if 2 }
     Polygon(DragDC,Buffer^,BufferCount^[0]);
    end   { if 2 }    else
    begin { else 2 }
     PolyPolygon(DragDc,Buffer^,BufferCount^,PolygonsCount);
    end;  { else 2 }
Cleaning:
   dispose(Buffer);
   dispose(BufferCount);
   if AGraphState^.ClipPath<>NULL then
    begin { if 1 }
     SelectObject(DragDC,OldClip);
     DeleteObject(AGraphState^.ClipRgn);
    end;  { if 1 }
   SelectObject(DragDC,OldBrush);
   DeleteObject(TheBrush);
  end; { method FillPath }

procedure TGraphState.DefClipPath;
 type PBuffer=^TBuffer;
      TBuffer=array [0..65531 div sizeof(TPoint)] of TPoint;
      PBufferCount=^TBufferCount;
      TBufferCount=array [0..65531 div sizeof(integer)] of integer;
 var Segment,Offset:word;
     Buffer:PBuffer;BufferPoint:integer;
     BufferCount:PBufferCount;BufferCountPoint:integer;
     PolygonsCount:integer;
     FirstMove:boolean;
     MoveBefore:boolean;
     StPoint:TGrPoint;
     CurrPoint:TGrPoint;
     Pt:pointer;
     PX0,PY0,PX1,PY1,PX2,PY2,PX3,PY3:TReal;
     Position:TPoint;
     OldBrush,TheBrush:HBrush;
     ClPath:PGraphPath;

     procedure DefClipCurve(X0,Y0,X1,Y1,X2,Y2,X3,Y3:TReal;Eps:TReal);
       var dx,dy,x01,y01,x12,y12,x23,y23,x012,y012,x123,y123,x0123,y0123:TReal;
           N1,N2:TReal;
           D:TReal;
       begin { interior procedure DefClipCurve }
	dx:=x3-x0;
        dy:=y3-y0;
        N1:=dy*(x1-x0)-dx*(y1-y0);
        N2:=dy*(x2-x0)-dx*(y2-y0);
        D:=sqrt(dy*dy+dx*dx);
        if (D<>0)and(abs(N1)/D<eps)and(abs(N2)/D<eps)then
         begin { if 1 }
             if MoveBefore then
              begin { if 2 }
	       Buffer^[BufferPoint].X:=round(StPoint.X);
               Buffer^[BufferPoint].Y:=round(StPoint.Y);
               MoveBefore:=false;
               inc(BufferPoint);
	       inc(PolygonsCount);
               inc(BufferCount^[BufferCountPoint]);
              end;  { if 2 }
             Buffer^[BufferPoint].X:=round(x3);
             Buffer^[BufferPoint].Y:=round(y3);
             inc(BufferPoint);
             inc(BufferCount^[BufferCountPoint]);
         end   { if 1 }
					    else
	 begin { else 1 }
          x01:=(x1+x0)/2;
          y01:=(y1+y0)/2;
          x12:=(x2+x1)/2;
	  y12:=(y2+y1)/2;
          x23:=(x3+x2)/2;
          y23:=(y3+y2)/2;
          x012:=(x12+x01)/2;
          y012:=(y12+y01)/2;
          x123:=(x12+x23)/2;
          y123:=(y12+y23)/2;
          x0123:=(x012+x123)/2;
          y0123:=(y012+y123)/2;
	  DefClipCurve(x0,y0,x01,y01,x012,y012,x0123,y0123,eps);
          DefClipCurve(x0123,y0123,x123,y123,x23,y23,x3,y3,eps);
         end;  { else 2 }
      end; { interior procedure DefClipCurve }

 begin { method DefClipPath }
  ClPath:=PGraphPath(PVirtMemory(VMem)^.GetPointer(ClipPath));
  new(Buffer);
  BufferPoint:=0;
  new(BufferCount);
  BufferCountPoint:=-1;
{  BufferCount^[BufferCountPoint]:=0;}
  PolygonsCount:=0;
  MoveBefore:=false;
  FirstMove:=true;
  Segment:=Seg(PGraphPath(ClPath)^.MemBlock^);
  Offset:=Ofs(PGraphPath(ClPath)^.MemBlock^);
  while byte(Ptr(Segment,Offset)^)<>Gr_EndOfSequence do
   case byte(Ptr(Segment,Offset)^) of
    Gr_Move:begin { case Gr_Move }
             inc(Offset,1);
             with StPoint do
              begin { with StPoint }
               if not(FirstMove) then
                begin
                 Buffer^[BufferPoint].X:=round(X);
                 Buffer^[BufferPoint].Y:=round(Y);
		 inc(BufferPoint);
                 inc(BufferCount^[BufferCountPoint]);
                end;
               X:=TReal(Ptr(Segment,Offset)^);
	       Y:=TReal(Ptr(Segment,Offset+sizeof(TReal))^);
               CurrPoint.X:=X;
               CurrPoint.Y:=Y;
              end;  { with StPoint }
             inc(Offset,sizeof(TReal) shl 1);
             if MoveBefore then
              begin
               inc(PolygonsCount);
              end          else MoveBefore:=true;
             inc(BufferCountPoint);
             BufferCount^[BufferCountPoint]:=0;
             FirstMove:=false;
	    end;  { case Gr_Move }
    Gr_Line:begin { case Gr_Line }
             inc(Offset,1);
             if MoveBefore then
	      begin { if 1 }
               Buffer^[BufferPoint].X:=round(StPoint.X);
               Buffer^[BufferPoint].Y:=round(StPoint.Y);
               MoveBefore:=false;
               inc(BufferPoint);
               inc(PolygonsCount);
               inc(BufferCount^[BufferCountPoint]);
              end;  { if 1 }
             with Buffer^[BufferPoint] do
	      begin
               X:=round(TReal(Ptr(Segment,Offset)^));
               Y:=round(TReal(Ptr(Segment,Offset+sizeof(TReal))^));
               CurrPoint.X:=X;
	       CurrPoint.Y:=Y;
              end;
             inc(BufferPoint);
             inc(BufferCount^[BufferCountPoint]);
             inc(Offset,sizeof(TReal) shl 1);
            end;               { case Gr_Line }
    Gr_ClosePath:begin { case Gr_ClosePath }
                  inc(Offset,1);
                  if MoveBefore then
		   begin
                    inc(Offset,1);
		    inc(Offset,sizeof(TReal)shl 1);
                    exit;
		   end;
                  with Buffer^[BufferPoint] do
                   begin
                    X:=round(TReal(Ptr(Segment,Offset)^));
                    Y:=round(TReal(Ptr(Segment,Offset+sizeof(TReal))^));
		    StPoint.X:=X;
                    StPoint.Y:=Y;
                    CurrPoint.X:=X;
                    CurrPoint.Y:=Y;
		   end;
                  inc(BufferPoint);
		  inc(BufferCount^[BufferCountPoint]);
                  inc(Offset,sizeof(TReal) shl 1);
		 end;  { case Gr_ClosePath }
    Gr_Curve:begin { case Gr_Curve }
              inc(Offset,1);
              PX1:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PY1:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
              PX2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PY2:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PX3:=TReal(Ptr(Segment,Offset)^);
              inc(Offset,sizeof(TReal));
	      PY3:=TReal(Ptr(Segment,Offset)^);
	      inc(Offset,sizeof(TReal));
              DefClipCurve(CurrPoint.X,CurrPoint.Y,PX1,PY1,PX2,PY2,PX3,PY3,Flatness);
              with CurrPoint do
               begin
                X:=PX3;
                Y:=PY3;
               end;
             end;  { case Gr_Curve }
    Gr_NextBlock:begin { case Gr_NextBlock }
                  inc(Offset,1);
		  Pt:=pointer(Ptr(Segment,Offset)^);
                  Segment:=Seg(Pt^);
		  Offset:=Ofs(Pt^);
                 end;  { case Gr_NextBlock }
   end; { case 1 }
   Buffer^[BufferPoint].X:=round(StPoint.X);
   Buffer^[BufferPoint].Y:=round(StPoint.Y);
   inc(BufferPoint);
   inc(BufferCount^[BufferCountPoint]);
   if PolygonsCount=1 then
    begin { if 2 }
     ClipRgn:=CreatePolygonRgn(Buffer^,BufferCount^[0],WINDING);
    end   { if 2 }    else
    begin { else 2 }
     ClipRgn:=CreatePolyPolygonRgn(Buffer^,BufferCount^,PolygonsCount,WINDING);
    end;  { else 2 }
   dispose(Buffer);
   dispose(BufferCount);
  end; { method DefClipPath }


constructor TWinGraphPath.Init(AParent:PWindowsObject;AGrPath:PGraphPath);
 begin
  inherited Init(AParent,'Current graph path');
  Attr.Style:=Attr.Style or WS_VScroll or WS_HScroll;
  Scroller:=new(PScroller,Init(@Self,XUnit,YUnit,XPageRange,YPageRange));
  Scroller^.XPage:=72;
  Scroller^.YPage:=72;
  GrPath:=AGrPath;
 end;

destructor TWinGraphPath.Done;
 begin
  SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,6,0);
  inherited Done;
 end;

procedure TWinGraphPath.Paint(PaintDC:HDC;var PaintStruct:TPaintStruct);
 const PathColor=$00000000;
 var   OldColor:longint;
       LineWidth:TReal;
       GrState:PGraphState;
 begin
  GrState:=PGraphState(SendMessage(Application^.MainWindow^.HWindow,GI_GRAPHSTATE,0,0));
  GrPath:=PGraphPath(SendMessage(Application^.MainWindow^.HWindow,GI_GRAPHPATH,0,0));
  if GrPath=nil then
   begin
    MessageBox(Application^.MainWindow^.HWindow,'Error in the unit GRAFIKA. Current graph path is not available',
                                         'System error',MB_ICONEXCLAMATION+MB_OK);
    PostMessage(HWindow,WM_CLOSE,0,0);
    exit;
   end;
  OldColor:=GrState^.Color;
  GrState^.Color:=PathColor;
  LineWidth:=GrState^.LWidth;
  GrState^.LWidth:=1;
  GrPath^.ViewCurrPath:=true;
  GrPath^.DrawPath(PaintDC);
  GrPath^.ViewCurrPath:=false;
  GrState^.Color:=OldColor;
  GrState^.LWidth:=LineWidth;
 end;

constructor TWinClipPath.Init(AParent:PWindowsObject; AGraphState:PGraphState);
 begin
  inherited Init(AParent,'Current clip path');
  Attr.Style:=Attr.Style or WS_VScroll or WS_HScroll;
  Scroller:=new(PScroller,Init(@Self,XUnit,YUnit,XPageRange,YPageRange));
  Scroller^.XPage:=72;
  Scroller^.YPage:=72;
  GrState:=AGraphState;
 end;

destructor TWinClipPath.Done;
 begin
  SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,7,0);
  inherited Done;
 end;

procedure TWinClipPath.Paint(PaintDC:HDC;var PaintStruct:TPaintStruct);
 const ClipColor=$00000000;
       PathColor=$0000FF00;

 var X,Y:TMemDescr;
     GrPath:PGraphPath;
     OldColor:longint;
     LineWidth:TReal;
 begin
  GrState:=PGraphState(SendMessage(Application^.MainWindow^.HWindow,GI_GRAPHSTATE,0,0));
  OldColor:=GrState^.Color;
  GrState^.Color:=ClipColor;
  LineWidth:=GrState^.LWidth;
  GrState^.LWidth:=1;
  if GrState=nil then
   begin
    MessageBox(Application^.MainWindow^.HWindow,'Error in the unit GRAFIKA. Current clip path is not available',
                                         'System error',MB_ICONEXCLAMATION+MB_OK);
    PostMessage(HWindow,WM_CLOSE,0,0);
    exit;
   end;
  with GrState^ do
   begin
    if ClipPath<>NULL then
     begin
      X:=ClipPath;
      Y:=Path;
      Path:=ClipPath;
      ClipPath:=NULL;
      ClPath:=PGraphPath(SendMessage(Application^.MainWindow^.HWindow,GI_GRAPHPATH,0,0));
      if ClPath=nil then
       begin
        MessageBox(Application^.MainWindow^.HWindow,'Error in the unit GRAFIKA. Current clip path is not available',
                                            'System error',MB_ICONEXCLAMATION+MB_OK);
        PostMessage(HWindow,WM_CLOSE,0,0);
        exit;
       end;
      ClPath^.FillPath(PaintDC);
      ClipPath:=X;
      Path:=Y;
     end;
   end;
  GrState^.Color:=PathColor;
  GrPath:=PGraphPath(SendMessage(Application^.MainWindow^.HWindow,GI_GRAPHPATH,0,0));
  if GrPath=nil then
   begin
    MessageBox(Application^.MainWindow^.HWindow,'Error in the unit GRAFIKA. Current graph path is not available',
                                         'System error',MB_ICONEXCLAMATION+MB_OK);
    PostMessage(HWindow,WM_CLOSE,0,0);
    exit;
   end;
  GrPath^.ViewCurrPath:=true;
  GrPath^.DrawPath(PaintDC);
  GrPath^.ViewCurrPath:=false;
  GrState^.Color:=OldColor;
  GrState^.LWidth:=LineWidth;
 end;

constructor TWinPaint.Init(AParent:PWindowsObject);
 begin
  inherited Init(AParent,'Graph page');
  Attr.Style:=Attr.Style or WS_VScroll or WS_HScroll;
  Scroller:=new(PScroller,Init(@Self,XUnit,YUnit,XPageRange,YPageRange));
  Scroller^.XPage:=72;
  Scroller^.YPage:=72;
  BitmapDC:=0;
 end;

destructor TWinPaint.Done;
 begin
  inherited Done;
  SendMessage(Application^.MainWindow^.HWindow,WM_USER+WM_WINCLOSED,8,0);
 end;

procedure TWinPaint.Paint(DC:HDC;var PaintStruct:TPaintStruct);
 var F:HDC;
     OldCursor:HCursor;
 begin
  OldCursor:=SetCursor(LoadCursor(0,IDC_WAIT));
  BitBlt(DC,0,0,576,792,BitmapDC,0,0,SRCCOPY);
  SetCursor(OldCursor);
 end;

constructor TWinPreview.Init(AParent:PWindowsObject);
 begin
  inherited Init(AParent,'Preview');
  Reduction:=0.25;
  BitmapDC:=0;
  with Attr do
   begin
    Style:=Attr.Style and not(WS_THICKFRAME) or WS_POPUPWINDOW or WS_SYSMENU or WS_MINIMIZEBOX;
    X:=0;
    Y:=0;
    W:=round(576*Reduction)+8;
    H:=round(792*Reduction)+27;
   end;
 end;

procedure TWinPreview.SetupWindow;
 begin
  inherited SetupWindow;
  Attr.Style:=Attr.Style and not(WS_THICKFRAME) or WS_POPUPWINDOW or WS_SYSMENU or WS_MINIMIZEBOX;
 end;

procedure TWinPreview.Paint(DC:HDC;var PaintStruct:TPaintStruct);
 var OldBrush:HBrush;
     OldCursor:HCursor;
 begin
  { Dark gray background }
  OldBrush:=SelectObject(DC,GetStockObject(DKGRAY_BRUSH));
  with Attr do Rectangle(DC,X,Y,W,H);
  SelectObject(DC,OldBrush);

  { Bitmap }
  OldCursor:=SetCursor(LoadCursor(0,IDC_WAIT));
  StretchBlt(DC,0,0,round(576*Reduction),round(792*Reduction),BitmapDC,0,0,576,792,SRCCOPY);
  SetCursor(OldCursor);
 end;

destructor TWinPreview.Done;
 begin
  inherited Done;
  SendMessage(Application^.MainWindow^.HWindow,WM_USER+WM_WINCLOSED,9,0);
 end;

constructor TGraphState.Init(VMemory:PVirtMemory);
 begin
  inherited Init(VMemory);
  COTyp:=sco_GraphState;
  LWidth:=1;
  Flatness:=0.20;
  MiterLimit:=10;
  ClipPath:=NULL;
  CTM:=NULL;
  Path:=NULL;
  Color:=RGB(0,0,0);
 end;

destructor TGraphState.Done;
 begin
  inherited Done;
 end;

function TGraphState.Copy(AVMemory:PObject):PCompObject;
 var B:PGraphState;
 begin
  B:=new(PGraphstate,Init(PVirtMemory(AVMemory)));
  B^.CTM:=CTM;  { memory descriptor of transformation matrix }
  B^.Color:=Color;
  B^.PosX:=PosX;
  B^.PosY:=PosY;    { current position of graphic cursor }
  B^.Path:=Path;      { memory descriptor of graph path }
  B^.ClipPath:=ClipPath;  { memory descriptor of clipping graph path }
  B^.ClipRgn:=ClipRgn;
  B^.Font:=Font;
  B^.LWidth:=LWidth;  { width of line }
  B^.LCap:=LCap;    { capse of end of line }
  B^.LJoin:=LJoin;   { type join of two lines }
  B^.HelfTScreen:=HelfTScreen;  {  }
  B^.Transfer:=Transfer;   { transfer user halftone to device procedure }
  B^.Flatness:=Flatness;
  B^.MiterLimit:=MiterLimit;
  B^.DashPattern:=DashPattern;
  B^.Device:=Device;   { current output device }
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;

constructor TGraphStack.Init(AVMemory:PVirtMemory);
 begin
  VirtMemory:=AVMemory;
  Bottom:=MaxGSaveLevel;
  Top:=0;
  Curr:=-1;
 end;

function TGraphStack.Copy(AVMemory:PVirtMemory):PGraphStack;
 var B:PgraphStack;
 begin
  B:=new(PGraphStack,Init(AVMemory));
  B^.Curr:=Curr;
  B^.POBOX:=POBOX;
 end;

function TGraphStack.Push(Element:TGraphsaveRecord):bool;
 var A,B,C,D:TMemDescr;
     XA:PGraphState;
     XB:PGraphPath;
     XC:PGraphPath;
 begin
    if Curr<MaxGSaveLevel then
   begin { if 1 }
    inc(Curr);
    with Element do
     begin
      XA:=PGraphstate(VirtMemory^.GetPointer(XGraphState)^.Copy(VirtMemory));
      VirtMemory^.Alloc(XA,A);
      XB:=PGraphPath(VirtMemory^.GetPointer(XGraphPath)^.Copy(VirtMemory));
      VirtMemory^.Alloc(XB,B);
      if XClipPath<>NULL then
       begin
	XC:=PGraphPath(VirtMemory^.GetPointer(XClipPath)^.Copy(VirtMemory));
	VirtMemory^.Alloc(XC,C);
       end
			 else C:=NULL;
      VirtMemory^.Alloc(VirtMemory^.GetPointer(XCTM)^.Copy(VirtMemory),D);
      XA^.Path:=B;
      XA^.ClipPath:=C;
      XA^.CTM:=D;
      XB^.GraphState:=A;
      if C<>NULL then XC^.GraphState:=A;
      VirtMemory^.Inc(A);
      VirtMemory^.Inc(B);
      VirtMemory^.Inc(C);
      VirtMemory^.Inc(D);
      XGraphState:=A;
      XGraphPath:=B;
      XClipPath:=C;
      XCTM:=D;
     end;
    POBox[Curr]:=Element;
    Push:=true;
   end   { if 1 }     else
   begin { else 1 }
    ErrorHandle^.NewValue('GRAPH STACK',err_limitcheck); { indikace chyby preteceni zasobniku }
    Push:=false;
   end;  { else 1 }
 end;

function TGraphStack.Pop(var Element:TGraphsaveRecord):bool;
 begin
  if Curr>=0 then
   begin
    Element:=POBOX[Curr];
    dec(Curr);
    with Element do
     begin
      VirtMemory^.Dec(XGraphState);
      VirtMemory^.Dec(XGraphPath);
      if XClipPath<>NULL then VirtMemory^.Dec(XClipPath);
      VirtMemory^.Dec(XCTM);
     end;
    Pop:=true;
   end       else
   begin
    Pop:=false;
   end;
 end;

function TGRaphStack.IsEmpty:bool;
 begin
  IsEmpty:=Curr<Bottom;
 end;


end.