unit Hodnoty;

{ Softwarov emulace poscriptu }
{     Definice konstant        }
{    Tom Mayer(C) 1993       }


interface


{ ********************************************************* }
{ ---                 Definice konstant                 --- }
{ ********************************************************* }

type TWhole=array [0..5] of byte;
type TReal=real;
type TMemDescr=longint;


const

WM_WINCLOSED     = 1;

NULL = -1;

cvm_proc  = 0;
cvm_dict  = 1;
cvm_str   = 2;
cvm_array = 3;
cvm_file  = 4;

cmd_File     = 0; { soubor na disku }
cmd_EditFile = 1; { editacni okno }

ct_Null          = 0;
ct_Integer       = 1;
ct_Real          = 2;
ct_Name          = 3;
ct_Mark          = 5;
ct_BackBrack     = 6;
ct_BracProc      = 7;
ct_BackBrackProc = 8;
ct_LitName   = 9;
ct_SubstName = 13;
ct_Logic     = 15;
ct_Dict      = 20;
ct_File      = 21;
ct_String    = 41;
ct_SubString = 42;
ct_DefArray  = 50;
ct_Array     = 51;
ct_SubArray  = 52;
ct_Matrix    = 53;
ct_Font      = 54;
ct_DefProc   = 60;
ct_Proc      = 61;
ct_ImpProc   = 70; { Operator }
ct_ForCyklus    = 80;
ct_RepeatCyklus = 82;
ct_LoopCyklus   = 85;

in_pop   = 1; ing_OpStackBeg = in_pop;
in_exch  = 2;
in_dup   = 3;
in_index = 5;
in_roll  = 6;
in_clear = 7;
in_count = 8;
in_mark  = 9;
in_cleartomark = 10;
in_counttomark  = 11; ing_OpStackEnd = in_counttomark;

in_add          = 12; ing_OpAritmBeg = in_add;
in_div          = 13;
in_idiv         = 14;
in_mod          = 15;
in_mul          = 16;
in_sub          = 17;
in_abs          = 18;
in_neg          = 19;
in_ceiling      = 20;
in_floor        = 21;
in_round        = 22;
in_truncate     = 23;
in_sqrt         = 24;
in_atan         = 25;
in_cos          = 26;
in_sin          = 27;
in_exp          = 28;
in_ln           = 29;
in_log          = 30;
in_rand         = 31;
in_srand        = 32;
in_rrand        = 33; ing_OpAritmEnd = in_rrand;

in_array        = 34; ing_OpArrayBeg = in_array;
in_aload        = 35;
in_astore       = 36;  ing_OpArrayEnd = in_astore;

in_dict      = 37; ing_OpDictBeg = in_dict;
in_maxlength = 38;
in_begin     = 39;
in_end       = 40;
in_def       = 41;
in_load      = 42;
in_store     = 43;
in_known     = 44;
in_where     = 45;
in_errordict      = 46;
in_systemdict     = 47;
in_userdict       = 48;
in_currentdict    = 49;
in_countdictstack = 50;
in_dictstack      = 51; ing_OpDictEnd = in_dictstack;

in_string         = 52; ing_OpStringBeg = in_string;
in_anchorsearch   = 53;
in_search         = 54; ing_OpStringEnd = in_search;

in_eq             = 55; ing_OpLogBeg = in_eq;
in_ne             = 56;
in_ge             = 57;
in_gt             = 58;
in_le             = 59;
in_lt             = 60;
in_and            = 61;
in_not            = 62;
in_or             = 63;
in_xor            = 64;
in_true           = 65;
in_false          = 66;
in_bitshift       = 67; ing_OpLogEnd = in_bitshift;

in_for            = 68;
in_repeat         = 69;
in_loop           = 70;
in_exit           = 71;
in_if             = 72;
in_ifelse         = 73;
in_stop           = 74;
in_stopped        = 75;

in_type           = 76; ing_OpTypBeg = in_type;
in_cvlit          = 77;
in_cvx            = 78;
in_xcheck         = 79;
in_executeonly    = 80;
in_noaccess       = 81;
in_readonly       = 82;
in_rcheck         = 83;
in_wcheck         = 84;
in_cvi            = 85;
in_cvn            = 86;
in_cvr            = 87;
in_cvrs           = 88;
in_cvs            = 89; ing_OpTypEnd = in_cvs;

in_file           = 90; ing_OpFileBeg = in_file;
in_closefile      = 91;
in_read           = 92;
in_write          = 93;
in_readhexstring  = 94;
in_writehexstring = 95;
in_readstring     = 96;
in_writestring    = 97;
in_readline       = 98;
in_bytesavailable = 99;
in_flush          = 100;
in_flushfile      = 101;
in_resetfile      = 102;
in_status         = 103;
in_run            = 104;
in_currentfile    = 105;
in_print          = 106;
in_stack          = 107;
in_pstack         = 108;
in_prompt         = 109;
in_echo           = 110; ing_OpFileEnd = in_echo;

in_save           = 111; ing_OpVMBeg = in_save;
in_restore        = 112;
in_vmstatus       = 113; ing_OpVMEnd = in_vmstatus;

in_bind           = 114; ing_OpMiscBeg = in_bind;
in_null           = 115;
in_usertime       = 116;
in_version        = 117; ing_OpMiscEnd = in_version;

in_gsave          = 118; ing_GraphStateBeg = in_gsave;
in_grestore       = 119;
in_grestoreall    = 120;
in_initgraphics   = 121;
in_setlinewidth   = 122;
in_currentlinewidth  = 123;
in_setlinecap     = 124;
in_currentlinecap = 125;
in_setlinejoin    = 126;
in_currentlinejoin = 127;
in_setmiterlimit   = 128;
in_currentmiterlimit = 129;
in_setdash        = 130;
in_currentdash    = 131;
in_setflat        = 132;
in_currentflat    = 132;
in_setgray        = 133;
in_currentgray    = 134;
in_sethsbcolor      = 135;
in_currenthsbcolor  = 136;
in_setrgbcolor      = 137;
in_currentrgbcolor  = 138;
in_setscreen      = 139;
in_currentscreen  = 140;
in_settransfer    = 141;
in_currenttransfer = 142; ing_GraphStateEnd = in_currenttransfer;

in_matrix         = 143; ing_CoordMatrixBeg = in_matrix;
in_initmatrix     = 144;
in_identmatrix    = 145;
in_defaultmatrix  = 146;
in_currentmatrix  = 147;
in_setmatrix      = 148;
in_translate      = 149;
in_scale          = 150;
in_rotate         = 151;
in_concat         = 152;
in_concatmatrix   = 153;
in_transform      = 154;
in_dtransform     = 155;
in_itransform     = 156;
in_idtransform    = 157;
in_invertmatrix   = 158; ing_CoordMatrixEnd = in_invertmatrix;

in_newpath        = 159; ing_GraphPathBeg = in_newpath;
in_currentpoint   = 160;
in_moveto         = 161;
in_rmoveto        = 162;
in_lineto         = 163;
in_rlineto        = 164;
in_arc            = 165;
in_arcn           = 166;
in_arcto          = 167;
in_curveto        = 168;
in_rcurveto       = 169;
in_closepath      = 170;
in_flattenpath    = 171;
in_reversepath    = 172;
in_strokepath     = 173;
in_charpath       = 174;
in_clippath       = 175;
in_pathbbox       = 176;
in_pathforall     = 177;
in_initclip       = 178;
in_clip           = 179;
in_eoclip         = 180; ing_GraphPathEnd = in_eoclip;

in_erasepage      = 181; ing_PaintingBeg = in_erasepage;
in_fill           = 182;
in_eofill         = 183;
in_stroke         = 184;
in_image          = 185;
in_imagemask      = 186; ing_PaintingEnd = in_imagemask;

in_showpage       = 187; ing_OutputBeg = in_showpage;
in_copypage       = 188;
in_banddevice     = 189;
in_framedevice    = 190;
in_nulldevice     = 191;
in_renderbands    = 192; ing_OutputEnd = in_renderbands;

in_definefont     = 193; ing_FontBeg = in_definefont;
in_findfont       = 194;
in_scalefont      = 195;
in_makefont       = 196;
in_setfont        = 197;
in_currentfont    = 198;
in_show           = 199;
in_ashow          = 200;
in_widthshow      = 201;
in_awidthshow     = 202;
in_kshow          = 203;
in_stringwidth    = 204;
in_FontDirectory  = 205;
in_StandardEncoding = 206; ing_FontEnd = in_StandardEncoding;

in_cachestatus    = 207; ing_FontCacheBeg = in_cachestatus;
in_setcachedevice = 208;
in_setcharwidth   = 209;
in_setcachelimit  = 210;
in_setcacheparams = 211;
in_currentcacheparams   = 213; ing_FontCacheEnd = in_currentcacheparams;






in_copy           = 240; { type operand dependent operator }
in_length         = 241;
in_get            = 242;
in_put            = 243;
in_putinterval    = 244;
in_getinterval    = 245;
in_forall         = 246;
in_token          = 247;

err_noerror            = 0;
err_dictfull           = 1;
err_dictstackoverflow  = 2;
err_dictstackunderflow = 3;
err_execstackoverflow  = 4;
err_execstackunderflow = 24;
err_handleerror        = 5;
err_interupt           = 6;
err_invalidacces       = 7;
err_invalidfileacces   = 26;
err_invalidexit        = 25;
err_invalidfont        = 8;
err_invalidrestore     = 9;
err_ioerror            = 10;
err_limitcheck         = 11;
err_nocurrentpoint     = 12;
err_rangecheck         = 13;
err_stackoverflow      = 14;
err_stackunderflow     = 15;
err_timeout            = 16;
err_typecheck          = 17;
err_undefined          = 18;
err_undefinedfilename  = 19;
err_undefinedresult    = 20;
err_unmatchedmark      = 21;
err_unregistered       = 22;
err_VMerror            = 23;

err_syntaxerror        = 98;    ste_syntaxerror=7;
err_Lexikal            = 98;

err_endoffile          = 99;

err_criticalerror      = 255;


{ Kosntanty stavu netrivialnich objektu Proc a Array}
co_direct              = 0;  { ProcBox ukazuje primo na data }
co_share               = 1;  { ProcBox ukazuje na sdileny objekt }

{ Konstanty urcujici typ CompObjectu }
sco_NotIdentified	= 0;
sco_String	= 1;
sco_Substring	= 2;
sco_Array		= 3;
sco_Subarray	= 4;
sco_Matrix	= 5;
sco_Dictionary	= 6;
sco_GraphState	= 7;
sco_GraphPath	= 8;
sco_Font		= 9;
sco_File            = 10;


implementation

end.