unit ObjKomp;

{ Nevyresene problemy: Sprava pro SubRet a SubArray a jejich metody Copy }

{ Softwarov emulace postcriptu }
{  Alokace pameti pro retezce   }
{    Tom Mayer (C) 1993       }

{$define DEBUG}

interface

uses Objects, OWindows, ODialogs, WinTypes, WinProcs, Strings, Hodnoty;

const MaxItem=500;
      DeltaItem=100;

type TMemDescr=longint;


type PCompObject=^TCompObject;
     TCompObject=object(TObject)
		  COTyp:word;
		  Kolik:word;
		  VMem:PObject;
                      Literal:boolean;
		  constructor Init(VMemory:PObject);
		  procedure Pridej; virtual;
		  procedure Uber;   virtual;
		  function Copy(AVMemory:PObject):PCompObject; virtual;
		 end;

type PVirtMemory=^TVirtMemory; { Object spravy virtualni pameti }
     TVirtMemory=object(TObject)
	       VM:PCollection;
	       constructor Init;
	       destructor Done; virtual;
	       function Alloc(Obj:PCompObject;var MemDescr:TMemDescr):bool;
	       function GetPointer(MemDescr:TMemDescr):PCompObject;
	       function GetMemDescr(APoint:PCompObject):TMemDescr;
	       procedure Free; { Uvolneni PCO s Kolik=0 }
	       function Copy:PVirtMemory;
	       procedure Inc(MemDescr:TMemDescr);
	       procedure Dec(MemDescr:TMemDescr);
	      end;


     PWinVMem=^TWinVMem;
     TWinVMem=object(TWindow)
	      ListWindow:PListBox;
	      VirtMem:PVirtMemory;
	      constructor Init(AParent:PWindowsObject; VMemory:PVirtMemory);
	      destructor Done; virtual;
	      procedure WMSize(var Msg:TMessage); virtual WM_FIRST+WM_SIZE;
	      procedure Seznam(VMem:PVirtMemory);
	     end;


type TPolProc=record Typ:byte;
		     case integer of
		      0:(Whole:TWhole);
		      1:(Uk:TMemDescr);
		      2:(W1,W2:word);
		      3:(HLongint:longint);
		      4:(HReal:real);
		      5:(HPRet:TMemDescr);
		      6:(HPPRoc:TMemDescr);
		      7:(HBoolean:boolean);
		      8:(HPFile:TMemDescr);
		      9:(HPDict:TMemDescr);
		     10:(HPCompObject:TMemDescr);
		     11:(HPFont:TMemDescr);
	      end;

type  PProcBox=^TProcBox;
      TProcBox=array [0..500] of TPolProc; { Polozka longint(PPRocBox^[0].Uk) urcuje jak je pole operandu opravdu velike }


type PRet=^TRet;
     TRet=object(TCompObject)
	   Count:word;  { Velikost boxu pro string }
	   Box:PChar;
	   constructor Init(VMemory:PVirtMemory;XRet:PChar; RCount:word);
	   destructor Done; virtual;
	   function Copy(AVMemory:PObject):PCompObject; virtual;
	  end;

     PSubRet=^TSubRet;
     TSubRet=object(TRet)
	      ControlRet:TMemDescr;
	      FIndex:word;
	      constructor Init(VMemory:PVirtMemory;BasicRet:TMemDescr; FirstIndex,CountSub:word);
	      destructor Done;  virtual;
	      function StartPoint:pointer;
	     end;

     PProc=^TProc;
     TProc=object(TCompObject)
	    Count:longint;
	    ProcBox:PProcBox;  { Prvni polozka v ProcBox urcuje pocet opwrandu procedury }
			       { je to voleno z duvodu nezavislosti datoveho pole na spravujicim objektu }
	    constructor Init(VMemory:PVirtMemory;Pocet:longint);     { Pocet - pocet operandu procedury }
	    procedure PlusPrvek(XPrvek:TPolProc); { Do ProcBox prida dalsi operand }
	    procedure VratPrvek(var Index:longint; var Prvek:TPolProc);
	    procedure Vloz(Index:longint; Prvek:TPolProc);
	    procedure Element(Index:longint; var Prvek:TPolProc);
	    function Size:longint;
	    function KonecProcedury(Index:longint):bool;
	    destructor Done; virtual;
	    function Copy(AVMemory:PObject):PCompObject; virtual;
	   end;

     PSubArray=^TSubArray;
     TSubArray=object(TProc)
		BasArray:TMemDescr;
		FIndex:word;
		constructor Init(VMemory:PVirtMemory;BasicArray:TMemDescr; FirstIndex,CountSub:word);
		destructor Done;  virtual;
		function StartPoint:pointer;
	       end;


type PMatrix=^TMatrix;
     TMatrix=object(TCompObject)
	      XX,XY,YX,YY,XT,YT:TReal;
	      constructor Init(VMemory:PVirtMemory);
	      destructor Done; virtual;
	      function Copy(AVMemory:PObject):PCompObject; virtual;
                procedure NewValue(AXX,AXY,AXT,AYX,AYY,AYT:TReal);
                procedure Concat(AMat:PMatrix);
	     end;

procedure IncLife(VMem:PVirtMemory;Typ:byte; Obj:TMemDescr);
procedure DecLife(VMem:PVirtMemory;Typ:byte; Obj:TMemDescr);

implementation

constructor TCompObject.Init(VMemory:PObject);
 begin
  inherited Init;
  COTyp:=sco_NotIdentified;
  Kolik:=0;
  VMem:=VMemory;
  Literal:=true;
 end;

procedure TCompObject.Pridej;
 begin
  inc(Kolik);
 end;

procedure TCompObject.Uber;
 begin
  dec(Kolik);
 end;

function TCompObject.Copy(AVMemory:PObject):PCompObject;
 begin
  VMem:=AVMemory;
  Copy:=nil;
 end;

constructor TVirtMemory.Init;
 begin
  inherited Init;
  VM:=new(PCollection,Init(20,10));
 end;

destructor TVirtMemory.Done;
 var i:integer;
 begin
  for i:=0 to VM^.Count-1 do
   begin
    if VM^.At(i)<>nil then
     begin
      dispose(PCompObject(VM^.At(i)),Done);
      VM^.AtPut(i,nil);
     end;
   end;
  dispose(VM,Done);
  inherited Done;
 end;

function TVirtMemory.Alloc(Obj:PCompObject;var MemDescr:TMemDescr):bool;
 var i:longint;
 begin
  i:=VM^.Count;
  if VM^.Count=0
   then
    VM^.Insert(Obj)
   else
    begin
{     while (i<VM^.Count)and(VM^.At(i)<>nil) do inc(i);}
{     if i<VM^.Count then VM^.AtPut(i,Obj)}
		    VM^.Insert(Obj);
    end;
  MemDescr:=i;
  Alloc:=true;
 end;

function TVirtMemory.GetPointer(MemDescr:TMemDescr):PCompObject;
 begin
  if MemDescr<>NULL then GetPointer:=VM^.At(MemDescr)
		else GetPointer:=nil;
 end;

function TVirtMemory.GetMemDescr(APoint:PCompObject):TMemDescr;
 var idx:TMemDescr;
 begin
  if VM^.Count=0 then GetMemDescr:=NULL
		 else
		  begin
		   idx:=0;
		   while idx<VM^.Count do
		    begin
		     if VM^.At(idx)=APoint then
		      begin
		       GetMemdescr:=idx;
		       exit;
		      end;
		     idx:=idx+1;
		    end;
		  end;
  if idx=VM^.Count then GetMemDescr:=NULL;
 end;

procedure TVirtMemory.Free;
 var i:integer;
 begin
  i:=0;
  if VM^.Count=0 then exit;
  for i:=0 to VM^.Count-1 do
   begin
    if VM^.At(i)<>nil then
     if PCompObject(VM^.At(i))^.Kolik=0 then
      begin
       dispose(PCOmpObject(VM^.At(i)),Done);
       VM^.AtPut(i,nil);
      end;
   end;
 end;

function TVirtMemory.Copy:PVirtMemory;
 var B:PVirtMemory;
     i:longint;
     X:PCompObject;
 label KONEC;
 begin
  B:=new(PVirtMemory,Init);
  if VM^.Count=0 then goto KONEC;
  for i:=0 to VM^.Count-1 do
   begin
    if VM^.At(i)<>nil then
     begin
      X:=PCompObject(VM^.At(i))^.Copy(B);
      B^.VM^.Insert(X);
     end              else
      B^.VM^.Insert(nil);
   end;
 KONEC:
  Copy:=B;
 end;

procedure TVirtMemory.Inc(MemDescr:TMemDescr);
 var X:PCompObject;
 begin
  X:=GetPointer(MemDescr);
  if X<>nil then X^.Pridej;
 end;

procedure TVirtMemory.Dec(MemDescr:TMemDescr);
 var X:PCompObject;
 begin
  X:=GetPointer(MemDescr);
  if X<>nil then X^.Uber;
 end;


constructor TWinVMem.Init(AParent:PWindowsObject; VMemory:PVirtMemory);
var  Textik:array [0..100] of char;
     i:longint;
     Text:PChar;
 begin
  inherited Init(AParent,'Virtual memory');
  ListWindow:=new(PListBox,Init(@Self,101,10,10,150,200));
  Listwindow^.Attr.Style:=ListWindow^.Attr.Style and not lbs_sort;
  VirtMem:=VMemory;
 end;

destructor TWinVMem.Done;
 begin
  dispose(ListWindow,Done);
  SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,5,0);
  inherited Done;
 end;

procedure TWinVMem.WMSize(var Msg:TMessage);
 begin
  TWindow.WMSize(Msg);
  with Msg do SetWindowPos(ListWindow^.HWindow,0,10,10,LParamLo-20,LParamHi-20,0);
 end;

 procedure TWinVMem.Seznam(VMem:PVirtMemory);
 var Hodn:record Cislo:word;
		   Typ:word;
		   Sdileni:word;
		 case integer of
		  1:(HLongint:longint);
		  2:(HSingle:real);
		  3:(HWord1,HWord2:word);
		  4:(HPChar:PChar);
		  5:(HBoolean:Boolean);
	  end;
     EditPChar:array [0..100] of char;
     Textik:array [0..100] of char;
     StrPom:string;
     i:word;
     Text:PChar;
 begin
  VirtMem:=VMem;
  ListWindow^.ClearList;
  with VirtMem^ do
  if VM^.Count>0 then
   begin
    for i:=VM^.Count-1 downto 0 do
	     if VM^.At(i)<>nil then
		    begin
		     Hodn.Cislo:=i;
		     Hodn.Typ:=PCompObject(VM^.At(i))^.COTyp;
		     Hodn.sdileni:=PCompObject(VM^.At(i))^.Kolik;
		     Text:=Textik;
		     case Hodn.Typ of
			  sco_NotIdentified:begin { neidentifikovano }
					     WVSPrintF(Text,'%d ... %d ... %d  unknown',Hodn);
					   end;
			  sco_String:begin { string }
				      Hodn.HPChar:=PRet(VM^.At(i))^.Box;
				      WVSPrintF(Text,'%d ... %d ... %d  string = %s',Hodn);
				     end;
			  sco_Substring:begin { substring }
					end;
			  sco_Array:begin { procedura }
				     WVSPrintF(Text,'%d ... %d ... %d  procedure',Hodn);
				    end;
			  sco_Subarray:begin { subarray }
					WVSPrintF(Text,'%d ... %d ... %d  subarray',Hodn);
				       end;
			  sco_Matrix:begin { matrix }
				      WVSPrintF(Text,'%d ... %d ... %d  matrix',Hodn);
				     end;
			  sco_Dictionary:begin { dictionay }
					  WVSPrintF(Text,'%d ... %d ... %d  dictionary',Hodn);
					 end;
			  sco_GraphState:begin { graph state }
					  WVSPrintF(Text,'%d ... %d ... %d  graph state',Hodn);
					 end;
			  sco_GraphPath:begin { matrix }
				      WVSPrintF(Text,'%d ... %d ... %d  graphpath',Hodn);
				     end;
			  sco_Font:begin { matrix }
				     WVSPrintF(Text,'%d ... %d ... %d  font',Hodn);
				   end;
                                sco_File:begin
				  WVSPrintF(Text,'%d ... %d .. %d  file',Hodn);
                                         end;
		      else WVSPrintF(Text,'%d ... %d ... %d',Hodn);
		     end;
		     ListWindow^.AddString(Text);
		    end  else
	       ListWindow^.AddString('nil')
   end
			  else
		    begin
		     StrCopy(Textik,'Virtual memory is empty');
		     Text:=Textik;
		     ListWindow^.AddString(Text);
		    end;
 end;


constructor TRet.Init(VMemory:PVirtMemory;XRet:PChar; RCount:word);
 begin { TRet.Init }
  inherited Init(VMemory);
  COTyp:=sco_String;
  Count:=RCount;
  getmem(Box,Count+1);
  strcopy(Box,XRet);
  Kolik:=0;
  Literal:=true;
 end;  { TRet.Init }

destructor TRet.Done;
 begin
  freemem(Box,Count+1);
 end;

function TRet.Copy(AVMemory:PObject):PCompObject;
 var B:PRet;
 begin
  B:=new(PRet,Init(PVirtMemory(VMem),Box,Count));
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;


constructor TSubRet.Init(VMemory:PVirtMemory;BasicRet:TMemDescr; FirstIndex, CountSub:word);
 begin
  COTyp:=sco_Substring;
  ControlRet:=BasicRet;
  FIndex:=FirstIndex;
  Count:=CountSub;
  Box:=@PRet(PVirtMemory(VMem)^.GetPointer(BasicRet))^.Box[FirstIndex];
  PVirtMemory(VMem)^.Inc(ControlRet);
 end;

destructor TSubRet.Done;
 begin
  PVirtMemory(VMem)^.Dec(ControlRet);
 end;

function TSubRet.StartPoint:pointer;
 begin
  StartPoint:=@PRet(PVirtMemory(VMem)^.GetPointer(ControlRet))^.Box[FIndex];
 end;

constructor TProc.Init(VMemory:PVirtMemory;Pocet:longint);
 var i:longint;
 begin { TProc.Init }
  inherited Init(VMemory);
  COTyp:=sco_Array;
  Count:=Pocet;
  getmem(ProcBox,(Count+1)*sizeof(TPolProc));
  for i:=0 to Count do ProcBox^[i].Typ:=ct_null;
  ProcBox^[0].HLongint:=0;
  Kolik:=0;
  Literal:=false;
 end;  { TProc.Init }


procedure TProc.PlusPrvek(XPrvek:TPolProc);
 begin
  inc(ProcBox^[0].HLongint);
  with ProcBox^[ProcBox^[0].HLongint] do
   begin
    ProcBox^[ProcBox^[0].HLongint]:=XPrvek;
    IncLife(PVirtMemory(VMem),Typ,HPCompObject);
   end;
 end;

procedure TProc.VratPrvek(var Index:longint; var Prvek:TPolProc);
 begin
  { Postupne vybira operandy procedury (odzadu !) }
  Prvek:=ProcBox^[Index];
  dec(Index);
 end;

procedure TProc.Vloz(Index:Longint; Prvek:TPolProc);
 begin
  with ProcBox^[Index] do
   begin
    DecLife(PVirtMemory(VMem),Typ,HPCompObject); { Puvodni prvek }
    ProcBox^[ProcBox^[0].HLongint]:=Prvek;
    IncLife(PVirtMemory(VMem),Typ,HPCompObject); { Novy prvek }
   end;
 end;

procedure TProc.Element(Index:longint; var Prvek:TPolProc);
 begin
  { Pole je vyplovno odzadu - podle vybrn ze zsobnku }
  Prvek:=ProcBox^[Count-Index+1];
 end;


function TProc.Size:longint;
 begin
  Size:=ProcBox^[0].HLongint;
 end;

function TProc.KonecProcedury(Index:longint):bool;
 begin
  KonecProcedury:=(Index=0);
 end;

destructor TProc.Done;
 var i:longint;
 begin
  for i:=1 to Count do with ProcBox^[i] do DecLife(PVirtMemory(VMem),Typ,HPCompObject);
  freemem(ProcBox,Count*sizeof(TPolProc));
 end;

function TProc.Copy(AVMemory:PObject):PCompObject;
 var B:PProc;
 begin
  B:=new(PPRoc,Init(PVirtMemory(AVMemory),Count));
  move(Self.ProcBox^,B^.ProcBox^,(Count+1)*sizeof(TPolProc));
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;

constructor TSubArray.Init(VMemory:PVirtMemory;BasicArray:TMemDescr; FirstIndex, CountSub:word);
 begin
  COTyp:=sco_Subarray;
  BasArray:=BasicArray;
  FIndex:=FirstIndex;
  Count:=CountSub;
  ProcBox:=StartPoint;
  PvirtMemory(VMem)^.Inc(BasArray);
 end;

destructor TSubArray.Done;
 begin
  PVirtMemory(VMem)^.Dec(BasArray);
 end;

function TSubArray.StartPoint:pointer;
 begin
  StartPoint:=@PProc(PVirtMemory(VMem)^.GetPointer(BasArray))^.ProcBox^[FIndex];
 end;


{procedure TRetCollection.Cisti;

 procedure Smaz(Polozka:PRet); far;
  begin
   if Polozka^.Kolik=0 then
    begin
     FreeItem(Polozka);
    end;
  end;

 begin
  ForEach(@Smaz);
 end;
}

procedure IncLife(VMem:PVirtMemory;Typ:byte; Obj:TMemDescr);
 begin
  if (Typ=ct_Name)or(Typ=ct_String)or(Typ=ct_LitName)or(Typ=ct_Proc)or
     (Typ=ct_Dict)or(Typ=ct_File)or(Typ=ct_LoopCyklus)or(Typ=ct_Array)or(Typ=ct_Font)
     or(Typ=ct_Matrix) then VMem^.Inc(Obj);
 end;

procedure DecLife(VMem:PVirtMemory;Typ:byte; Obj:TMemDescr);
 begin
  if (Typ=ct_Name)or(Typ=ct_String)or(Typ=ct_LitName)or(Typ=ct_Proc)or
     (Typ=ct_Dict)or(Typ=ct_File)or(Typ=ct_LoopCyklus)or(Typ=ct_Array)or(Typ=ct_Font)
     or(Typ=ct_Matrix)then if VMem^.GetPointer(Obj)<>nil then VMem^.Dec(Obj);;
 end;

constructor TMatrix.Init(VMemory:PVirtMemory);
begin
 inherited Init(VMemory);
 COTyp:=5;
 XX:=1; XY:=0; XT:=0;
 YX:=0; YY:=1; YT:=0;
end;

destructor TMAtrix.Done;
 begin
  inherited Done;
 end;

function TMatrix.Copy(AVMemory:PObject):PCompObject;
 var B:PMatrix;
 begin
  B:=new(PMatrix,Init(PVirtMemory(AVMemory)));
  with B^ do
   begin
    XX:=Self.XX;
    XY:=Self.XY;
    XT:=Self.XT;
    YX:=Self.YX;
    YY:=Self.YY;
    YT:=Self.YT;
   end;
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;

procedure TMatrix.NewValue(AXX,AXY,AXT,AYX,AYY,AYT:TReal);
 begin
  XX:=AXX; XY:=AXY; XT:=AXT;
  YX:=AYX; YY:=AYY; YT:=AYT;
 end;

procedure TMatrix.Concat(AMat:PMatrix);
 begin
  XX:=XX*AMat^.XX+XY*AMat^.YX;
  XY:=XX*AMat^.XY+XY*AMat^.YY;
  XT:=XX*AMat^.XT+XY*AMat^.YT+XT;
  YX:=YX*AMat^.XX+YY*AMat^.YX;
  YY:=YX*AMat^.XY+YY*AMat^.YY;
  YT:=YX+AMat^.XT+YY*AMat^.YT+YT;
 end;

end.