unit Slovniky;

{ Softwarov emulace postcriptu }
{    Manipulace se slovnky    }
{    Tom Mayer (C) 1993      }

{$X+}
{$undef DEBUG}

interface


uses WinTypes, WinProcs, Objects, OMemory, Strings, ODialogs, OStdDlgs,
     GlobInf, Hodnoty, ObjKomp, Chyby, Lexikal;

type PHodnota=^THodnota;
     THodnota=record
	       case integer of
		0:(Whole:TWhole);
		1:(Uk:TMemDescr);
		2:(Slovo1:word; Slovo2:word);
		3:(HLongint:longint);
		4:(HReal:real);
		5:(HPRet:TMemDescr);
		6:(HPProc:TMemDescr);
		7:(HBoolean:boolean);
		8:(HPFile:TMemDescr);
		9:(HPDict:TMemDescr);
	       10:(HPCompObject:TMemDescr);
              end;

type TPolOld = record  Op:array [0..255] of char; { Polozka pouzita pro generovani vestavenych slovniku }
		       Typ:byte;
		       Hodnota:THodnota;
		end;


     PPolozka = ^TPolozka;        { Struktura zaznamu slovniku }
     TPolozka = record Op:TMemDescr;     { Retezec jmena }
		       Typ:byte;         { Typ hodnoty   }
		       Hodnota:THodnota; { Hodnota }
		end;

var Polozka:TPolozka;


type
     PTabulka = ^TTabulka;
     TTabulka = array [0..65520 div sizeof(PPolozka)] of PPolozka;


     PSlovnik = ^TSlovnik;
     TSlovnik = object(TCompObject)   { Slozeny postscriptovy objekt - def. v unit Retezce }
		       Nazev:array[0..40] of char;
		       Cislo:word;     { Interni cislo slovniku pro primy pristup }
		       Kapacita:word; { Maximalni pocet paru v tabulce }
		       Pocet:word;   { Aktualni pocet paru v tabulce }
		       VelTab:word; { Fyzicka velikost tabulky }
		       Ukaz:PTabulka;
		       constructor Init(VMemory:PVirtMemory;SNazev:PChar;SPocet:word);
		       function GetPair(var Polozka:TPolozka; var Index:word):bool;
		       function PutPair(Polozka:TPolozka):bool;
		       destructor Done; virtual;
		       function Copy(AVMemory:PObject):PCompObject; virtual;
		end;



type PSlovZas=^TSlovZas;
     TSlovZas=object (TObject)
	       VMem:PVirtMemory;
	       SlovZas:array [1..20] of TMemDescr;
	       SlovZasTop,
	       SlovZasAkt,
	       SlovZasSystem,
	       SlovZasUser:byte;
	       InterCislo:word; { Pocitac identifikacnich cisel }
	       constructor Init(VMemory:PVirtMemory);
	       constructor InitCopy(VMemory:PVirtMemory);
	       function Vloz(Slovnik:TMemDescr):bool;
	       function Vyber:bool;
	       function Put(SlovPor:byte;Polozka:TPolozka):bool;
	       function Get(SlovPor:byte; var Polozka:TPolozka; var PolIndex:word):bool;
	       function Find(var Polozka:TPolozka;var SlovPor:word;var PolIndex:word):bool;
	       function StoreDirect(SlovID:word;PolIndex:word;Polozka:TPolozka):bool;
	       function Where(var Polozka:TPolozka; var Slovnik:TMemDescr; var PolIndex:word):bool;
	       destructor Done; virtual;
	       function Copy(VMemory:PVirtMemory):PSlovZas;
	      end;


implementation

{VAR Soubor:TDOSStream; { Soubor s uloenmi prvosly }

var   InterCislo:word;

var   SJmeno:array [0..255] of char;  { BASICNUM.DTA }
      DJmeno:array [0..255] of char;  { SYSTDICT.DTA }
      UJmeno:array [0..255] of char;  { USERDICT.DTA }


{ ******************************************************** }
{ *     Inicializace slovnkovho zsobnku              * }
{ ******************************************************** }


constructor TSlovZas.Init(VMemory:PVirtMemory);

var Soubor:PDOSStream;
    PomPol:TPolOld;
    XB:array [0..255] of char;

 begin
  inherited Init;
  VMem:=VMemory;
  SlovZasSystem:=1;
  SlovZasUser:=2;
  SlovZasTop:=2;
  SlovZasAkt:=2;
  InterCislo:=1;

  VMem^.Alloc(new(PSlovnik,Init(VMem,'SYSTEMDICT',240)),SlovZas[SlovZasSystem]);
  VMem^.Inc(SlovZas[SlovZasSystem]);
  VMem^.Alloc(new(PSlovnik,Init(VMem,'USERDICT',200)),SlovZas[SlovZasUser]);
  VMem^.Inc(SlovZas[SlovZasUser]);

  Soubor:=new(PDOSStream,Init(DJmeno,stOpen));
  while Soubor^.GetPos<>Soubor^.GetSize do
   begin
    Soubor^.Read(PomPol,sizeof(PomPol));
    with Polozka do
     begin
      VMem^.Alloc(new(PRet,Init(PVirtMemory(VMem),PomPol.Op,strlen(PomPol.Op))),Op);
      Typ:=PomPol.Typ;
      Hodnota:=PomPol.Hodnota;
     end;
    Put(1,Polozka);
   end;
  dispose(Soubor,Done);

  Soubor:=new(PDOSStream,Init(UJmeno,stOpen));
  while Soubor^.GetPos<>Soubor^.GetSize do
   begin
    Soubor^.Read(PomPol,sizeof(PomPol));
    with Polozka do
     begin
      VMem^.Alloc(new(PRet,Init(VMem,PomPol.Op,strlen(PomPol.Op))),Op);
      Typ:=PomPol.Typ;
      Hodnota:=PomPol.Hodnota;
     end;
    Put(2,Polozka);
   end;
  dispose(Soubor,Done);
 end;

{ ******************************************************** }
constructor TSlovZas.InitCopy(VMemory:PVirtMemory);
 begin
  inherited Init;
  VMem:=VMemory;
  SlovZasSystem:=1;
  SlovZasUser:=2;
  SlovZasTop:=2;
  SlovZasAkt:=2;
  InterCislo:=1;
 end;

{ ******************************************************** }


function TSlovZas.Copy(VMemory:PVirtMemory):PSlovZas;
 var X:PSlovZas;
 begin
  X:=new(PSlovZas,InitCopy(VMemory));
  X^.SlovZas:=SlovZas;
  X^.SlovZasTop:=SlovZasTop;
  X^.SlovZasAkt:=SlovZasAkt;
  X^.InterCislo:=InterCislo;
  Copy:=X;
 end;


{ ******************************************************** }
{ * Odstrann slovnkovho zsobnku                    * }
{ ******************************************************** }


destructor TSlovZas.Done;
begin
 inherited Done;
 { Tady se provede declife vsech vlozenych slovniku }
 { Slovniky umistene na zasobniku se rusi pri dispose virtualni pameti }
end;

{ ******************************************************** }



{ ******************************************************** }
{ *    Vytvoen novho slovnku na vrcholu zsobnku    * }
{ ******************************************************** }


function TSlovZas.Vloz(Slovnik:TMemDescr):bool;
 begin
  if SlovZasAkt<20 then
   begin
    inc(SlovZasTop);
    inc(SlovZasAkt);
    SlovZas[SlovZasTop]:=Slovnik;
    inclife(VMem,ct_dict,Slovnik);
   end             else begin
                         ErrorHandle^.NewValue('INSERTING TO STACK DICTIONARY',err_dictstackoverflow);
                         Vloz:=false;
                        end;
 end;


{ ******************************************************** }


{ ******************************************************** }
{ *         Uren h0 pro hledani v tabulce              * }
{ ******************************************************** }

function H0(Op:PChar;Max:word):word;
 var i:byte;
     Counter:word;
 begin
  Counter:=0;
  for i:=0 to StrLen(Op)-1 do
   begin
    Counter:=Counter+byte(Op[i]);
    while Counter>=Max do Counter:=Counter-Max;
   end;
  H0:=Counter;
 end;

{ ******************************************************** }




{ ******************************************************** }
{ *          Vloen pru do definic (def)               * }
{ ******************************************************** }

function TSlovZas.Put(SlovPor:byte;Polozka:TPolozka):bool;

 var Index,i:word;
     H,D:word;

 begin
  Put:=PSLovnik(VMem^.GetPointer(SlovZas[SlovPor]))^.PutPair(Polozka);
 end;

{ ******************************************************** }

function TSlovnik.GetPair(var Polozka:TPolozka; var Index:word):bool;

 var I,J:word;

 begin { Function }
      j:=H0(PRet(PVirtMemory(VMem)^.GetPointer(Polozka.Op))^.Box,VelTab);
      i:=0;
      while (Ukaz^[j]<>nil)and(StrComp(PRet(PVirtMemory(VMem)^.GetPointer(Ukaz^[j]^.Op))^.Box,
	  PRet(PVirtMemory(VMem)^.GetPointer(Polozka.Op))^.Box)<>0) do
       begin { while 1 }
        inc(i);
	j:=(j+i*i)mod Veltab;
       end;  { while 1 }
      if Ukaz^[j]=nil  then GetPair:=false
			   else
       begin { else 1 }
        GetPair:=true;
	Polozka:=Ukaz^[j]^;
        Index:=j;
       end;  { else 1 }
 end;  { Function }


{ ******************************************************** }

function TSlovnik.PutPair(Polozka:TPolozka):bool;

 var I,J:word;

 begin { Function }
    PutPair:=false;
    j:=H0(PRet(PVirtMemory(VMem)^.GetPointer(Polozka.Op))^.Box,VelTab);
    i:=0;
    while (Ukaz^[j]<>nil)and(StrComp(PRet(PVirtMemory(VMem)^.GetPointer(Ukaz^[j]^.Op))^.Box,
	  PREt(PVirtMemory(VMem)^.GetPointer(Polozka.Op))^.Box)<>0) do
     begin { while 1 }
      inc(i);
      j:=(j+i*i)mod Veltab;
     end;  { while 1 }
    if Ukaz^[j]=nil then begin
                          if Pocet>=Kapacita then
                           begin
                            ErrorHandle^.NewValue('DICTIONARY STACK',err_dictfull);
                            exit;
                           end;
                          inc(Pocet);
                          getmem(Ukaz^[j],sizeof(TPolozka));
                         end
		else begin { Ukaz^[j] jiz na neco ukazuje, a to bude ze slovniku uvolneno }
                               with Ukaz^[j]^ do
                                        begin
				 DecLife(PVirtMemory(VMem),ct_string,Op);
				 DecLife(PVirtMemory(VMem),Typ,Hodnota.HPCompObject);
				end;
		     end;
    with Polozka do
     begin
      IncLife(PVirtMemory(VMem),ct_string,Op);     { zvyseni poctu zivotu jmena v paru }
      IncLife(PVirtMemory(VMem),Typ,Hodnota.Uk);   { zvyseni poctu zivotu objekktu v paru }
     end;
    Ukaz^[j]^:=Polozka;
    PutPair:=true;
 end;  { Function }


{ ******************************************************** }
{ *      Vyhledn kle v konkrtnm slovnku           * }
{ ******************************************************** }
{ *      Nvratov hodnota funkce uruje zda byl         * }
{ *      opertor v tabulce nalezen:                     * }
{ *      Return = true  -  opertor bezchybn nalezen    * }
{ *      Return = false  -  pi hledn nastala chyba    * }
{ ******************************************************** }

function TSlovZas.Get(SlovPor:byte; var Polozka:TPolozka; var PolIndex:word):bool;

 var Index:longint;
     i:longint;

 begin { Function }
    with PSlovnik(VMem^.GetPointer(SlovZas[SlovPor]))^ do
     begin { with 1 }
      Index:=H0(PRet(Self.VMem^.GetPointer(Polozka.Op))^.Box,VelTab);
      i:=0;
      while (Ukaz^[Index]<>nil)and(StrComp(PRet(Self.VMem^.GetPointer(Ukaz^[Index]^.Op))^.Box,
	    PRet(Self.VMem^.GetPointer(Polozka.Op))^.Box)<>0) do
       begin { while 1 }
	inc(i);
{DEBUG ONLY BEGIN}
      if Index>60000 then
       begin
        MessageBeep($FFFF);
       end;
      if i>sqrt(100000) then
       begin
        MessageBeep($FFFF);
       end;
{DEBUG ONLZ END}
        Index:=(Index+i*i)mod Veltab;
       end;  { while 1 }
      if Ukaz^[Index]=nil  then Get:=false
                           else
       begin { else 1 }
        Get:=true;
	Polozka:=Ukaz^[Index]^;
	PolIndex:=Index;
       end;  { else 1 }
     end;  { with 1 }
 end;  { Function }


{ ******************************************************** }



{ ******************************************************** }
{ *          Vyhledn kle v ad slovnk             * }
{ ******************************************************** }
{ *      Nvratov hodnota funkce uruje zda byl         * }
{ *      opertor ve slovncch nalezen:                 * }
{ *      Return = true  -  opertor bezchybn nalezen    * }
{ *      Return = false  -  pi hledn nastala chyba    * }
{ ******************************************************** }

function TSlovZas.Find(var Polozka:TPolozka;var SlovPor:word;var PolIndex:word):bool;

 var j:word;

 begin { Function }
  j:=SlovZasTop;
  while (j<>0) and not(Get(j,Polozka,PolIndex)) do
   begin { while 1 }
    dec(j);
   end;  { while 1 }
  if j=0 then Find:=false
         else begin
	       Find:=true;
	       SlovPor:=PSlovnik(VMem^.GetPointer(SlovZas[j]))^.Cislo
	      end;
 end;  { Function }

{ ******************************************************** }

function TSlovZas.Where(var Polozka:TPolozka; var Slovnik:TMemDescr; var PolIndex:word):bool;

 var j:word;

 begin { Function }
  j:=SlovZasTop;
  while (j<>0) and not(Get(j,Polozka,PolIndex)) do
   begin { while 1 }
    dec(j);
   end;  { while 1 }
  if j=0 then Where:=false
	 else begin
               Where:=true;
	       Slovnik:=SlovZas[j];
	      end;
 end;  { Function }

{ ******************************************************** }
{ *    Vyjmut slovnku ze slovnkovho zsobnku        * }
{ ******************************************************** }

function TSlovZas.Vyber:bool;
 begin
  if SlovZasTop<>SlovZasUser then
   begin
    DecLife(VMem,ct_dict,SlovZas[SlovZasTop]);
    dec(SlovZasTop);
    dec(SlovZasAkt);
   end 		         else
   begin
    ErrorHandle^.NewValue('',err_dictstackunderflow);
   end;
 end;

{ ******************************************************** }




{ ******************************************************** }
{ *          Pm uloen hodnoty                       * }
{ ******************************************************** }
{ *      SlovID - identifikan slo slovnku           * }
{ *      pidlen pi jeho vytvoen                    * }
{ *      Nvratov hodnota funkce uruje zda byla        * }
{ *      hodnota nalezena:                               * }
{ *      Return = true  -  hodnota bezchybn nalezen     * }
{ *      Return = false  -  pi hledn nastala chyba    * }
{ ******************************************************** }

function TSlovZas.StoreDirect(SlovID:word;PolIndex:word;Polozka:TPolozka):bool;

 var j:word;

 begin { Function }
  j:=SlovZasTop;
  while (j<>0)and(PSlovnik(VMem^.GetPointer(SlovZas[j]))^.Cislo<>SlovID) do
   begin { while 1 }
    dec(j);
   end;  { while 1 }
  if j=0 then StoreDirect:=false
         else begin
	       StoreDirect:=true;
	       with PSLovnik(VMem^.GetPointer(SlovZas[j]))^.Ukaz^[PolIndex]^ do
                begin
		 DecLife(VMem,ct_string,Op);
		 DecLife(VMem,Typ,Hodnota.HPCompObject);
		end;
	       PSlovnik(VMem^.GetPointer(SlovZas[j]))^.Ukaz^[PolIndex]^:=Polozka;
	       with PSlovnik(VMem^.GetPointer(SlovZas[j]))^.Ukaz^[PolIndex]^ do
		begin
		 IncLife(VMem,ct_string,Op);
		 IncLife(VMem,Typ,Hodnota.HPCompObject);
                end;
              end;
 end;  { Function }

{ ******************************************************** }


{ ******************************************************** }
{ *           Uren velikosti tabulky                   * }
{ ******************************************************** }

function Velikost(Pocet:word):word;

var Zac,Kon,Pozice:longint;
    Cislo:word;
    Soubor:PDOSStream;

 begin
  if Pocet>400 then Pocet:=Pocet+Pocet div 10
               else Pocet:=Pocet+40;
  new(Soubor,Init(SJmeno,StOpenRead)); { oteven souboru s prvosly }
  Zac:=0;                       { metoda puleni intervalu }
  Kon:=(Soubor^.GetSize div 2)-1;
 repeat
  Pozice:=(Zac*2+Kon*2) div 4;
  Soubor^.Seek(Pozice*2);
  Soubor^.Read(Cislo,sizeof(Cislo));
  if Pocet>=Cislo then Zac:=Pozice+1;
  if Pocet<=Cislo then Kon:=Pozice-1;
 until Zac>Kon;
 if (Zac-Kon>1)then
                begin { if 1 }
                 Velikost:=Cislo;
	      end   { if 1 }
	   else begin { else 1 }
                 Soubor^.Seek(Zac*2);
	       Soubor^.Read(Cislo,sizeof(Cislo));
	       Velikost:=Cislo;
                end;  { else 1 }
  dispose(Soubor,Done);
 end;

{ ******************************************************** }



{ ******************************************************** }
{ *          Vytvoen slovnku v pamti                 * }
{ ******************************************************** }

constructor TSlovnik.Init(VMemory:PVirtMemory; SNazev:PChar;SPocet:word);
 var Vel:word;
     i:word;
 begin
{$ifdef DEBUG}
  MessageBox(0,'TSlovnik.Init','DEBUG',mb_Ok);
{$endif}
  inherited Init(VMemory);
  COTyp:=sco_Dictionary;
  Vel:=Velikost(SPocet);
  strcopy(Nazev,SNazev);{new(PRet,Init(SNazev,strlen(SNazev)));}
  Cislo:=InterCislo;
  Kolik:=0;             {Pocet zivotu - pri ukladani na zasobnik se zvetsuje  }
			{             - pri vybirani zmensuje, pokud je 0,    }
  inc(InterCislo);
  Kapacita:=SPocet;
  VelTab:=Vel;
  Pocet:=0;
  GetMem(Ukaz,VelTab*sizeof(PPolozka));
  for i:=0 to VelTab-1 do Ukaz^[i]:=nil;
 end;

{ ******************************************************** }

destructor TSlovnik.Done;
 var i:longint;
 begin { TSLovnik.Done }
{$ifdef DEBUG}
 MessageBox(0,'TSlovnik.Done','DEBUG',mb_Ok);
{$endif}
  for i:=0 to VelTab-1 do { Uvoleni paru ze slovniku }
   begin { for 1 }
    if Ukaz^[i]<>nil then with Ukaz^[i]^ do
                           begin { with 1 }
			    DecLife(PVirtMemory(VMem),ct_string,Op);
			    DecLife(PVirtMemory(VMem),Typ,Hodnota.HPCompObject);
			   end;  { with 1 }
   end;  { for 1 }
  FreeMem(Ukaz,VelTab*sizeof(PPolozka));
 end;  { TSlovnik.Done }

function TSlovnik.Copy(AVMemory:PObject):PCompObject;
 var B:PSlovnik;
     i:word;
 begin { TSlovnik.Copy }
  B:=new(PSlovnik,Init(PVirtMemory(AVMemory),Nazev,Kapacita));
  for i:=0 to VelTab-1 do
   begin
    if Ukaz^[i]<>nil then
     begin
      getmem(B^.Ukaz^[i],sizeof(TPolozka));
      B^.UKaz^[i]^:=Ukaz^[i]^;
     end;
   end;
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;  { TSlovnik.Copy }


begin
 strcopy(SJmeno,WorkDir);
 strcat(SJmeno,'\BASICNUM.DTA');
 strcopy(DJmeno,WorkDir);
 strcat(DJmeno,'\SYSTDICT.DTA');
 strcopy(UJmeno,WorkDir);
 strcat(UJmeno,'\USERDICT.DTA');
end.